/* A Bison parser, made by GNU Bison 3.7.3.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.7.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = Display::value_to_lily_string (value);		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)

#line 103 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>
using namespace std;

#include "book.hh"
#include "context.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "ly-module.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"
#include "lily-imports.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const string &s)
{
	parser->parser_error (*i, s);
}

// The following are somewhat precarious constructs as they may change
// the value of the lookahead token.  That implies that the lookahead
// token must not yet have made an impact on the state stack other
// than causing the reduction of the current rule, or switching the
// lookahead token while Bison is mulling it over will cause trouble.

#define MYBACKUP(Token, Value, Location)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		if (Token)						\
			parser->lexer_->push_extra_token		\
				(Location, Token, Value);		\
		parser->lexer_->push_extra_token (Location, BACKUP);	\
		yychar = YYEMPTY;					\
	} while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token			\
			(Location, REPARSE, Pred);			\
		yychar = YYEMPTY;					\
	} while (0)

#line 184 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- delay application of the function
*/

#define LOWLEVEL_MAKE_SYNTAX(location, proc, ...)			\
	with_location							\
		(parser->lexer_->override_input (location).smobbed_copy (), \
		 proc,							\
		 ##__VA_ARGS__)

/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (location, Syntax::name, ##__VA_ARGS__)

#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (Syntax::name, ##__VA_ARGS__, SCM_UNDEFINED)

#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX						\
		(location,						\
		 Guile_user::apply,					\
		 scm_car (start),					\
		 scm_append_x						\
		 (scm_list_2 (scm_cdr (start),				\
			      scm_list_n (__VA_ARGS__, SCM_UNDEFINED))))

SCM get_next_unique_context_id ();
SCM get_next_unique_lyrics_context_id ();

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif


static Music *make_music_with_input (SCM name, Input where);
bool add_post_events (Music *music, SCM events);
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0, SCM factor = SCM_UNDEFINED);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM make_reverse_key_list (SCM keys);
SCM try_word_variants (SCM pred, SCM str);
SCM try_string_variants (SCM pred, SCM str);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


#line 234 "./out/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of input"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_PREC_BOT = 3,                   /* PREC_BOT  */
  YYSYMBOL_COMPOSITE = 4,                  /* COMPOSITE  */
  YYSYMBOL_5_ = 5,                         /* ':'  */
  YYSYMBOL_6_ = 6,                         /* '^'  */
  YYSYMBOL_7___ = 7,                       /* '_'  */
  YYSYMBOL_8_ = 8,                         /* '!'  */
  YYSYMBOL_9_ = 9,                         /* '\''  */
  YYSYMBOL_10_ = 10,                       /* ','  */
  YYSYMBOL_PREC_TOP = 11,                  /* PREC_TOP  */
  YYSYMBOL_ACCEPTS = 12,                   /* "\\accepts"  */
  YYSYMBOL_ADDLYRICS = 13,                 /* "\\addlyrics"  */
  YYSYMBOL_ALIAS = 14,                     /* "\\alias"  */
  YYSYMBOL_ALTERNATIVE = 15,               /* "\\alternative"  */
  YYSYMBOL_BOOK = 16,                      /* "\\book"  */
  YYSYMBOL_BOOKPART = 17,                  /* "\\bookpart"  */
  YYSYMBOL_CHANGE = 18,                    /* "\\change"  */
  YYSYMBOL_CHORDMODE = 19,                 /* "\\chordmode"  */
  YYSYMBOL_CHORDS = 20,                    /* "\\chords"  */
  YYSYMBOL_CONSISTS = 21,                  /* "\\consists"  */
  YYSYMBOL_CONTEXT = 22,                   /* "\\context"  */
  YYSYMBOL_DEFAULT = 23,                   /* "\\default"  */
  YYSYMBOL_DEFAULTCHILD = 24,              /* "\\defaultchild"  */
  YYSYMBOL_DENIES = 25,                    /* "\\denies"  */
  YYSYMBOL_DESCRIPTION = 26,               /* "\\description"  */
  YYSYMBOL_DRUMMODE = 27,                  /* "\\drummode"  */
  YYSYMBOL_DRUMS = 28,                     /* "\\drums"  */
  YYSYMBOL_ETC = 29,                       /* "\\etc"  */
  YYSYMBOL_FIGUREMODE = 30,                /* "\\figuremode"  */
  YYSYMBOL_FIGURES = 31,                   /* "\\figures"  */
  YYSYMBOL_HEADER = 32,                    /* "\\header"  */
  YYSYMBOL_INVALID = 33,                   /* "\\version-error"  */
  YYSYMBOL_LAYOUT = 34,                    /* "\\layout"  */
  YYSYMBOL_LYRICMODE = 35,                 /* "\\lyricmode"  */
  YYSYMBOL_LYRICS = 36,                    /* "\\lyrics"  */
  YYSYMBOL_LYRICSTO = 37,                  /* "\\lyricsto"  */
  YYSYMBOL_MARKUP = 38,                    /* "\\markup"  */
  YYSYMBOL_MARKUPLIST = 39,                /* "\\markuplist"  */
  YYSYMBOL_MIDI = 40,                      /* "\\midi"  */
  YYSYMBOL_NAME = 41,                      /* "\\name"  */
  YYSYMBOL_NOTEMODE = 42,                  /* "\\notemode"  */
  YYSYMBOL_OVERRIDE = 43,                  /* "\\override"  */
  YYSYMBOL_PAPER = 44,                     /* "\\paper"  */
  YYSYMBOL_REMOVE = 45,                    /* "\\remove"  */
  YYSYMBOL_REPEAT = 46,                    /* "\\repeat"  */
  YYSYMBOL_REST = 47,                      /* "\\rest"  */
  YYSYMBOL_REVERT = 48,                    /* "\\revert"  */
  YYSYMBOL_SCORE = 49,                     /* "\\score"  */
  YYSYMBOL_SCORELINES = 50,                /* "\\score-lines"  */
  YYSYMBOL_SEQUENTIAL = 51,                /* "\\sequential"  */
  YYSYMBOL_SET = 52,                       /* "\\set"  */
  YYSYMBOL_SIMULTANEOUS = 53,              /* "\\simultaneous"  */
  YYSYMBOL_TEMPO = 54,                     /* "\\tempo"  */
  YYSYMBOL_TYPE = 55,                      /* "\\type"  */
  YYSYMBOL_UNSET = 56,                     /* "\\unset"  */
  YYSYMBOL_WITH = 57,                      /* "\\with"  */
  YYSYMBOL_NEWCONTEXT = 58,                /* "\\new"  */
  YYSYMBOL_CHORD_BASS = 59,                /* "/+"  */
  YYSYMBOL_CHORD_CARET = 60,               /* "^"  */
  YYSYMBOL_CHORD_COLON = 61,               /* ":"  */
  YYSYMBOL_CHORD_MINUS = 62,               /* "-"  */
  YYSYMBOL_CHORD_SLASH = 63,               /* "/"  */
  YYSYMBOL_ANGLE_OPEN = 64,                /* "<"  */
  YYSYMBOL_ANGLE_CLOSE = 65,               /* ">"  */
  YYSYMBOL_DOUBLE_ANGLE_OPEN = 66,         /* "<<"  */
  YYSYMBOL_DOUBLE_ANGLE_CLOSE = 67,        /* ">>"  */
  YYSYMBOL_E_BACKSLASH = 68,               /* "\\\\"  */
  YYSYMBOL_E_EXCLAMATION = 69,             /* "\\!"  */
  YYSYMBOL_E_PLUS = 70,                    /* "\\+"  */
  YYSYMBOL_EXTENDER = 71,                  /* "__"  */
  YYSYMBOL_FIGURE_CLOSE = 72,              /* FIGURE_CLOSE  */
  YYSYMBOL_FIGURE_OPEN = 73,               /* FIGURE_OPEN  */
  YYSYMBOL_FIGURE_SPACE = 74,              /* "_"  */
  YYSYMBOL_HYPHEN = 75,                    /* "--"  */
  YYSYMBOL_MULTI_MEASURE_REST = 76,        /* MULTI_MEASURE_REST  */
  YYSYMBOL_E_UNSIGNED = 77,                /* E_UNSIGNED  */
  YYSYMBOL_UNSIGNED = 78,                  /* UNSIGNED  */
  YYSYMBOL_EXPECT_MARKUP = 79,             /* "markup?"  */
  YYSYMBOL_EXPECT_SCM = 80,                /* "scheme?"  */
  YYSYMBOL_BACKUP = 81,                    /* "(backed-up?)"  */
  YYSYMBOL_REPARSE = 82,                   /* "(reparsed?)"  */
  YYSYMBOL_EXPECT_MARKUP_LIST = 83,        /* "markup-list?"  */
  YYSYMBOL_EXPECT_OPTIONAL = 84,           /* "optional?"  */
  YYSYMBOL_EXPECT_NO_MORE_ARGS = 85,       /* EXPECT_NO_MORE_ARGS  */
  YYSYMBOL_EMBEDDED_LILY = 86,             /* "#{"  */
  YYSYMBOL_BOOK_IDENTIFIER = 87,           /* BOOK_IDENTIFIER  */
  YYSYMBOL_CHORD_MODIFIER = 88,            /* CHORD_MODIFIER  */
  YYSYMBOL_CHORD_REPETITION = 89,          /* CHORD_REPETITION  */
  YYSYMBOL_DRUM_PITCH = 90,                /* DRUM_PITCH  */
  YYSYMBOL_DURATION_ARG = 91,              /* DURATION_ARG  */
  YYSYMBOL_DURATION_IDENTIFIER = 92,       /* DURATION_IDENTIFIER  */
  YYSYMBOL_EVENT_IDENTIFIER = 93,          /* EVENT_IDENTIFIER  */
  YYSYMBOL_EVENT_FUNCTION = 94,            /* EVENT_FUNCTION  */
  YYSYMBOL_FRACTION = 95,                  /* FRACTION  */
  YYSYMBOL_LOOKUP_IDENTIFIER = 96,         /* LOOKUP_IDENTIFIER  */
  YYSYMBOL_LYRIC_ELEMENT = 97,             /* LYRIC_ELEMENT  */
  YYSYMBOL_MARKUP_FUNCTION = 98,           /* MARKUP_FUNCTION  */
  YYSYMBOL_MARKUP_LIST_FUNCTION = 99,      /* MARKUP_LIST_FUNCTION  */
  YYSYMBOL_MARKUP_IDENTIFIER = 100,        /* MARKUP_IDENTIFIER  */
  YYSYMBOL_MARKUPLIST_IDENTIFIER = 101,    /* MARKUPLIST_IDENTIFIER  */
  YYSYMBOL_MUSIC_FUNCTION = 102,           /* MUSIC_FUNCTION  */
  YYSYMBOL_MUSIC_IDENTIFIER = 103,         /* MUSIC_IDENTIFIER  */
  YYSYMBOL_NOTENAME_PITCH = 104,           /* NOTENAME_PITCH  */
  YYSYMBOL_NUMBER_IDENTIFIER = 105,        /* NUMBER_IDENTIFIER  */
  YYSYMBOL_PITCH_IDENTIFIER = 106,         /* PITCH_IDENTIFIER  */
  YYSYMBOL_REAL = 107,                     /* REAL  */
  YYSYMBOL_RESTNAME = 108,                 /* RESTNAME  */
  YYSYMBOL_SCM_ARG = 109,                  /* SCM_ARG  */
  YYSYMBOL_SCM_FUNCTION = 110,             /* SCM_FUNCTION  */
  YYSYMBOL_SCM_IDENTIFIER = 111,           /* SCM_IDENTIFIER  */
  YYSYMBOL_SCM_TOKEN = 112,                /* SCM_TOKEN  */
  YYSYMBOL_STRING = 113,                   /* STRING  */
  YYSYMBOL_SYMBOL_LIST = 114,              /* SYMBOL_LIST  */
  YYSYMBOL_TONICNAME_PITCH = 115,          /* TONICNAME_PITCH  */
  YYSYMBOL_SYMBOL = 116,                   /* SYMBOL  */
  YYSYMBOL_117_ = 117,                     /* '-'  */
  YYSYMBOL_118_ = 118,                     /* '+'  */
  YYSYMBOL_UNARY_MINUS = 119,              /* UNARY_MINUS  */
  YYSYMBOL_120_ = 120,                     /* '.'  */
  YYSYMBOL_121_ = 121,                     /* '{'  */
  YYSYMBOL_122_ = 122,                     /* '}'  */
  YYSYMBOL_123_ = 123,                     /* '='  */
  YYSYMBOL_124_ = 124,                     /* '*'  */
  YYSYMBOL_125_ = 125,                     /* ']'  */
  YYSYMBOL_126_ = 126,                     /* '/'  */
  YYSYMBOL_127_ = 127,                     /* '['  */
  YYSYMBOL_128_ = 128,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 129,                 /* $accept  */
  YYSYMBOL_start_symbol = 130,             /* start_symbol  */
  YYSYMBOL_131_1 = 131,                    /* $@1  */
  YYSYMBOL_lilypond = 132,                 /* lilypond  */
  YYSYMBOL_toplevel_expression = 133,      /* toplevel_expression  */
  YYSYMBOL_lookup = 134,                   /* lookup  */
  YYSYMBOL_embedded_scm_bare = 135,        /* embedded_scm_bare  */
  YYSYMBOL_embedded_scm_active = 136,      /* embedded_scm_active  */
  YYSYMBOL_embedded_scm_bare_arg = 137,    /* embedded_scm_bare_arg  */
  YYSYMBOL_embedded_scm = 138,             /* embedded_scm  */
  YYSYMBOL_embedded_scm_arg = 139,         /* embedded_scm_arg  */
  YYSYMBOL_scm_function_call = 140,        /* scm_function_call  */
  YYSYMBOL_embedded_lilypond_number = 141, /* embedded_lilypond_number  */
  YYSYMBOL_embedded_lilypond = 142,        /* embedded_lilypond  */
  YYSYMBOL_lilypond_header_body = 143,     /* lilypond_header_body  */
  YYSYMBOL_lilypond_header = 144,          /* lilypond_header  */
  YYSYMBOL_header_block = 145,             /* header_block  */
  YYSYMBOL_146_2 = 146,                    /* $@2  */
  YYSYMBOL_assignment_id = 147,            /* assignment_id  */
  YYSYMBOL_assignment = 148,               /* assignment  */
  YYSYMBOL_identifier_init = 149,          /* identifier_init  */
  YYSYMBOL_identifier_init_nonumber = 150, /* identifier_init_nonumber  */
  YYSYMBOL_partial_function_scriptable = 151, /* partial_function_scriptable  */
  YYSYMBOL_partial_function = 152,         /* partial_function  */
  YYSYMBOL_context_def_spec_block = 153,   /* context_def_spec_block  */
  YYSYMBOL_context_mod_arg = 154,          /* context_mod_arg  */
  YYSYMBOL_155_3 = 155,                    /* $@3  */
  YYSYMBOL_context_def_spec_body = 156,    /* context_def_spec_body  */
  YYSYMBOL_book_block = 157,               /* book_block  */
  YYSYMBOL_book_body = 158,                /* book_body  */
  YYSYMBOL_159_4 = 159,                    /* $@4  */
  YYSYMBOL_bookpart_block = 160,           /* bookpart_block  */
  YYSYMBOL_bookpart_body = 161,            /* bookpart_body  */
  YYSYMBOL_162_5 = 162,                    /* $@5  */
  YYSYMBOL_score_block = 163,              /* score_block  */
  YYSYMBOL_score_body = 164,               /* score_body  */
  YYSYMBOL_score_item = 165,               /* score_item  */
  YYSYMBOL_score_items = 166,              /* score_items  */
  YYSYMBOL_167_6 = 167,                    /* $@6  */
  YYSYMBOL_paper_block = 168,              /* paper_block  */
  YYSYMBOL_output_def = 169,               /* output_def  */
  YYSYMBOL_output_def_head = 170,          /* output_def_head  */
  YYSYMBOL_output_def_head_with_mode_switch = 171, /* output_def_head_with_mode_switch  */
  YYSYMBOL_music_or_context_def = 172,     /* music_or_context_def  */
  YYSYMBOL_output_def_body = 173,          /* output_def_body  */
  YYSYMBOL_174_7 = 174,                    /* $@7  */
  YYSYMBOL_tempo_event = 175,              /* tempo_event  */
  YYSYMBOL_music_list = 176,               /* music_list  */
  YYSYMBOL_braced_music_list = 177,        /* braced_music_list  */
  YYSYMBOL_music = 178,                    /* music  */
  YYSYMBOL_pitch_as_music = 179,           /* pitch_as_music  */
  YYSYMBOL_music_embedded = 180,           /* music_embedded  */
  YYSYMBOL_music_embedded_backup = 181,    /* music_embedded_backup  */
  YYSYMBOL_music_assign = 182,             /* music_assign  */
  YYSYMBOL_repeated_music = 183,           /* repeated_music  */
  YYSYMBOL_sequential_music = 184,         /* sequential_music  */
  YYSYMBOL_simultaneous_music = 185,       /* simultaneous_music  */
  YYSYMBOL_simple_music = 186,             /* simple_music  */
  YYSYMBOL_context_modification = 187,     /* context_modification  */
  YYSYMBOL_188_8 = 188,                    /* $@8  */
  YYSYMBOL_context_modification_arg = 189, /* context_modification_arg  */
  YYSYMBOL_optional_context_mods = 190,    /* optional_context_mods  */
  YYSYMBOL_context_modification_mods_list = 191, /* context_modification_mods_list  */
  YYSYMBOL_context_mod_list = 192,         /* context_mod_list  */
  YYSYMBOL_context_prefix = 193,           /* context_prefix  */
  YYSYMBOL_new_lyrics = 194,               /* new_lyrics  */
  YYSYMBOL_basic_music = 195,              /* basic_music  */
  YYSYMBOL_contextable_music = 196,        /* contextable_music  */
  YYSYMBOL_contexted_basic_music = 197,    /* contexted_basic_music  */
  YYSYMBOL_composite_music = 198,          /* composite_music  */
  YYSYMBOL_music_bare = 199,               /* music_bare  */
  YYSYMBOL_grouped_music_list = 200,       /* grouped_music_list  */
  YYSYMBOL_symbol_list_arg = 201,          /* symbol_list_arg  */
  YYSYMBOL_symbol_list_rev = 202,          /* symbol_list_rev  */
  YYSYMBOL_symbol_list_part = 203,         /* symbol_list_part  */
  YYSYMBOL_symbol_list_element = 204,      /* symbol_list_element  */
  YYSYMBOL_symbol_list_part_bare = 205,    /* symbol_list_part_bare  */
  YYSYMBOL_function_arglist_nonbackup = 206, /* function_arglist_nonbackup  */
  YYSYMBOL_reparsed_rhythm = 207,          /* reparsed_rhythm  */
  YYSYMBOL_function_arglist_nonbackup_reparse = 208, /* function_arglist_nonbackup_reparse  */
  YYSYMBOL_function_arglist_backup = 209,  /* function_arglist_backup  */
  YYSYMBOL_function_arglist = 210,         /* function_arglist  */
  YYSYMBOL_function_arglist_skip_nonbackup = 211, /* function_arglist_skip_nonbackup  */
  YYSYMBOL_function_arglist_partial = 212, /* function_arglist_partial  */
  YYSYMBOL_function_arglist_partial_optional = 213, /* function_arglist_partial_optional  */
  YYSYMBOL_function_arglist_common = 214,  /* function_arglist_common  */
  YYSYMBOL_function_arglist_common_reparse = 215, /* function_arglist_common_reparse  */
  YYSYMBOL_function_arglist_optional = 216, /* function_arglist_optional  */
  YYSYMBOL_function_arglist_skip_backup = 217, /* function_arglist_skip_backup  */
  YYSYMBOL_music_function_call = 218,      /* music_function_call  */
  YYSYMBOL_optional_id = 219,              /* optional_id  */
  YYSYMBOL_lyric_mode_music = 220,         /* lyric_mode_music  */
  YYSYMBOL_221_9 = 221,                    /* $@9  */
  YYSYMBOL_mode_changed_music = 222,       /* mode_changed_music  */
  YYSYMBOL_mode_changing_head = 223,       /* mode_changing_head  */
  YYSYMBOL_mode_changing_head_with_context = 224, /* mode_changing_head_with_context  */
  YYSYMBOL_context_change = 225,           /* context_change  */
  YYSYMBOL_property_path = 226,            /* property_path  */
  YYSYMBOL_property_operation = 227,       /* property_operation  */
  YYSYMBOL_revert_arg = 228,               /* revert_arg  */
  YYSYMBOL_revert_arg_backup = 229,        /* revert_arg_backup  */
  YYSYMBOL_revert_arg_part = 230,          /* revert_arg_part  */
  YYSYMBOL_context_def_mod = 231,          /* context_def_mod  */
  YYSYMBOL_context_mod = 232,              /* context_mod  */
  YYSYMBOL_grob_prop_spec = 233,           /* grob_prop_spec  */
  YYSYMBOL_grob_prop_path = 234,           /* grob_prop_path  */
  YYSYMBOL_context_prop_spec = 235,        /* context_prop_spec  */
  YYSYMBOL_simple_revert_context = 236,    /* simple_revert_context  */
  YYSYMBOL_music_property_def = 237,       /* music_property_def  */
  YYSYMBOL_string = 238,                   /* string  */
  YYSYMBOL_text = 239,                     /* text  */
  YYSYMBOL_simple_string = 240,            /* simple_string  */
  YYSYMBOL_symbol = 241,                   /* symbol  */
  YYSYMBOL_scalar = 242,                   /* scalar  */
  YYSYMBOL_event_chord = 243,              /* event_chord  */
  YYSYMBOL_note_chord_element = 244,       /* note_chord_element  */
  YYSYMBOL_chord_body = 245,               /* chord_body  */
  YYSYMBOL_chord_body_elements = 246,      /* chord_body_elements  */
  YYSYMBOL_chord_body_element = 247,       /* chord_body_element  */
  YYSYMBOL_music_function_chord_body = 248, /* music_function_chord_body  */
  YYSYMBOL_event_function_event = 249,     /* event_function_event  */
  YYSYMBOL_post_events = 250,              /* post_events  */
  YYSYMBOL_post_event_nofinger = 251,      /* post_event_nofinger  */
  YYSYMBOL_post_event = 252,               /* post_event  */
  YYSYMBOL_string_number_event = 253,      /* string_number_event  */
  YYSYMBOL_direction_less_event = 254,     /* direction_less_event  */
  YYSYMBOL_direction_reqd_event = 255,     /* direction_reqd_event  */
  YYSYMBOL_octave_check = 256,             /* octave_check  */
  YYSYMBOL_quotes = 257,                   /* quotes  */
  YYSYMBOL_erroneous_quotes = 258,         /* erroneous_quotes  */
  YYSYMBOL_sup_quotes = 259,               /* sup_quotes  */
  YYSYMBOL_sub_quotes = 260,               /* sub_quotes  */
  YYSYMBOL_steno_pitch = 261,              /* steno_pitch  */
  YYSYMBOL_steno_tonic_pitch = 262,        /* steno_tonic_pitch  */
  YYSYMBOL_pitch = 263,                    /* pitch  */
  YYSYMBOL_pitch_or_tonic_pitch = 264,     /* pitch_or_tonic_pitch  */
  YYSYMBOL_gen_text_def = 265,             /* gen_text_def  */
  YYSYMBOL_fingering = 266,                /* fingering  */
  YYSYMBOL_script_abbreviation = 267,      /* script_abbreviation  */
  YYSYMBOL_script_dir = 268,               /* script_dir  */
  YYSYMBOL_maybe_notemode_duration = 269,  /* maybe_notemode_duration  */
  YYSYMBOL_optional_notemode_duration = 270, /* optional_notemode_duration  */
  YYSYMBOL_steno_duration = 271,           /* steno_duration  */
  YYSYMBOL_multiplied_duration = 272,      /* multiplied_duration  */
  YYSYMBOL_dots = 273,                     /* dots  */
  YYSYMBOL_multipliers = 274,              /* multipliers  */
  YYSYMBOL_tremolo_type = 275,             /* tremolo_type  */
  YYSYMBOL_bass_number = 276,              /* bass_number  */
  YYSYMBOL_figured_bass_alteration = 277,  /* figured_bass_alteration  */
  YYSYMBOL_bass_figure = 278,              /* bass_figure  */
  YYSYMBOL_figured_bass_modification = 279, /* figured_bass_modification  */
  YYSYMBOL_br_bass_figure = 280,           /* br_bass_figure  */
  YYSYMBOL_figure_list = 281,              /* figure_list  */
  YYSYMBOL_optional_rest = 282,            /* optional_rest  */
  YYSYMBOL_pitch_or_music = 283,           /* pitch_or_music  */
  YYSYMBOL_simple_element = 284,           /* simple_element  */
  YYSYMBOL_lyric_element = 285,            /* lyric_element  */
  YYSYMBOL_lyric_element_music = 286,      /* lyric_element_music  */
  YYSYMBOL_new_chord = 287,                /* new_chord  */
  YYSYMBOL_chord_items = 288,              /* chord_items  */
  YYSYMBOL_chord_separator = 289,          /* chord_separator  */
  YYSYMBOL_chord_item = 290,               /* chord_item  */
  YYSYMBOL_step_numbers = 291,             /* step_numbers  */
  YYSYMBOL_step_number = 292,              /* step_number  */
  YYSYMBOL_tempo_range = 293,              /* tempo_range  */
  YYSYMBOL_number_expression = 294,        /* number_expression  */
  YYSYMBOL_number_term = 295,              /* number_term  */
  YYSYMBOL_number_factor = 296,            /* number_factor  */
  YYSYMBOL_bare_number_common = 297,       /* bare_number_common  */
  YYSYMBOL_bare_number = 298,              /* bare_number  */
  YYSYMBOL_unsigned_number = 299,          /* unsigned_number  */
  YYSYMBOL_exclamations = 300,             /* exclamations  */
  YYSYMBOL_questions = 301,                /* questions  */
  YYSYMBOL_full_markup_list = 302,         /* full_markup_list  */
  YYSYMBOL_303_10 = 303,                   /* $@10  */
  YYSYMBOL_markup_mode = 304,              /* markup_mode  */
  YYSYMBOL_markup_mode_word = 305,         /* markup_mode_word  */
  YYSYMBOL_full_markup = 306,              /* full_markup  */
  YYSYMBOL_partial_markup = 307,           /* partial_markup  */
  YYSYMBOL_markup_top = 308,               /* markup_top  */
  YYSYMBOL_markup_scm = 309,               /* markup_scm  */
  YYSYMBOL_310_11 = 310,                   /* $@11  */
  YYSYMBOL_markup_list = 311,              /* markup_list  */
  YYSYMBOL_markup_uncomposed_list = 312,   /* markup_uncomposed_list  */
  YYSYMBOL_313_12 = 313,                   /* $@12  */
  YYSYMBOL_markup_composed_list = 314,     /* markup_composed_list  */
  YYSYMBOL_markup_braced_list = 315,       /* markup_braced_list  */
  YYSYMBOL_markup_braced_list_body = 316,  /* markup_braced_list_body  */
  YYSYMBOL_markup_command_list = 317,      /* markup_command_list  */
  YYSYMBOL_markup_command_basic_arguments = 318, /* markup_command_basic_arguments  */
  YYSYMBOL_markup_command_list_arguments = 319, /* markup_command_list_arguments  */
  YYSYMBOL_markup_partial_function = 320,  /* markup_partial_function  */
  YYSYMBOL_markup_arglist_partial = 321,   /* markup_arglist_partial  */
  YYSYMBOL_markup_head_1_item = 322,       /* markup_head_1_item  */
  YYSYMBOL_markup_head_1_list = 323,       /* markup_head_1_list  */
  YYSYMBOL_markup_word = 324,              /* markup_word  */
  YYSYMBOL_simple_markup = 325,            /* simple_markup  */
  YYSYMBOL_simple_markup_noword = 326,     /* simple_markup_noword  */
  YYSYMBOL_327_13 = 327,                   /* $@13  */
  YYSYMBOL_markup = 328                    /* markup  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4266

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  200
/* YYNRULES -- Number of rules.  */
#define YYNRULES  599
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  888

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     8,     2,     2,     2,     2,     2,     9,
       2,     2,   124,   118,    10,   117,   120,   126,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     5,     2,
       2,   123,     2,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   127,     2,   125,     6,     7,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,   122,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   119
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   392,   392,   393,   393,   401,   402,   404,   406,   409,
     416,   419,   423,   427,   434,   438,   442,   446,   450,   454,
     489,   505,   506,   514,   518,   522,   523,   524,   528,   529,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   549,   550,   551,   564,   565,   566,   570,   577,   581,
     582,   590,   597,   598,   599,   604,   616,   634,   638,   646,
     647,   650,   654,   663,   669,   669,   680,   684,   691,   695,
     700,   705,   720,   721,   722,   726,   730,   755,   756,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,   767,
     768,   769,   779,   783,   787,   791,   795,   799,   803,   807,
     811,   818,   819,   829,   839,   849,   860,   870,   876,   885,
     898,   900,   900,   912,   915,   925,   936,   964,   976,   986,
     989,   993,   997,  1001,  1005,  1009,  1013,  1017,  1046,  1045,
    1049,  1058,  1066,  1071,  1074,  1077,  1081,  1085,  1089,  1093,
    1097,  1127,  1126,  1133,  1141,  1148,  1165,  1171,  1172,  1173,
    1178,  1181,  1241,  1240,  1263,  1276,  1286,  1292,  1297,  1306,
    1318,  1319,  1323,  1330,  1334,  1363,  1370,  1369,  1387,  1393,
    1396,  1399,  1408,  1411,  1415,  1425,  1431,  1432,  1433,  1437,
    1449,  1450,  1451,  1455,  1459,  1474,  1492,  1493,  1497,  1501,
    1508,  1511,  1517,  1520,  1528,  1529,  1530,  1535,  1534,  1542,
    1561,  1562,  1570,  1584,  1587,  1600,  1603,  1607,  1621,  1624,
    1630,  1633,  1655,  1656,  1657,  1658,  1661,  1668,  1669,  1670,
    1674,  1681,  1685,  1692,  1693,  1694,  1701,  1702,  1703,  1707,
    1708,  1765,  1766,  1770,  1777,  1778,  1782,  1791,  1792,  1804,
    1808,  1813,  1822,  1829,  1830,  1834,  1846,  1852,  1858,  1868,
    1872,  1882,  1886,  1890,  1894,  1898,  1902,  1910,  1923,  1940,
    1951,  1962,  1979,  1996,  2009,  2032,  2050,  2051,  2066,  2076,
    2092,  2108,  2117,  2144,  2155,  2165,  2184,  2195,  2205,  2219,
    2234,  2249,  2264,  2274,  2279,  2284,  2289,  2296,  2297,  2304,
    2305,  2324,  2328,  2332,  2336,  2343,  2347,  2351,  2355,  2362,
    2365,  2375,  2380,  2385,  2390,  2395,  2400,  2410,  2415,  2420,
    2425,  2432,  2450,  2461,  2472,  2490,  2508,  2522,  2545,  2557,
    2573,  2582,  2583,  2587,  2591,  2592,  2599,  2607,  2608,  2620,
    2620,  2627,  2631,  2642,  2653,  2658,  2664,  2669,  2676,  2683,
    2688,  2693,  2699,  2706,  2713,  2719,  2722,  2725,  2736,  2765,
    2772,  2784,  2785,  2789,  2793,  2800,  2801,  2803,  2804,  2805,
    2807,  2808,  2809,  2810,  2814,  2815,  2818,  2821,  2839,  2857,
    2865,  2880,  2912,  2930,  2939,  2942,  2951,  2962,  2963,  2964,
    2968,  2969,  2970,  2971,  2982,  2983,  2984,  2996,  2999,  3005,
    3021,  3022,  3023,  3024,  3032,  3036,  3037,  3041,  3048,  3055,
    3059,  3063,  3064,  3069,  3087,  3093,  3100,  3101,  3108,  3134,
    3144,  3160,  3164,  3165,  3166,  3170,  3177,  3180,  3201,  3204,
    3216,  3221,  3226,  3236,  3243,  3250,  3260,  3261,  3268,  3276,
    3277,  3280,  3285,  3289,  3292,  3313,  3314,  3319,  3322,  3323,
    3328,  3335,  3338,  3344,  3347,  3353,  3368,  3379,  3380,  3391,
    3392,  3396,  3401,  3407,  3414,  3422,  3430,  3433,  3436,  3439,
    3442,  3445,  3448,  3454,  3455,  3456,  3460,  3463,  3471,  3479,
    3487,  3493,  3499,  3502,  3509,  3512,  3519,  3530,  3533,  3545,
    3546,  3547,  3548,  3549,  3564,  3565,  3566,  3570,  3574,  3585,
    3589,  3600,  3608,  3611,  3614,  3617,  3623,  3626,  3633,  3636,
    3642,  3643,  3651,  3710,  3730,  3737,  3753,  3758,  3763,  3768,
    3772,  3782,  3788,  3795,  3798,  3804,  3807,  3810,  3813,  3819,
    3822,  3825,  3831,  3832,  3838,  3841,  3844,  3850,  3853,  3865,
    3868,  3871,  3875,  3878,  3881,  3887,  3890,  3894,  3895,  3896,
    3903,  3904,  3905,  3911,  3912,  3921,  3933,  3934,  3950,  3951,
    3962,  3961,  3970,  3986,  3995,  3999,  4006,  4014,  4017,  4022,
    4029,  4028,  4043,  4046,  4050,  4053,  4056,  4060,  4060,  4076,
    4083,  4089,  4090,  4093,  4099,  4105,  4108,  4111,  4114,  4120,
    4121,  4127,  4131,  4139,  4143,  4147,  4151,  4158,  4164,  4167,
    4173,  4174,  4178,  4182,  4186,  4186,  4199,  4202,  4209,  4214
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "\"invalid token\"", "PREC_BOT",
  "COMPOSITE", "':'", "'^'", "'_'", "'!'", "'\\''", "','", "PREC_TOP",
  "\"\\\\accepts\"", "\"\\\\addlyrics\"", "\"\\\\alias\"",
  "\"\\\\alternative\"", "\"\\\\book\"", "\"\\\\bookpart\"",
  "\"\\\\change\"", "\"\\\\chordmode\"", "\"\\\\chords\"",
  "\"\\\\consists\"", "\"\\\\context\"", "\"\\\\default\"",
  "\"\\\\defaultchild\"", "\"\\\\denies\"", "\"\\\\description\"",
  "\"\\\\drummode\"", "\"\\\\drums\"", "\"\\\\etc\"", "\"\\\\figuremode\"",
  "\"\\\\figures\"", "\"\\\\header\"", "\"\\\\version-error\"",
  "\"\\\\layout\"", "\"\\\\lyricmode\"", "\"\\\\lyrics\"",
  "\"\\\\lyricsto\"", "\"\\\\markup\"", "\"\\\\markuplist\"",
  "\"\\\\midi\"", "\"\\\\name\"", "\"\\\\notemode\"", "\"\\\\override\"",
  "\"\\\\paper\"", "\"\\\\remove\"", "\"\\\\repeat\"", "\"\\\\rest\"",
  "\"\\\\revert\"", "\"\\\\score\"", "\"\\\\score-lines\"",
  "\"\\\\sequential\"", "\"\\\\set\"", "\"\\\\simultaneous\"",
  "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"", "\"\\\\with\"",
  "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"", "\"/\"", "\"<\"",
  "\">\"", "\"<<\"", "\">>\"", "\"\\\\\\\\\"", "\"\\\\!\"", "\"\\\\+\"",
  "\"__\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"", "\"--\"",
  "MULTI_MEASURE_REST", "E_UNSIGNED", "UNSIGNED", "\"markup?\"",
  "\"scheme?\"", "\"(backed-up?)\"", "\"(reparsed?)\"", "\"markup-list?\"",
  "\"optional?\"", "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER",
  "CHORD_MODIFIER", "CHORD_REPETITION", "DRUM_PITCH", "DURATION_ARG",
  "DURATION_IDENTIFIER", "EVENT_IDENTIFIER", "EVENT_FUNCTION", "FRACTION",
  "LOOKUP_IDENTIFIER", "LYRIC_ELEMENT", "MARKUP_FUNCTION",
  "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER",
  "MUSIC_FUNCTION", "MUSIC_IDENTIFIER", "NOTENAME_PITCH",
  "NUMBER_IDENTIFIER", "PITCH_IDENTIFIER", "REAL", "RESTNAME", "SCM_ARG",
  "SCM_FUNCTION", "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST",
  "TONICNAME_PITCH", "SYMBOL", "'-'", "'+'", "UNARY_MINUS", "'.'", "'{'",
  "'}'", "'='", "'*'", "']'", "'/'", "'['", "'?'", "$accept",
  "start_symbol", "$@1", "lilypond", "toplevel_expression", "lookup",
  "embedded_scm_bare", "embedded_scm_active", "embedded_scm_bare_arg",
  "embedded_scm", "embedded_scm_arg", "scm_function_call",
  "embedded_lilypond_number", "embedded_lilypond", "lilypond_header_body",
  "lilypond_header", "header_block", "$@2", "assignment_id", "assignment",
  "identifier_init", "identifier_init_nonumber",
  "partial_function_scriptable", "partial_function",
  "context_def_spec_block", "context_mod_arg", "$@3",
  "context_def_spec_body", "book_block", "book_body", "$@4",
  "bookpart_block", "bookpart_body", "$@5", "score_block", "score_body",
  "score_item", "score_items", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "output_def_body", "$@7", "tempo_event",
  "music_list", "braced_music_list", "music", "pitch_as_music",
  "music_embedded", "music_embedded_backup", "music_assign",
  "repeated_music", "sequential_music", "simultaneous_music",
  "simple_music", "context_modification", "$@8",
  "context_modification_arg", "optional_context_mods",
  "context_modification_mods_list", "context_mod_list", "context_prefix",
  "new_lyrics", "basic_music", "contextable_music",
  "contexted_basic_music", "composite_music", "music_bare",
  "grouped_music_list", "symbol_list_arg", "symbol_list_rev",
  "symbol_list_part", "symbol_list_element", "symbol_list_part_bare",
  "function_arglist_nonbackup", "reparsed_rhythm",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_partial", "function_arglist_partial_optional",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_optional", "function_arglist_skip_backup",
  "music_function_call", "optional_id", "lyric_mode_music", "$@9",
  "mode_changed_music", "mode_changing_head",
  "mode_changing_head_with_context", "context_change", "property_path",
  "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_revert_context",
  "music_property_def", "string", "text", "simple_string", "symbol",
  "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "event_function_event", "post_events", "post_event_nofinger",
  "post_event", "string_number_event", "direction_less_event",
  "direction_reqd_event", "octave_check", "quotes", "erroneous_quotes",
  "sup_quotes", "sub_quotes", "steno_pitch", "steno_tonic_pitch", "pitch",
  "pitch_or_tonic_pitch", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "maybe_notemode_duration",
  "optional_notemode_duration", "steno_duration", "multiplied_duration",
  "dots", "multipliers", "tremolo_type", "bass_number",
  "figured_bass_alteration", "bass_figure", "figured_bass_modification",
  "br_bass_figure", "figure_list", "optional_rest", "pitch_or_music",
  "simple_element", "lyric_element", "lyric_element_music", "new_chord",
  "chord_items", "chord_separator", "chord_item", "step_numbers",
  "step_number", "tempo_range", "number_expression", "number_term",
  "number_factor", "bare_number_common", "bare_number", "unsigned_number",
  "exclamations", "questions", "full_markup_list", "$@10", "markup_mode",
  "markup_mode_word", "full_markup", "partial_markup", "markup_top",
  "markup_scm", "$@11", "markup_list", "markup_uncomposed_list", "$@12",
  "markup_composed_list", "markup_braced_list", "markup_braced_list_body",
  "markup_command_list", "markup_command_basic_arguments",
  "markup_command_list_arguments", "markup_partial_function",
  "markup_arglist_partial", "markup_head_1_item", "markup_head_1_list",
  "markup_word", "simple_markup", "simple_markup_noword", "$@13", "markup", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,    58,    94,    95,    33,    39,
      44,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    45,    43,   366,
      46,   123,   125,    61,    42,    93,    47,    91,    63
};
#endif

#define YYPACT_NINF (-623)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-586)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      -5,  -623,   116,  1641,  1208,  -623,  -623,    66,    98,  -623,
    -623,   820,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    1107,  -623,  -623,  -623,  -623,  -623,  1157,   107,   131,   131,
     820,  -623,  -623,   -23,   411,  -623,   411,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,   136,    74,  -623,
    -623,  -623,  -623,  -623,  -623,   143,  1543,  -623,  -623,  -623,
    -623,  4053,   260,  -623,  -623,  -623,  -623,  -623,  -623,    22,
    -623,  -623,  1356,   169,  -623,  -623,    53,   216,   216,   820,
     509,  1208,     8,     8,     8,   914,     8,   884,  -623,  -623,
    -623,  -623,    96,  -623,   217,    96,    96,  -623,  -623,   492,
    -623,  -623,   512,    95,  -623,    95,   224,    96,   638,  -623,
    -623,   332,    95,   335,    47,  -623,  -623,   348,  -623,  -623,
    -623,  -623,  -623,  -623,   327,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  3241,   286,   372,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,    96,  -623,  -623,   374,  -623,  -623,
    -623,    96,  -623,   964,  -623,  -623,  -623,   376,  -623,    96,
    -623,  -623,  -623,  -623,  4002,  -623,   378,  -623,   302,   316,
    -623,  -623,  -623,   296,   308,   317,   323,   306,   326,  1516,
    -623,  -623,  -623,   431,  -623,  -623,  -623,   296,  1885,     8,
     648,   345,  -623,  -623,   375,  -623,  -623,   381,  -623,  1325,
     322,  -623,     8,     8,  3128,  -623,  -623,  -623,  -623,  -623,
    -623,  3989,    76,   169,  -623,  -623,   260,  -623,  -623,  -623,
    -623,   443,  -623,    22,   410,  -623,  -623,   552,   580,  -623,
    -623,  -623,  -623,  -623,    56,  -623,  -623,  -623,  -623,  -623,
    -623,  1356,  -623,  -623,  3128,  -623,  -623,  -623,  -623,   350,
    -623,  -623,  -623,  -623,  -623,  -623,    82,  -623,  -623,  -623,
       8,   351,  -623,     8,    82,   359,  -623,  -623,  -623,  -623,
      96,   365,  -623,  -623,  -623,  -623,   383,  -623,  1037,   852,
    -623,  -623,  -623,  -623,   373,  -623,  -623,   373,   756,   425,
    -623,  -623,   756,   428,  -623,  -623,  -623,  -623,   506,   508,
    -623,  -623,  -623,   756,   444,  -623,  -623,   217,  -623,  -623,
    -623,     8,     8,   411,  -623,  -623,   216,  -623,  -623,  -623,
    -623,  1085,  -623,  -623,   289,  -623,  1050,  1104,   518,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  4002,  -623,   413,   911,  1044,
    -623,  1044,   663,   510,  4037,  -623,  1681,  -623,  1777,  1157,
    -623,  -623,  -623,    22,  1157,   459,   439,  -623,  1516,  -623,
    -623,  -623,  3897,    71,  3797,  -623,  -623,  -623,  -623,    82,
     464,   225,  -623,  3015,   466,   801,   906,  1742,  -623,  -623,
      82,   426,   432,    44,    86,    89,   175,  -623,  -623,  -623,
    -623,    97,  -623,  -623,   197,  -623,    60,  -623,  -623,  -623,
    -623,  -623,  -623,   443,   306,  -623,  -623,  -623,   430,   437,
     580,   580,   580,  -623,  -623,   580,  -623,  -623,  3544,   478,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  1157,  3571,
       8,     8,  -623,  3353,  -623,  -623,   480,  -623,  3465,   440,
     431,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  1296,  -623,
    -623,   453,  -623,  -623,  1044,  -623,  1044,   756,   486,  -623,
    2450,   835,  2450,   835,  -623,  -623,  2450,   835,   452,   461,
    1443,  1044,  -623,  1044,   467,  -623,  -623,   467,  -623,  -623,
     -15,  -623,   103,  -623,  1044,   976,   976,  -623,  -623,   663,
    -623,  -623,  -623,  -623,   136,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,   136,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,   306,   586,  -623,  -623,  -623,
    -623,   136,  -623,  -623,  -623,   968,  1244,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,   190,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,   515,  2563,   579,  -623,
    -623,   100,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,   721,  3128,  3128,  -623,   502,
     170,  -623,     8,     8,  1044,   170,   170,   170,   170,  -623,
     306,  -623,  -623,  -623,   793,  1516,  1073,  -623,  -623,  1356,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,     8,  -623,     8,  -623,   820,  -623,   323,  -623,  -623,
    4145,  -623,  -623,  1121,  -623,   487,  -623,  -623,  -623,  -623,
     240,  -623,   175,  -623,  -623,   118,  -623,  -623,   161,  -623,
    -623,    20,  -623,  -623,   431,  -623,   519,  3596,  1044,   518,
     453,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  2676,   984,  -623,   756,   547,  2111,  -623,  -623,
    2111,  -623,  2111,  3697,  3697,  -623,  -623,  1229,    95,  -623,
      96,  -623,  -623,   976,   612,  -623,   793,  -623,  -623,  -623,
    -623,  -623,   131,  -623,   563,  2224,   621,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,   801,  -623,  -623,  -623,  -623,
    -623,   361,  -623,  -623,  -623,  -623,  -623,  -623,  -623,   373,
       8,     8,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,    73,    78,  -623,  -623,  -623,
     546,  1073,  -623,  -623,   525,  -623,  -623,  -623,  -623,  -623,
    -623,  3697,   756,   572,  -623,     8,     8,   262,   277,   564,
     834,  -623,  -623,   431,  -623,  -623,  -623,   -15,   587,  1998,
    -623,  2789,   835,  -623,  -623,  -623,   175,    33,  -623,  -623,
    -623,   557,  -623,  -623,    95,  1073,  -623,   968,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,   447,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,   413,    82,    82,  -623,
    -623,  3697,  -623,   849,  1014,  -623,  -623,   756,   602,   756,
     603,    99,   594,     8,     8,  -623,  -623,  -623,   984,  2337,
    -623,  -623,   607,  -623,   646,  -623,  -623,  -623,  -623,  1044,
    -623,     8,     8,  -623,   625,   849,   849,  1014,   849,  1014,
     976,    99,  -623,  -623,  1044,  -623,  -623,  -623,   583,   584,
    1014,   849,   849,  -623,  1044,   849,   849,  2902
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,   337,
     341,     0,   335,   339,   336,   340,     9,   158,   338,   342,
       0,   552,   550,   157,   334,   156,     0,     0,     0,     0,
       0,   172,    13,    21,     0,   227,     0,    25,    18,    66,
      67,   172,     6,    27,    19,    26,    10,     0,     0,     7,
      11,    12,    14,    20,   159,     0,     0,   191,   213,   230,
     229,     0,   223,   224,    15,   214,   228,   212,   226,     0,
     203,    17,     0,   555,    16,    57,   477,   464,   463,     0,
       0,     0,     0,     0,     0,     0,     0,   197,   406,   421,
     498,   420,   466,   428,   472,   466,   466,   472,   430,     0,
      85,   509,     0,   437,   538,   437,   537,   466,     0,    24,
      23,   508,   437,   507,   465,    43,    41,   185,    42,    53,
       4,    77,    52,   101,     0,    82,    79,    80,    78,    81,
     401,   180,   178,     0,   182,   176,   186,    90,   187,   196,
     195,    86,   194,   402,   466,   432,   426,   181,   429,   418,
     447,   466,   546,   108,   474,   416,   431,   179,   416,   466,
     177,   416,    49,    89,     0,   555,   506,    88,   118,   132,
     387,   388,   389,   327,   384,   385,   386,   329,     0,     0,
     384,   385,   386,     0,   150,   190,   192,   327,     0,     0,
       0,     0,   299,   287,     0,   326,   243,     0,    47,     0,
       0,    65,     0,     0,    64,   162,   168,   165,   155,   164,
     163,     0,     0,     0,   218,   217,   221,   222,   219,   179,
     203,   225,   332,     0,   202,   594,   567,     0,     0,   590,
     591,   571,   560,   554,     0,   557,   563,   562,   564,   565,
     588,     0,   553,   559,    64,   478,   455,   424,   425,     0,
     113,    58,   240,   239,   241,   238,   368,   234,   242,   237,
     369,     0,   372,     0,   371,     0,   472,   380,   381,   383,
     171,     0,   382,   376,   201,   200,     0,   199,     0,     0,
     468,   416,   467,    50,   469,   416,   504,   470,     0,     0,
     415,    93,     0,     0,    92,   441,   443,   445,   439,   438,
     448,   539,   505,     0,     0,    94,   446,   455,    48,   427,
      91,     0,     0,     0,   508,   507,   465,   185,   172,   176,
     181,     0,   416,   506,     0,   416,   511,     0,   548,   456,
     462,   459,   460,   452,   453,   458,   457,   461,   454,   107,
     419,   423,   422,   433,   434,     0,   451,   471,   184,   398,
     416,   503,     0,     0,     0,   119,     0,   133,     0,     0,
     203,   331,   215,     0,     0,     0,     0,   551,     0,   543,
     544,   545,     0,     0,   145,   203,   174,   193,   173,    22,
       0,   321,   266,    64,     0,     0,     0,     0,   175,    59,
     344,     0,     0,   541,   377,   378,   465,    87,    68,    72,
      83,     0,   416,    84,    73,   531,   532,   540,   536,   379,
     161,   167,   160,   220,   329,   203,   333,   204,     0,     0,
       0,     0,     0,   578,   596,     0,   579,   574,     0,     0,
     597,   566,   569,   589,   592,   558,   593,    71,     0,   111,
       0,     0,   370,    64,   351,   374,     0,   350,    64,     0,
       0,   205,   404,   416,   413,   414,   412,   407,   410,   411,
     450,   449,   546,   405,   487,   479,   480,   481,     0,   483,
     488,   496,   499,   482,   400,   473,   399,     0,     0,   292,
      64,     0,    64,     0,   442,   444,    64,     0,     0,     0,
       0,   184,   183,   403,     0,   516,   515,     0,   513,   547,
     435,   106,     0,   417,   510,     0,     0,   581,   556,     0,
     130,   126,   117,   127,     0,   121,   122,   120,   154,   123,
     125,   124,   143,   139,   131,   140,     0,   135,   134,   136,
     138,   137,   328,   208,   330,   329,   188,   146,   144,   147,
     151,     0,   149,   148,   209,     0,     0,   317,   318,    30,
      28,   311,    29,   314,   315,   465,    40,    44,   300,    45,
      34,    36,    37,    38,    35,    39,    46,    33,   302,   313,
     312,   301,    32,   316,    31,   323,     0,    64,     0,   472,
     254,   231,   256,   252,   251,   250,   255,   253,   304,   310,
     309,   308,   306,   305,   307,     0,    64,    64,   542,   541,
       0,   535,     0,     0,    76,     0,     0,     0,     0,   210,
     329,   150,   150,   587,     0,     0,     0,   570,   573,     0,
     599,   572,   561,   343,   357,   360,   355,   358,   359,   362,
     363,     0,   356,     0,   361,     0,   109,    41,   110,   116,
       0,   115,   364,     0,   114,     0,   236,   235,   464,   463,
       0,   392,   465,   390,   104,     0,   395,   373,   108,   391,
     393,     0,   105,   375,     0,   169,   527,   111,   409,   548,
     497,   486,   495,   493,   492,   484,   485,   489,   494,   490,
     491,   296,    64,     0,    96,     0,     0,    64,   294,    95,
      64,    97,    64,    64,    64,   518,   517,   512,   437,   549,
     466,   475,   476,     0,   587,   583,   586,   584,   582,   129,
     142,   216,     0,   153,     0,   324,   325,   286,   285,   284,
     282,   283,   319,   303,   320,     0,   264,   265,   258,   261,
     262,   465,   248,   244,   260,   259,   249,   263,   288,   474,
       0,     0,    61,    63,    62,    60,    70,    69,    75,    74,
     530,   529,   533,   534,   211,     0,     0,   577,   576,   575,
       0,     0,   580,   598,     0,   348,   346,   112,   365,   366,
     367,    64,     0,     0,   394,     0,     0,     0,     0,     0,
       0,   349,   170,     0,   198,   207,   206,   435,     0,   324,
     298,    64,     0,    99,    98,   100,     0,   524,   521,   519,
     514,   520,   522,   436,   437,   585,   189,     0,   272,   278,
     274,   273,   279,   280,   281,   465,   267,   268,   270,   269,
     271,   322,   290,   245,   247,   246,   416,   233,   232,   595,
     568,    64,   345,   291,     0,   397,   396,     0,     0,     0,
       0,     0,     0,     0,     0,   354,   528,   416,     0,    64,
     526,   525,     0,   440,   500,   325,   275,   277,   276,   257,
     347,     0,     0,   465,     0,   293,   291,     0,   291,     0,
       0,     0,   353,   352,   408,   523,   501,   416,     0,     0,
       0,   293,   293,   586,   502,   102,   103,    64
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -623,  -623,  -623,  -623,  -623,     4,   147,   -30,  -623,   155,
     247,    21,   606,   664,  -623,  -414,    61,  -623,  -623,   -27,
    -204,    90,  -130,   291,   231,    80,  -623,  -623,   266,  -623,
    -623,    58,  -623,  -623,   141,  -216,  -623,  -623,  -623,   395,
      17,  -623,  -623,  -623,  -623,  -623,  -623,     7,   -24,  -115,
     693,    72,  -623,    79,  -623,  -623,  -623,  -623,    42,  -623,
    -623,  -157,  -623,  -623,  -623,   540,   697,  -623,   699,    10,
    -623,   -22,  -331,   -72,   -40,  -623,  -159,   -51,  -321,  -623,
    -511,     3,  -622,   -77,  -433,   -43,  -623,  -166,  -508,  -117,
     578,  -397,  -623,  -623,  -623,  -623,  -623,   -13,  -623,  -359,
    -623,  -623,  -623,   101,  -623,  -305,   -78,  -623,  -623,  -390,
    -623,     6,   -11,  -381,   705,  -623,  -623,  -623,  -623,  -623,
    -623,   -71,   -64,   110,  -623,   -84,  -623,   -20,   -94,  -623,
    -623,  -623,  -623,   184,   167,  -623,  -623,   320,  -623,    12,
    -136,  1009,   -26,   676,   -67,    35,  -623,  -623,  -623,   304,
    -623,  -623,  -623,  -623,    37,  -623,  -623,  -254,  -623,  -623,
      84,  -623,  -623,   -73,   123,  -623,  -193,  -307,    34,  -342,
    -180,   329,   128,   204,  -623,   714,    24,    -3,   313,  -623,
    -144,  -623,  -137,  -192,  -623,  -623,  -623,  -623,  -623,  -170,
    -370,   643,  -340,  -213,   -70,    -1,  -208,    19,  -623,   385
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,    42,   115,   116,    44,   557,   232,
     558,   118,   119,   120,   595,   201,   560,    47,    48,    49,
     398,   399,   123,   124,   561,   639,   640,   439,   562,   356,
     514,   563,   358,   526,   564,   373,   540,   374,   541,   517,
     565,    54,    55,   411,    56,   211,   130,   188,    57,   131,
     132,   378,   134,   566,    58,    59,    60,   136,   567,   276,
     277,   223,   224,   667,    61,   221,    62,   216,    63,   138,
      65,    66,   582,   390,   257,   258,   259,   193,   583,   194,
     381,   195,   578,   688,   479,   196,   197,   383,   384,    67,
     360,   362,   363,    68,    69,    70,   139,   391,   642,   445,
     446,   447,   643,   644,   260,   261,   265,   263,   140,   141,
     270,   177,   173,   657,   142,   143,   144,   278,   457,   458,
     145,   348,   146,   503,   148,   149,   342,   700,   297,   854,
     298,   299,   150,   151,   152,   462,   343,   309,   344,   321,
     280,   281,   154,   282,   284,   347,   156,   470,   679,   471,
     680,   472,   279,   877,   219,   158,   159,   160,   161,   697,
     498,   800,   801,   802,   665,   404,   405,   406,   407,   408,
     666,   328,   500,   572,   179,   164,   165,   409,   574,   233,
     234,   429,   235,   236,   419,   237,   238,   428,   239,   426,
     427,   501,   507,   240,   354,   434,   620,   436,   418,   762
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   166,   241,   372,   185,   186,   488,    43,   273,   178,
     256,   300,   264,    64,   264,   326,   153,   609,   306,   187,
      53,   129,   291,   339,    45,   294,   209,    73,   433,   210,
     287,   305,   183,   435,   715,   366,   340,   716,   162,   198,
     437,   157,   367,   262,   681,   401,   137,   222,   199,   432,
     613,   614,   615,   656,  -240,   616,   589,   424,   656,   271,
      43,    51,   127,   414,    46,   121,   590,   663,   249,   341,
     492,   242,   537,    28,   537,    29,   133,    45,   166,   537,
     213,     1,   272,   135,   202,   401,   252,   349,    31,   601,
     351,   243,   440,   153,   122,   850,  -239,   189,   129,  -241,
     709,   660,   290,   822,   295,   296,   660,   602,   698,   368,
     740,   198,   710,   699,   147,   162,     5,   379,   157,   109,
     110,   253,   480,   137,   254,   307,   482,   713,   775,   780,
     323,   245,   586,   593,   581,   704,   706,   486,   711,   127,
     402,   433,   121,    41,    52,   128,   435,   382,   162,   598,
     346,   851,   104,   133,   106,   433,   430,   431,   172,   117,
     135,   456,   432,   242,  -240,   705,   707,   176,   200,   708,
     822,   122,   789,   182,   266,   716,   432,   172,   505,   870,
     402,   701,   424,   243,   607,   323,   608,   168,    97,   229,
     392,   147,   230,   538,   203,   829,   323,   204,   702,    21,
     830,   416,   441,   533,   340,   318,  -239,    71,   163,  -241,
     474,   242,   319,   754,   476,   717,   153,   603,   544,   169,
     741,   129,   128,   444,   366,   718,   172,   172,   184,   255,
     255,   255,   269,   255,   489,   125,   117,   341,   776,   256,
     264,   403,   275,   320,   449,   382,   137,   442,   599,   382,
     790,   491,    41,   599,   493,   650,   153,   536,   610,   543,
     382,   129,   127,   777,   205,   121,   417,   319,   722,    50,
     126,   778,   764,   220,   765,   104,   473,   106,   319,   504,
     104,   403,   106,   400,   655,   163,   137,   600,   317,   655,
     412,   618,   244,   601,   246,   723,   715,   724,   320,   855,
     752,   753,   127,   656,   656,   121,  -324,   546,   338,   320,
     774,   682,   125,   663,   605,   606,   290,   167,   346,   568,
     772,   323,   283,   400,   773,   490,   513,    21,   525,   301,
     781,   604,  -377,   805,   577,  -378,   255,   789,   371,   424,
     855,   534,   837,   317,   242,   128,   838,   126,   -87,   255,
     255,   660,   660,   521,   317,   531,   310,   839,   619,   397,
      43,   840,    43,   705,   243,   532,   519,   324,   529,   323,
     535,   323,   -83,   518,   -54,   518,   -84,    45,  -379,    45,
     573,   656,   668,   323,   323,   128,   101,   556,   459,   355,
     832,   542,   746,   747,   167,   755,   756,   247,   248,   397,
     646,   647,   314,   357,   559,   315,   433,   255,   163,   361,
     255,   763,   750,   751,   515,   790,   568,   571,   568,   359,
     587,   594,   568,   585,   592,   385,   469,   432,   645,   660,
     687,  -387,   690,   455,   382,   125,   692,   401,   401,   823,
    -388,   656,   410,   389,   623,   461,  -389,   556,   163,   364,
     860,   319,   556,   319,   774,   658,   415,   386,   255,   255,
     658,   671,   460,   387,   559,   473,   824,    87,   825,   559,
     126,   366,   760,   438,   443,   125,   338,   573,   759,   573,
     659,   641,   448,   573,   556,   659,   556,   323,   450,   660,
     556,   190,   153,   475,   153,   191,   192,   516,   153,   527,
     883,   559,   382,   559,   451,   481,   182,   559,   483,   369,
     126,   182,   739,   733,   571,   484,   571,   167,   485,   791,
     571,   672,   673,   674,   487,   856,   499,    33,   339,   539,
     707,   708,   402,   402,   655,   655,   370,   502,   420,   508,
     431,    36,   109,   110,   545,   368,   761,   575,   433,   596,
     570,   611,   857,   763,   858,   597,   878,   167,   612,   622,
     520,   661,   530,   664,   804,   744,   683,   569,   745,   319,
     675,   676,   288,   291,   737,   693,   289,   192,   677,   678,
     721,   556,   112,   720,   694,   182,   637,   255,   255,   748,
     749,   444,   292,   444,   638,   725,   293,   192,   559,    43,
     320,   712,   738,   846,   803,   371,   833,   598,   153,   153,
     771,   736,   655,   129,   129,   469,    45,   760,   568,   213,
     109,   110,   170,   733,   766,   171,   733,   792,   733,   433,
     250,   420,   421,   403,   403,   422,   783,   423,   137,   137,
     382,  -585,   382,   807,   821,   317,   430,   570,   831,   570,
     767,   817,   834,   570,   127,   127,   645,   121,   121,   425,
     421,   760,   841,   422,   569,   423,   569,   848,   827,   828,
     569,   866,   655,   868,   577,   400,   400,   852,   695,   573,
     155,   696,   867,   869,   737,   797,   556,   737,   806,   737,
     653,   556,   871,   876,   556,   653,   556,   556,   556,   153,
     294,   305,   153,   559,   153,   880,   885,   886,   559,   842,
     853,   559,   820,   559,   559,   559,   571,    72,   303,   556,
     308,   736,   304,   192,   736,   817,   736,   568,   190,   382,
     659,   659,   380,   192,   654,   761,   559,   128,   128,   662,
     845,   849,   505,   506,   735,   251,   422,   785,   423,   255,
     255,   397,   397,   528,   214,   859,   413,   155,   215,    21,
     217,   734,   835,   836,   382,   375,   218,   847,   786,   758,
     212,   684,   670,   689,   826,   556,   874,   691,   255,   875,
     255,   799,   172,   865,   879,   733,   820,   782,   573,   256,
     264,   669,   559,   556,   382,   556,   382,   787,   770,    72,
     163,   163,     0,   872,   873,   382,   884,   353,   659,   322,
     559,     0,   559,   621,   637,     0,   881,    33,   882,   371,
       0,     0,   638,   733,   732,   571,     0,   125,   125,   887,
       0,    36,    37,   742,    39,   556,   477,    40,     0,     0,
     478,   192,     0,   743,   843,   658,   737,    72,     0,   570,
       0,     0,   559,   556,   735,   648,   649,   735,     0,   735,
       0,   758,   126,   126,   322,     0,   569,   345,   659,     0,
     559,   734,     0,     0,   734,   322,   734,   658,   658,     0,
     658,   190,   819,   736,   737,   576,   192,   255,   255,    33,
      21,   556,   861,   658,   658,     0,     0,   658,   658,   818,
       0,   862,    72,    36,   109,   110,   757,     0,   559,   167,
     167,   -55,   252,    72,     0,   685,    76,    77,    78,   686,
     192,   736,   255,   255,   463,     0,   464,   255,     0,     0,
     465,   109,   110,   170,   732,     0,   171,   732,   371,   732,
     653,   653,     0,   650,    21,   109,   110,   253,     0,     0,
     254,   777,    21,     0,   844,     0,   819,     0,   570,   778,
       0,     0,   816,   109,   110,   466,   863,     0,   467,    76,
     329,   330,   331,   818,     0,   569,     0,     0,   793,   468,
      33,   794,    89,   795,   266,     0,    91,   274,    93,     0,
     255,   255,   266,    72,    36,   109,   110,   579,    97,     0,
       0,     0,    21,   101,    98,   313,    97,     0,   255,   255,
     103,   104,   105,   106,     0,   580,   735,     0,   653,   314,
     581,   112,   315,     0,     0,   109,   110,   267,   316,   332,
     268,     0,     0,   734,     0,    72,   816,     0,    72,     0,
       0,    93,    76,    77,    78,     0,     0,     0,   190,    76,
      77,    78,   714,   192,   735,   703,   506,    98,    99,   422,
      33,   423,   584,   591,   477,     0,   102,     0,   788,   192,
      72,   734,    72,     0,   108,   109,   110,   333,   653,     0,
     334,   335,   336,     0,   337,     0,    72,     0,    72,     0,
      76,   329,   330,   331,   685,     0,   732,     0,   864,   192,
      72,    72,   452,     0,   285,   286,     0,     0,    89,  -468,
    -468,  -468,    91,  -468,    93,    89,   302,     0,     0,    91,
       0,    93,   225,    21,   684,     0,     0,   453,     0,     0,
      98,   313,     0,    33,   732,     0,     0,    98,   313,    34,
     454,   103,     0,   105,     0,     0,     0,    36,   109,   110,
     332,     0,   112,   325,   316,     0,   793,   689,     0,   691,
     327,   316,    93,   494,   495,   496,   322,   497,   350,    33,
       0,   227,   794,   795,     0,     0,   654,   662,    98,   313,
       0,    33,    72,    36,   109,   110,   229,    34,     0,   230,
       0,     0,     0,     0,     0,    36,   109,   110,   333,     0,
       0,   334,   335,   336,    72,   337,     0,     0,   -51,    75,
       0,     0,     0,    76,    77,    78,     0,    33,   109,   110,
     174,     0,   719,   175,     7,     8,    79,     9,    10,     0,
      80,    36,   109,   110,   768,    12,    13,   769,    14,    15,
     -64,    81,    17,    18,    19,    20,    21,    22,    23,     0,
      24,    82,    25,     0,    26,     0,    83,    27,     0,    28,
      84,    29,    85,     0,    86,    87,    30,     0,   109,   110,
     180,     0,    88,   181,    31,     0,     0,     0,     0,    89,
       0,    90,     0,    91,    92,    93,    94,     0,   494,   495,
     496,     0,   497,     0,     0,     0,     0,    95,    96,     0,
      97,    98,    99,   100,    33,   101,     0,   797,     0,   212,
     102,    35,   103,   104,   105,   106,   107,   798,   108,   109,
     110,   111,   266,   112,   113,   114,   376,     0,     0,    41,
      76,    77,    78,     0,    21,   579,    97,     0,     0,     0,
       0,     0,     0,    79,     9,    10,     0,    11,   103,   104,
     105,   106,    12,    13,     0,    14,    15,     0,   581,   112,
      18,    19,    20,    21,     0,     0,     0,    24,   311,     0,
     464,    26,   779,    83,   465,     0,    28,   312,    29,    85,
       0,    86,     0,    30,     0,     0,     0,     0,     0,    88,
       0,    31,     0,     0,     0,     0,    89,     0,    90,     0,
      91,    92,    93,   266,     0,   225,   226,   109,   110,   466,
       0,     0,   467,     0,    95,    96,     0,    97,    98,   313,
       0,    33,   101,     0,     0,     0,     0,    34,    35,   103,
       0,   105,     0,   107,     0,    36,   109,   110,   314,     0,
     112,   315,   316,   -56,   376,     0,    41,   388,    76,    77,
      78,     0,    33,     0,   227,   228,     0,     0,     0,     0,
       0,    79,     9,    10,     0,    11,    36,   109,   110,   229,
      12,    13,   230,    14,    15,     0,     0,   231,    18,    19,
      20,    21,     0,     0,     0,    24,   311,     0,     0,    26,
       0,    83,     0,     0,    28,   312,    29,    85,     0,    86,
       0,    30,     0,     0,     0,     0,     0,    88,     0,    31,
       0,     0,     0,     0,    89,     0,    90,     0,    91,    92,
      93,   266,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    95,    96,     0,    97,    98,   313,     0,    33,
     101,     0,     0,     0,   206,    34,    35,   103,     0,   105,
       0,   107,     0,    36,   109,   110,   314,     0,   112,   315,
     316,  -166,  -166,  -166,    41,  -166,   226,     0,     0,     0,
    -166,  -166,     0,  -166,  -166,     0,     0,     0,  -166,  -166,
    -166,    21,     0,     0,     0,  -166,  -166,     0,     0,  -166,
       0,  -166,     0,     0,  -166,  -166,  -166,  -166,     0,  -166,
       0,  -166,     0,     0,     0,     0,     0,  -166,     0,  -166,
       0,     0,    33,     0,   365,   228,  -166,     0,     0,  -166,
       0,     0,     0,     0,     0,     0,    36,   109,   110,     0,
       0,     0,  -166,  -166,     0,     0,     0,   231,     0,    33,
       0,    -2,     6,     0,     0,  -166,  -166,     0,     0,     0,
       0,  -166,     0,    36,    37,   207,    39,     7,     8,    40,
       9,    10,     0,    11,  -166,   208,     0,     0,    12,    13,
       0,    14,    15,   -64,    16,    17,    18,    19,    20,    21,
      22,    23,   510,    24,     0,    25,     0,    26,     0,     0,
      27,     0,    28,     0,    29,     0,     0,     0,     8,    30,
       9,    10,     0,    11,     0,     0,     0,    31,    12,    13,
       0,    14,    15,  -128,     0,    17,    18,    19,    20,    21,
      22,    23,     0,    24,     0,    25,     0,    26,    32,     0,
      27,     0,    28,     0,    29,     0,     0,    33,     0,    30,
       0,     0,     0,    34,    35,     0,     0,    31,     0,     0,
       0,    36,    37,    38,    39,     0,     0,    40,     0,     0,
       0,     0,    41,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    33,   522,     0,
      21,     0,     0,    34,    35,     0,     0,     0,     0,     0,
       0,    36,    37,   511,     0,     0,     9,    10,     0,    11,
       0,     0,    41,   512,    12,    13,     0,    14,    15,  -141,
       0,    17,    18,    19,    20,    21,    22,    23,     0,    24,
     266,    25,     0,    26,     0,     0,    27,     0,    28,     0,
      29,     0,     0,   579,    97,    30,     0,     0,     0,   101,
       0,     0,     0,    31,     0,     0,   103,   104,   105,   106,
       0,   588,     0,     0,     0,   314,   581,   112,   315,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,    34,
      35,     0,     0,     0,     0,     0,   376,    36,    37,   523,
      76,    77,    78,     0,     0,     0,     0,     0,    41,   524,
       0,     0,     0,    79,     9,    10,     0,    11,     0,     0,
       0,     0,    12,    13,     0,    14,    15,     0,     0,     0,
      18,    19,    20,    21,     0,     0,     0,    24,   311,     0,
       0,    26,     0,    83,     0,     0,    28,   312,    29,    85,
       0,    86,     0,    30,     0,     0,     0,     0,     0,    88,
       0,    31,   377,     0,     0,     0,    89,     0,    90,     0,
      91,    92,    93,   266,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,    97,    98,   313,
       0,    33,   101,     0,     0,     0,     0,    34,    35,   103,
       0,   105,     0,   107,     0,    36,   109,   110,   314,     0,
     112,   315,   316,    76,    77,    78,    41,     0,     0,     0,
       0,     0,     0,     0,     7,     8,    79,     9,    10,     0,
      80,     0,     0,     0,     0,    12,    13,  -297,    14,    15,
     -64,     0,    17,    18,    19,    20,    21,    22,    23,     0,
      24,   311,    25,     0,    26,     0,    83,    27,     0,    28,
     312,    29,    85,     0,    86,    87,    30,     0,     0,     0,
       0,     0,    88,     0,    31,     0,     0,     0,     0,    89,
       0,    90,     0,    91,    92,    93,   808,     0,     0,     0,
     546,     0,     0,     0,     0,     0,     0,    95,    96,     0,
     809,    98,   313,   549,    33,     0,     0,     0,     0,     0,
      34,    35,   103,   810,   105,   811,   107,   550,    36,   812,
     552,   813,     0,   112,   814,   815,    76,    77,    78,    41,
       0,     0,     0,     0,     0,     0,     0,     7,     8,    79,
       9,    10,     0,    80,  -289,     0,     0,     0,    12,    13,
    -293,    14,    15,     0,     0,    17,    18,    19,    20,    21,
      22,    23,     0,    24,    82,    25,     0,    26,     0,    83,
      27,     0,    28,    84,    29,    85,     0,    86,    87,    30,
       0,     0,     0,     0,     0,    88,     0,    31,     0,     0,
       0,     0,    89,     0,    90,     0,    91,    92,    93,   726,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      95,    96,     0,   727,    98,    99,   549,    33,     0,     0,
       0,     0,     0,   102,    35,   103,   104,   105,   106,   107,
     550,   108,   728,   552,   729,     0,   112,   730,   731,    76,
      77,    78,    41,     0,     0,     0,     0,     0,     0,     0,
       7,     8,    79,     9,    10,     0,    80,     0,     0,     0,
       0,    12,    13,     0,    14,    15,   -64,     0,    17,    18,
      19,    20,    21,    22,    23,     0,    24,   311,    25,     0,
      26,     0,    83,    27,     0,    28,   312,    29,    85,     0,
      86,    87,    30,     0,     0,     0,     0,     0,    88,     0,
      31,     0,     0,     0,     0,    89,     0,    90,     0,    91,
      92,    93,   808,     0,     0,     0,   546,     0,     0,     0,
       0,     0,     0,    95,    96,     0,   809,    98,   313,   549,
      33,     0,     0,     0,     0,     0,    34,    35,   103,   810,
     105,   811,   107,   550,    36,   812,   552,   813,     0,   112,
     814,   815,    76,    77,    78,    41,     0,     0,     0,     0,
       0,     0,     0,     7,     8,    79,     9,    10,     0,    80,
    -289,     0,     0,     0,    12,    13,  -293,    14,    15,     0,
       0,    17,    18,    19,    20,    21,    22,    23,     0,    24,
     311,    25,     0,    26,     0,    83,    27,     0,    28,   312,
      29,    85,     0,    86,    87,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,    89,     0,
      90,     0,    91,    92,    93,   726,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,   727,
      98,   313,   549,    33,     0,     0,     0,     0,     0,    34,
      35,   103,   104,   105,   106,   107,   550,    36,   728,   552,
     729,     0,   112,   730,   731,    76,    77,    78,    41,     0,
       0,     0,     0,     0,     0,     0,     7,     8,    79,     9,
      10,     0,    80,     0,     0,     0,     0,    12,    13,  -291,
      14,    15,     0,     0,    17,    18,    19,    20,    21,    22,
      23,     0,    24,    82,    25,     0,    26,     0,    83,    27,
       0,    28,    84,    29,    85,     0,    86,    87,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,    89,     0,    90,     0,    91,    92,    93,   547,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,   548,    98,    99,   549,    33,     0,     0,     0,
       0,     0,   102,    35,   103,   104,   105,   106,   107,   550,
     108,   551,   552,   553,     0,   112,   554,   555,    76,    77,
      78,    41,     0,     0,     0,     0,     0,     0,     0,     7,
       8,    79,     9,    10,     0,    80,  -289,     0,     0,     0,
      12,    13,     0,    14,    15,     0,     0,    17,    18,    19,
      20,    21,    22,    23,     0,    24,   311,    25,     0,    26,
       0,    83,    27,     0,    28,   312,    29,    85,     0,    86,
      87,    30,     0,     0,     0,     0,     0,    88,     0,    31,
       0,     0,     0,     0,    89,     0,    90,     0,    91,    92,
      93,   726,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    95,    96,     0,   727,    98,   313,   549,    33,
       0,     0,     0,     0,     0,    34,    35,   103,   104,   105,
     106,   107,   550,    36,   728,   552,   729,     0,   112,   730,
     731,    76,    77,    78,    41,     0,     0,     0,     0,     0,
       0,     0,     7,     8,    79,     9,    10,     0,    80,     0,
       0,     0,     0,    12,    13,  -295,    14,    15,     0,     0,
      17,    18,    19,    20,    21,    22,    23,     0,    24,   311,
      25,     0,    26,     0,    83,    27,     0,    28,   312,    29,
      85,     0,    86,    87,    30,     0,     0,     0,     0,     0,
      88,     0,    31,     0,     0,     0,     0,    89,     0,    90,
       0,    91,    92,    93,   547,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,     0,   548,    98,
     313,   549,    33,     0,     0,     0,     0,     0,    34,    35,
     103,   104,   105,   106,   107,   550,    36,   551,   552,   553,
       0,   112,   554,   555,    76,    77,    78,    41,     0,     0,
       0,     0,     0,     0,     0,     7,     8,    79,     9,    10,
       0,    80,     0,     0,     0,     0,    12,    13,  -291,    14,
      15,     0,     0,    17,    18,    19,    20,    21,    22,    23,
       0,    24,   311,    25,     0,    26,     0,    83,    27,     0,
      28,   312,    29,    85,     0,    86,    87,    30,     0,     0,
       0,     0,     0,    88,     0,    31,     0,     0,     0,     0,
      89,     0,    90,     0,    91,    92,    93,   547,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    95,    96,
       0,   548,    98,   313,   549,    33,     0,     0,     0,     0,
       0,    34,    35,   103,   104,   105,   106,   107,   550,    36,
     551,   552,   553,     0,   112,   554,   555,    76,    77,    78,
      41,     0,     0,     0,     0,     0,     0,     0,     7,     8,
      79,     9,    10,     0,    80,     0,     0,     0,     0,    12,
      13,  -293,    14,    15,     0,     0,    17,    18,    19,    20,
      21,    22,    23,     0,    24,   311,    25,     0,    26,     0,
      83,    27,     0,    28,   312,    29,    85,     0,    86,    87,
      30,     0,     0,     0,     0,     0,    88,     0,    31,     0,
       0,     0,     0,    89,     0,    90,     0,    91,    92,    93,
     726,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    95,    96,     0,   727,    98,   313,   549,    33,     0,
       0,     0,     0,     0,    34,    35,   103,   104,   105,   106,
     107,   550,    36,   728,   552,   729,     0,   112,   730,   731,
      76,    77,    78,    41,     0,     0,     0,     0,     0,     0,
       0,     7,     8,    79,     9,    10,     0,    80,     0,     0,
       0,     0,    12,    13,     0,    14,    15,     0,     0,    17,
      18,    19,    20,    21,    22,    23,     0,    24,   311,    25,
       0,    26,     0,    83,    27,     0,    28,   312,    29,    85,
       0,    86,    87,    30,     0,     0,     0,     0,     0,    88,
       0,    31,     0,     0,     0,     0,    89,     0,    90,     0,
      91,    92,    93,   547,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,   548,    98,   313,
     549,    33,     0,     0,     0,     0,     0,    34,    35,   103,
     104,   105,   106,   107,   550,    36,   551,   552,   553,     0,
     112,   554,   555,    76,    77,    78,    41,     0,     0,     0,
       0,     0,     0,     0,     7,     8,    79,     9,    10,     0,
      80,     0,     0,     0,     0,    12,    13,     0,    14,    15,
       0,     0,    17,    18,    19,    20,    21,    22,    23,     0,
      24,    82,    25,     0,    26,     0,    83,    27,     0,    28,
      84,    29,    85,     0,    86,    87,    30,     0,     0,     0,
       0,     0,    88,     0,    31,     0,     0,     0,     0,    89,
       0,    90,     0,    91,    92,    93,   393,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,     0,
       0,    98,    99,   100,    33,     0,     0,     0,     0,     0,
     102,    35,   103,   104,   105,   106,   107,     0,   108,   109,
     110,   394,     0,   112,   395,   396,    76,    77,    78,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       9,    10,     0,    11,     0,     0,     0,     0,    12,    13,
       0,    14,    15,     0,     0,     0,    18,    19,    20,    21,
       0,     0,     0,    24,   311,     0,     0,    26,     0,    83,
       0,     0,    28,   312,    29,    85,     0,    86,     0,    30,
       0,     0,     0,     0,     0,    88,     0,    31,     0,     0,
       0,     0,    89,     0,    90,     0,    91,    92,    93,   266,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      95,    96,     0,    97,    98,   313,     0,    33,   101,     0,
       0,     0,     0,    34,    35,   103,     0,   105,     0,   107,
       0,    36,   109,   110,   314,     0,   112,   315,   316,   648,
     649,     0,    41,     0,     0,     0,     0,     0,     0,     7,
       8,    79,     9,    10,     0,    80,     0,     0,     0,     0,
      12,    13,  -102,    14,    15,     0,     0,    17,    18,    19,
      20,    21,    22,    23,     0,    24,    82,    25,     0,    26,
       0,    83,    27,     0,    28,    84,    29,    85,     0,    86,
      87,    30,     0,     0,     0,     0,     0,    88,     0,    31,
       0,     0,     0,     0,     0,     0,    90,     0,     0,    92,
       0,   393,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    95,    96,     0,     0,     0,   650,   549,    33,
       0,     0,     0,     0,     0,   102,    35,   103,   104,   105,
     106,   107,   550,   108,   651,   552,   394,     0,   112,   395,
     652,   648,   649,     0,    41,     0,     0,     0,     0,     0,
       0,     7,     8,    79,     9,    10,     0,    80,     0,     0,
       0,     0,    12,    13,  -103,    14,    15,     0,     0,    17,
      18,    19,    20,    21,    22,    23,     0,    24,    82,    25,
       0,    26,     0,    83,    27,     0,    28,    84,    29,    85,
       0,    86,    87,    30,     0,     0,     0,     0,     0,    88,
       0,    31,     0,     0,     0,     0,     0,     0,    90,     0,
       0,    92,     0,   393,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,     0,     0,   650,
     549,    33,     0,     0,     0,     0,     0,   102,    35,   103,
     104,   105,   106,   107,   550,   108,   651,   552,   394,     0,
     112,   395,   652,   624,     0,   625,    41,     0,     0,     0,
       0,     0,   626,   225,   226,   627,   628,   629,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   624,     0,
     625,     0,   630,     0,   631,     0,   632,   626,     0,   633,
     627,   628,   629,     0,     0,     0,   634,   635,    87,     0,
       0,     0,     0,     0,     0,     0,     0,   630,     0,   631,
      33,   632,   227,   228,   633,     0,     0,     0,     0,     0,
       0,   634,   635,     0,    36,   109,   110,   229,     0,     0,
     230,     0,     0,     0,     0,   231,   617,    33,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,   109,   110,   170,     0,     0,   171,     0,     0,
       0,     0,    33,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,   109,   110,   170,
       0,     0,   171,     7,     8,    79,     9,    10,   784,    80,
       0,     0,     0,     0,    12,    13,     0,    14,    15,     0,
       0,    17,    18,    19,    20,    21,    22,    23,     0,    24,
     311,    25,     0,    26,     0,    83,    27,     0,    28,   312,
      29,    85,     0,    86,    87,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,     0,     0,
      90,     0,     0,    92,     0,   393,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,     0,
       0,     0,   549,    33,     0,     0,     0,     0,     0,    34,
      35,   103,   104,   105,   106,   107,   550,    36,   651,   552,
     394,     0,   112,   395,   796,    79,     9,    10,    41,    11,
       0,     0,     0,     0,    12,    13,     0,    14,    15,  -152,
       0,    17,    18,    19,    20,    21,     0,    23,     0,    24,
     311,    25,     0,    26,     0,    83,     0,     0,    28,   312,
      29,    85,     0,    86,     0,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,     0,     0,
      90,     0,     0,    92,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,     0,
       0,     0,     0,    33,   101,     0,     0,     0,     0,    34,
      35,   103,     0,   105,     0,   107,     0,    36,   109,   110,
     314,     0,   112,   315,     0,    79,     9,    10,    41,    11,
       0,     0,     0,     0,    12,    13,     0,    14,    15,     0,
       0,     0,    18,    19,    20,    21,     0,     0,     0,    24,
     311,     0,     0,    26,     0,    83,     0,     0,    28,   312,
      29,    85,     0,    86,     0,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,     0,     0,
      90,     0,     0,    92,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,     0,
       0,     0,     0,     0,   101,     0,     0,     0,     0,    34,
      35,   103,     0,   105,     0,   107,     0,    79,     9,    10,
     314,    80,   112,   315,     0,     0,    12,    13,    41,    14,
      15,     0,     0,     0,    18,    19,    20,     0,     0,     0,
       0,    24,   311,     0,     0,    26,     0,    83,     0,     0,
      28,   312,    29,    85,     0,    86,     0,    30,     0,     0,
       0,   225,   226,    88,     0,    31,     0,     0,     0,     0,
       0,     0,    90,     0,     0,    92,     0,     0,     0,     0,
       0,     0,     9,    10,     0,    11,     0,     0,    95,    96,
      12,    13,     0,    14,    15,     0,   225,   226,    18,    19,
      20,    34,    35,     0,     0,    24,     0,   107,    33,    26,
     352,   228,     0,     0,    28,     0,    29,    85,     0,     0,
      41,    30,    36,   109,   110,   229,     0,    88,   230,    31,
       0,     0,     0,   231,     0,     0,    90,     0,     0,    92,
       0,     0,     0,    33,     0,   509,   228,     0,     0,     0,
       0,     0,    95,    96,     0,     0,     0,    36,   109,   110,
     229,     0,     0,   230,     0,    34,    35,   103,   231,   105,
       0,   107,     0,     0,     9,    10,     0,    11,   112,     0,
       0,     0,    12,    13,    41,    14,    15,     0,     0,     0,
      18,    19,    20,     0,     0,     0,     0,    24,     0,     0,
       0,    26,     0,     0,     0,     0,    28,     0,    29,     0,
       0,     0,     0,    30,     0,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    34,    35,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41
};

static const yytype_int16 yycheck[] =
{
       3,     4,    72,   183,    28,    29,   311,     3,    86,    20,
      82,   105,    84,     3,    86,   151,     4,   414,   112,    30,
       3,     4,    99,   153,     3,   102,    56,     3,   241,    56,
      97,   108,    26,   241,   545,   179,   153,   545,     4,    36,
     244,     4,   179,    83,   477,   204,     4,    69,    41,   241,
     420,   421,   422,   443,    10,   425,   387,   227,   448,    85,
      56,     3,     4,   220,     3,     4,   387,   448,    79,   153,
     324,    72,     1,    51,     1,    53,     4,    56,    81,     1,
      56,    86,    85,     4,    10,   244,    78,   158,    66,   396,
     161,    72,    10,    81,     4,    62,    10,   120,    81,    10,
     514,   443,    99,   725,     9,    10,   448,    10,   123,   179,
      10,   108,   526,   128,     4,    81,     0,   189,    81,   111,
     112,   113,   288,    81,   116,    78,   292,   541,    10,   109,
     133,    78,   386,   387,   114,   505,   506,   303,   535,    81,
     204,   354,    81,   121,     3,     4,   354,   190,   114,   105,
     153,   118,   105,    81,   107,   368,   100,   101,    11,     4,
      81,   278,   354,   164,   120,   505,   506,    20,    32,   509,
     792,    81,   683,    26,    78,   683,   368,    30,    79,    80,
     244,    78,   352,   164,   124,   188,   126,   121,    92,   113,
     203,    81,   116,   122,   120,   122,   199,   123,    95,    38,
     122,   223,   120,   360,   321,   133,   120,     3,     4,   120,
     281,   212,   133,   610,   285,   546,   204,   120,   375,   121,
     120,   204,    81,   263,   368,   546,    79,    80,   121,    82,
      83,    84,    85,    86,   312,     4,    81,   321,   120,   311,
     312,   204,    87,   133,   270,   288,   204,   260,    78,   292,
     683,   322,   121,    78,   325,    94,   244,   372,   415,   374,
     303,   244,   204,   102,   121,   204,   224,   188,    78,     3,
       4,   110,   631,    13,   633,   105,   279,   107,   199,   350,
     105,   244,   107,   204,   443,    81,   244,   117,   133,   448,
     211,   428,   123,   600,    78,   105,   807,   107,   188,   807,
     607,   608,   244,   693,   694,   244,    81,    82,   153,   199,
     652,   477,    81,   694,   117,   118,   313,     4,   321,   383,
      80,   324,   105,   244,    84,   318,   356,    38,   358,   105,
     661,   402,     0,   703,   385,     0,   189,   848,   183,   509,
     848,   363,    80,   188,   345,   204,    84,    81,     0,   202,
     203,   693,   694,   356,   199,   358,    29,    80,   428,   204,
     356,    84,   358,   703,   345,   359,   356,    81,   358,   372,
     364,   374,     0,   356,     0,   358,     0,   356,     0,   358,
     383,   771,   453,   386,   387,   244,    97,   383,   278,    87,
     771,   374,   596,   597,    81,   611,   612,    77,    78,   244,
     440,   441,   113,    87,   383,   116,   619,   260,   204,   103,
     263,   619,   605,   606,   356,   848,   480,   383,   482,   123,
     386,   387,   486,   386,   387,    80,   279,   619,   439,   771,
     481,   123,   483,   278,   477,   204,   487,   596,   597,    78,
     123,   831,   211,   121,   438,   278,   123,   443,   244,   123,
     831,   372,   448,   374,   796,   443,    13,    82,   311,   312,
     448,     8,   278,    82,   443,   468,   105,    57,   107,   448,
     204,   615,   616,   123,   123,   244,   321,   480,   615,   482,
     443,   439,   123,   486,   480,   448,   482,   490,   123,   831,
     486,    80,   480,   120,   482,    84,    85,   356,   486,   358,
     870,   480,   545,   482,   121,    80,   359,   486,    80,    78,
     244,   364,   579,   577,   480,     9,   482,   204,    10,   685,
     486,    68,    69,    70,    80,    78,     8,    96,   658,   374,
     870,   871,   596,   597,   693,   694,   105,   124,    79,    29,
     101,   110,   111,   112,    80,   615,   616,    81,   761,   123,
     383,   121,   105,   761,   107,   123,   861,   244,   121,    81,
     356,    81,   358,   123,   700,   595,    80,   383,   595,   490,
     117,   118,    80,   650,   577,   123,    84,    85,   125,   126,
     546,   577,   115,   546,   123,   438,   439,   440,   441,   602,
     603,   631,    80,   633,   439,    80,    84,    85,   577,   595,
     490,    15,    23,   783,   698,   450,   772,   105,   596,   597,
     123,   577,   771,   596,   597,   468,   595,   761,   682,   595,
     111,   112,   113,   687,   635,   116,   690,    80,   692,   842,
     121,    79,    80,   596,   597,    83,   117,    85,   596,   597,
     683,    29,   685,    80,    23,   490,   100,   480,   123,   482,
     640,   715,    80,   486,   596,   597,   667,   596,   597,    79,
      80,   805,    98,    83,   480,    85,   482,    80,   740,   741,
     486,   837,   831,   839,   725,   596,   597,   120,   494,   682,
       4,   497,    80,    80,   687,    78,   682,   690,   712,   692,
     443,   687,    98,    47,   690,   448,   692,   693,   694,   687,
     777,   778,   690,   682,   692,    80,   123,   123,   687,   779,
     804,   690,   715,   692,   693,   694,   682,     3,    80,   715,
     114,   687,    84,    85,   690,   789,   692,   791,    80,   772,
     693,   694,    84,    85,   443,   805,   715,   596,   597,   448,
     780,   792,    79,    80,   577,    81,    83,   667,    85,   602,
     603,   596,   597,   358,    61,   826,   216,    81,    61,    38,
      61,   577,   775,   776,   807,   187,    61,   787,   667,   614,
      56,   480,   468,   482,   739,   771,   847,   486,   631,   852,
     633,   697,   635,   834,   862,   849,   789,   664,   791,   861,
     862,   462,   771,   789,   837,   791,   839,   669,   643,    85,
     596,   597,    -1,   843,   844,   848,   877,   164,   771,   133,
     789,    -1,   791,   428,   667,    -1,   867,    96,   869,   664,
      -1,    -1,   667,   887,   577,   791,    -1,   596,   597,   880,
      -1,   110,   111,   112,   113,   831,    80,   116,    -1,    -1,
      84,    85,    -1,   122,    10,   833,   849,   133,    -1,   682,
      -1,    -1,   831,   849,   687,     6,     7,   690,    -1,   692,
      -1,   706,   596,   597,   188,    -1,   682,   153,   831,    -1,
     849,   687,    -1,    -1,   690,   199,   692,   865,   866,    -1,
     868,    80,   715,   849,   887,    84,    85,   740,   741,    96,
      38,   887,    43,   881,   882,    -1,    -1,   885,   886,   715,
      -1,    52,   188,   110,   111,   112,   113,    -1,   887,   596,
     597,     0,    78,   199,    -1,    80,     5,     6,     7,    84,
      85,   887,   775,   776,    72,    -1,    74,   780,    -1,    -1,
      78,   111,   112,   113,   687,    -1,   116,   690,   783,   692,
     693,   694,    -1,    94,    38,   111,   112,   113,    -1,    -1,
     116,   102,    38,    -1,   120,    -1,   789,    -1,   791,   110,
      -1,    -1,   715,   111,   112,   113,   117,    -1,   116,     5,
       6,     7,     8,   789,    -1,   791,    -1,    -1,   687,   127,
      96,   690,    71,   692,    78,    -1,    75,   103,    77,    -1,
     843,   844,    78,   279,   110,   111,   112,    91,    92,    -1,
      -1,    -1,    38,    97,    93,    94,    92,    -1,   861,   862,
     104,   105,   106,   107,    -1,   109,   849,    -1,   771,   113,
     114,   115,   116,    -1,    -1,   111,   112,   113,   117,    65,
     116,    -1,    -1,   849,    -1,   321,   789,    -1,   324,    -1,
      -1,    77,     5,     6,     7,    -1,    -1,    -1,    80,     5,
       6,     7,    84,    85,   887,    79,    80,    93,    94,    83,
      96,    85,   386,   387,    80,    -1,   102,    -1,    84,    85,
     356,   887,   358,    -1,   110,   111,   112,   113,   831,    -1,
     116,   117,   118,    -1,   120,    -1,   372,    -1,   374,    -1,
       5,     6,     7,     8,    80,    -1,   849,    -1,    84,    85,
     386,   387,    65,    -1,    95,    96,    -1,    -1,    71,    59,
      60,    61,    75,    63,    77,    71,   107,    -1,    -1,    75,
      -1,    77,    49,    38,   833,    -1,    -1,    90,    -1,    -1,
      93,    94,    -1,    96,   887,    -1,    -1,    93,    94,   102,
     103,   104,    -1,   106,    -1,    -1,    -1,   110,   111,   112,
      65,    -1,   115,   144,   117,    -1,   865,   866,    -1,   868,
     151,   117,    77,    59,    60,    61,   490,    63,   159,    96,
      -1,    98,   881,   882,    -1,    -1,   885,   886,    93,    94,
      -1,    96,   468,   110,   111,   112,   113,   102,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,    -1,
      -1,   116,   117,   118,   490,   120,    -1,    -1,     0,     1,
      -1,    -1,    -1,     5,     6,     7,    -1,    96,   111,   112,
     113,    -1,   546,   116,    16,    17,    18,    19,    20,    -1,
      22,   110,   111,   112,   113,    27,    28,   116,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    -1,    56,    57,    58,    -1,   111,   112,
     113,    -1,    64,   116,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    59,    60,
      61,    -1,    63,    -1,    -1,    -1,    -1,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    78,    -1,   595,
     102,   103,   104,   105,   106,   107,   108,    88,   110,   111,
     112,   113,    78,   115,   116,   117,     1,    -1,    -1,   121,
       5,     6,     7,    -1,    38,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    -1,    22,   104,   105,
     106,   107,    27,    28,    -1,    30,    31,    -1,   114,   115,
      35,    36,    37,    38,    -1,    -1,    -1,    42,    43,    -1,
      74,    46,   658,    48,    78,    -1,    51,    52,    53,    54,
      -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,
      75,    76,    77,    78,    -1,    49,    50,   111,   112,   113,
      -1,    -1,   116,    -1,    89,    90,    -1,    92,    93,    94,
      -1,    96,    97,    -1,    -1,    -1,    -1,   102,   103,   104,
      -1,   106,    -1,   108,    -1,   110,   111,   112,   113,    -1,
     115,   116,   117,     0,     1,    -1,   121,   122,     5,     6,
       7,    -1,    96,    -1,    98,    99,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    -1,    22,   110,   111,   112,   113,
      27,    28,   116,    30,    31,    -1,    -1,   121,    35,    36,
      37,    38,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    48,    -1,    -1,    51,    52,    53,    54,    -1,    56,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    92,    93,    94,    -1,    96,
      97,    -1,    -1,    -1,     1,   102,   103,   104,    -1,   106,
      -1,   108,    -1,   110,   111,   112,   113,    -1,   115,   116,
     117,    18,    19,    20,   121,    22,    50,    -1,    -1,    -1,
      27,    28,    -1,    30,    31,    -1,    -1,    -1,    35,    36,
      37,    38,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    48,    -1,    -1,    51,    52,    53,    54,    -1,    56,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    96,    -1,    98,    99,    73,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    89,    90,    -1,    -1,    -1,   121,    -1,    96,
      -1,     0,     1,    -1,    -1,   102,   103,    -1,    -1,    -1,
      -1,   108,    -1,   110,   111,   112,   113,    16,    17,   116,
      19,    20,    -1,    22,   121,   122,    -1,    -1,    27,    28,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,     1,    42,    -1,    44,    -1,    46,    -1,    -1,
      49,    -1,    51,    -1,    53,    -1,    -1,    -1,    17,    58,
      19,    20,    -1,    22,    -1,    -1,    -1,    66,    27,    28,
      -1,    30,    31,    32,    -1,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    46,    87,    -1,
      49,    -1,    51,    -1,    53,    -1,    -1,    96,    -1,    58,
      -1,    -1,    -1,   102,   103,    -1,    -1,    66,    -1,    -1,
      -1,   110,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
      -1,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,     1,    -1,
      38,    -1,    -1,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    19,    20,    -1,    22,
      -1,    -1,   121,   122,    27,    28,    -1,    30,    31,    32,
      -1,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      78,    44,    -1,    46,    -1,    -1,    49,    -1,    51,    -1,
      53,    -1,    -1,    91,    92,    58,    -1,    -1,    -1,    97,
      -1,    -1,    -1,    66,    -1,    -1,   104,   105,   106,   107,
      -1,   109,    -1,    -1,    -1,   113,   114,   115,   116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,   102,
     103,    -1,    -1,    -1,    -1,    -1,     1,   110,   111,   112,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,   121,   122,
      -1,    -1,    -1,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    -1,    30,    31,    -1,    -1,    -1,
      35,    36,    37,    38,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    48,    -1,    -1,    51,    52,    53,    54,
      -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    67,    -1,    -1,    -1,    71,    -1,    73,    -1,
      75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,
      -1,    96,    97,    -1,    -1,    -1,    -1,   102,   103,   104,
      -1,   106,    -1,   108,    -1,   110,   111,   112,   113,    -1,
     115,   116,   117,     5,     6,     7,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      32,    -1,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,
      92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,     5,     6,     7,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    -1,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    90,    -1,    92,    93,    94,    95,    96,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     5,
       6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,
      -1,    27,    28,    -1,    30,    31,    32,    -1,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    -1,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,
      76,    77,    78,    -1,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    22,
      23,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      -1,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,
      73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,
      93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     5,     6,     7,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    75,    76,    77,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,     5,     6,
       7,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    -1,    22,    23,    -1,    -1,    -1,
      27,    28,    -1,    30,    31,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    -1,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    92,    93,    94,    95,    96,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    -1,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,
      94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,     5,     6,     7,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    -1,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    -1,    56,    57,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      71,    -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,
      -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     5,     6,     7,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    -1,    56,    57,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    92,    93,    94,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
       5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    -1,    30,    31,    -1,    -1,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,
      75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     5,     6,     7,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,
      -1,    -1,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,
      -1,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,   111,
     112,   113,    -1,   115,   116,   117,     5,     6,     7,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,
      -1,    30,    31,    -1,    -1,    -1,    35,    36,    37,    38,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    48,
      -1,    -1,    51,    52,    53,    54,    -1,    56,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    90,    -1,    92,    93,    94,    -1,    96,    97,    -1,
      -1,    -1,    -1,   102,   103,   104,    -1,   106,    -1,   108,
      -1,   110,   111,   112,   113,    -1,   115,   116,   117,     6,
       7,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    -1,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    76,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    -1,    -1,    94,    95,    96,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     6,     7,    -1,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    -1,    -1,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    76,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    -1,    -1,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,    12,    -1,    14,   121,    -1,    -1,    -1,
      -1,    -1,    21,    49,    50,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    -1,
      14,    -1,    41,    -1,    43,    -1,    45,    21,    -1,    48,
      24,    25,    26,    -1,    -1,    -1,    55,    56,    57,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    43,
      96,    45,    98,    99,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    56,    -1,   110,   111,   112,   113,    -1,    -1,
     116,    -1,    -1,    -1,    -1,   121,   122,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    96,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
      -1,    -1,   116,    16,    17,    18,    19,    20,   122,    22,
      -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,    -1,
      -1,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    76,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    -1,
      -1,    -1,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,    18,    19,    20,   121,    22,
      -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,    32,
      -1,    34,    35,    36,    37,    38,    -1,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    -1,    -1,    51,    52,
      53,    54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    -1,
      -1,    -1,    -1,    96,    97,    -1,    -1,    -1,    -1,   102,
     103,   104,    -1,   106,    -1,   108,    -1,   110,   111,   112,
     113,    -1,   115,   116,    -1,    18,    19,    20,   121,    22,
      -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,    -1,
      -1,    -1,    35,    36,    37,    38,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    48,    -1,    -1,    51,    52,
      53,    54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,   102,
     103,   104,    -1,   106,    -1,   108,    -1,    18,    19,    20,
     113,    22,   115,   116,    -1,    -1,    27,    28,   121,    30,
      31,    -1,    -1,    -1,    35,    36,    37,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    48,    -1,    -1,
      51,    52,    53,    54,    -1,    56,    -1,    58,    -1,    -1,
      -1,    49,    50,    64,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    -1,    22,    -1,    -1,    89,    90,
      27,    28,    -1,    30,    31,    -1,    49,    50,    35,    36,
      37,   102,   103,    -1,    -1,    42,    -1,   108,    96,    46,
      98,    99,    -1,    -1,    51,    -1,    53,    54,    -1,    -1,
     121,    58,   110,   111,   112,   113,    -1,    64,   116,    66,
      -1,    -1,    -1,   121,    -1,    -1,    73,    -1,    -1,    76,
      -1,    -1,    -1,    96,    -1,    98,    99,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    -1,    -1,   110,   111,   112,
     113,    -1,    -1,   116,    -1,   102,   103,   104,   121,   106,
      -1,   108,    -1,    -1,    19,    20,    -1,    22,   115,    -1,
      -1,    -1,    27,    28,   121,    30,    31,    -1,    -1,    -1,
      35,    36,    37,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    51,    -1,    53,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   121
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    86,   130,   132,   131,     0,     1,    16,    17,    19,
      20,    22,    27,    28,    30,    31,    33,    34,    35,    36,
      37,    38,    39,    40,    42,    44,    46,    49,    51,    53,
      58,    66,    87,    96,   102,   103,   110,   111,   112,   113,
     116,   121,   133,   134,   136,   140,   145,   146,   147,   148,
     157,   160,   163,   169,   170,   171,   173,   177,   183,   184,
     185,   193,   195,   197,   198,   199,   200,   218,   222,   223,
     224,   302,   304,   305,   306,     1,     5,     6,     7,    18,
      22,    33,    43,    48,    52,    54,    56,    57,    64,    71,
      73,    75,    76,    77,    78,    89,    90,    92,    93,    94,
      95,    97,   102,   104,   105,   106,   107,   108,   110,   111,
     112,   113,   115,   116,   117,   134,   135,   138,   140,   141,
     142,   145,   150,   151,   152,   153,   157,   160,   163,   169,
     175,   178,   179,   180,   181,   182,   186,   187,   198,   225,
     237,   238,   243,   244,   245,   249,   251,   252,   253,   254,
     261,   262,   263,   268,   271,   272,   275,   283,   284,   285,
     286,   287,   297,   302,   304,   305,   306,   307,   121,   121,
     113,   116,   135,   241,   113,   116,   135,   240,   241,   303,
     113,   116,   135,   240,   121,   177,   177,   241,   176,   120,
      80,    84,    85,   206,   208,   210,   214,   215,   210,   176,
      32,   144,    10,   120,   123,   121,     1,   112,   122,   136,
     148,   174,   304,   305,   179,   195,   196,   197,   243,   283,
      13,   194,   200,   190,   191,    49,    50,    98,    99,   113,
     116,   121,   138,   308,   309,   311,   312,   314,   315,   317,
     322,   323,   324,   326,   123,    78,    78,   266,   266,   241,
     121,   142,    78,   113,   116,   135,   202,   203,   204,   205,
     233,   234,   203,   236,   202,   235,    78,   113,   116,   135,
     239,   271,   306,   235,   103,   138,   188,   189,   246,   281,
     269,   270,   272,   105,   273,   270,   270,   273,    80,    84,
     210,   212,    80,    84,   212,     9,    10,   257,   259,   260,
     257,   105,   270,    80,    84,   212,   257,    78,   141,   266,
      29,    43,    52,    94,   113,   116,   117,   138,   180,   182,
     252,   268,   272,   306,    81,   270,   269,   270,   300,     6,
       7,     8,    65,   113,   116,   117,   118,   120,   138,   151,
     218,   254,   255,   265,   267,   304,   306,   274,   250,   250,
     270,   250,    98,   320,   323,    87,   158,    87,   161,   123,
     219,   103,   220,   221,   123,    98,   309,   311,   323,    78,
     105,   138,   299,   164,   166,   219,     1,    67,   180,   202,
      84,   209,   214,   216,   217,    80,    82,    82,   122,   121,
     202,   226,   226,    78,   113,   116,   117,   138,   149,   150,
     182,   205,   251,   283,   294,   295,   296,   297,   298,   306,
     153,   172,   182,   194,   190,    13,   200,   187,   327,   313,
      79,    80,    83,    85,   318,    79,   318,   319,   316,   310,
     100,   101,   312,   322,   324,   325,   326,   149,   123,   156,
      10,   120,   226,   123,   203,   228,   229,   230,   123,   271,
     123,   121,    65,    90,   103,   138,   218,   247,   248,   252,
     262,   263,   264,    72,    74,    78,   113,   116,   127,   135,
     276,   278,   280,   306,   250,   120,   250,    80,    84,   213,
     216,    80,   216,    80,     9,    10,   216,    80,   234,   235,
     176,   250,   286,   250,    59,    60,    61,    63,   289,     8,
     301,   320,   124,   252,   250,    79,    80,   321,    29,    98,
       1,   112,   122,   136,   159,   160,   163,   168,   169,   198,
     302,   306,     1,   112,   122,   136,   162,   163,   168,   198,
     302,   306,   240,   190,   200,   240,   178,     1,   122,   138,
     165,   167,   169,   178,   190,    80,    82,    78,    92,    95,
     109,   111,   112,   113,   116,   117,   134,   137,   139,   140,
     145,   153,   157,   160,   163,   169,   182,   187,   251,   262,
     263,   297,   302,   306,   307,    81,    84,   206,   211,    91,
     109,   114,   201,   207,   272,   283,   286,   297,   109,   201,
     207,   272,   283,   286,   297,   143,   123,   123,   105,    78,
     117,   296,    10,   120,   250,   117,   118,   124,   126,   220,
     190,   121,   121,   319,   319,   319,   319,   122,   311,   323,
     325,   328,    81,   240,    12,    14,    21,    24,    25,    26,
      41,    43,    45,    48,    55,    56,   122,   135,   138,   154,
     155,   187,   227,   231,   232,   241,   203,   203,     6,     7,
      94,   111,   117,   139,   152,   205,   238,   242,   268,   283,
     298,    81,   152,   242,   123,   293,   299,   192,   250,   300,
     278,     8,    68,    69,    70,   117,   118,   125,   126,   277,
     279,   213,   216,    80,   152,    80,    84,   206,   212,   152,
     206,   152,   206,   123,   123,   262,   262,   288,   123,   128,
     256,    78,    95,    79,   319,   321,   319,   321,   321,   144,
     144,   220,    15,   144,    84,   209,   217,   201,   207,   272,
     283,   297,    78,   105,   107,    80,    78,    92,   111,   113,
     116,   117,   139,   251,   262,   263,   297,   306,    23,   273,
      10,   120,   112,   122,   136,   148,   149,   149,   226,   226,
     295,   295,   296,   296,   220,   164,   164,   113,   138,   311,
     309,   323,   328,   325,   228,   228,   241,   198,   113,   116,
     138,   123,    80,    84,   298,    10,   120,   102,   110,   304,
     109,   201,   293,   117,   122,   154,   232,   301,    84,   209,
     213,   216,    80,   152,   152,   152,   117,    78,    88,   289,
     290,   291,   292,   257,   269,   319,   177,    80,    78,    92,
     105,   107,   111,   113,   116,   117,   139,   251,   262,   263,
     306,    23,   211,    78,   105,   107,   274,   202,   202,   122,
     122,   123,   242,   216,    80,   226,   226,    80,    84,    80,
      84,    98,   323,    10,   120,   203,   299,   256,    80,   206,
      62,   118,   120,   257,   258,   217,    78,   105,   107,   250,
     242,    43,    52,   117,    84,   206,   216,    80,   216,    80,
      80,    98,   203,   203,   250,   292,    47,   282,   234,   235,
      80,   206,   206,   319,   250,   123,   123,   206
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   129,   130,   131,   130,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   136,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   139,   139,   139,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   146,   145,   147,   147,   148,   148,
     148,   148,   149,   149,   149,   149,   149,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   152,   152,   152,   152,   152,   152,   152,   152,   153,
     154,   155,   154,   156,   156,   156,   156,   157,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   159,   158,
     158,   160,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   162,   161,   161,   163,   164,   164,   165,   165,   165,
     166,   166,   167,   166,   168,   169,   170,   170,   170,   171,
     172,   172,   173,   173,   173,   173,   174,   173,   173,   175,
     175,   175,   176,   176,   176,   177,   178,   178,   178,   179,
     180,   180,   180,   180,   180,   181,   182,   182,   183,   183,
     184,   184,   185,   185,   186,   186,   186,   188,   187,   187,
     189,   189,   190,   191,   191,   192,   192,   192,   193,   193,
     194,   194,   195,   195,   195,   195,   195,   196,   196,   196,
     197,   197,   197,   198,   198,   198,   199,   199,   199,   200,
     200,   201,   201,   201,   202,   202,   202,   203,   203,   204,
     204,   205,   205,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   207,   208,   208,
     208,   208,   208,   208,   208,   208,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   210,   210,   211,
     211,   212,   212,   212,   212,   213,   213,   213,   213,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   216,   216,   216,   217,   217,   218,   219,   219,   221,
     220,   220,   222,   222,   223,   223,   223,   223,   223,   224,
     224,   224,   224,   225,   226,   227,   227,   227,   227,   228,
     229,   230,   230,   230,   230,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   232,   232,   232,   232,   233,   234,
     234,   235,   236,   237,   237,   237,   237,   238,   238,   238,
     239,   239,   239,   239,   240,   240,   240,   241,   241,   241,
     242,   242,   242,   242,   242,   242,   242,   242,   243,   243,
     243,   243,   243,   244,   245,   245,   246,   246,   247,   247,
     247,   247,   248,   248,   248,   249,   250,   250,   251,   251,
     251,   251,   251,   251,   251,   251,   252,   252,   253,   254,
     254,   254,   254,   255,   255,   256,   256,   257,   257,   257,
     258,   259,   259,   260,   260,   261,   262,   263,   263,   264,
     264,   265,   265,   265,   265,   266,   267,   267,   267,   267,
     267,   267,   267,   268,   268,   268,   269,   269,   270,   271,
     271,   272,   273,   273,   274,   274,   274,   275,   275,   276,
     276,   276,   276,   276,   277,   277,   277,   278,   278,   278,
     278,   278,   279,   279,   279,   279,   280,   280,   281,   281,
     282,   282,   283,   283,   284,   284,   285,   285,   285,   285,
     286,   287,   287,   288,   288,   289,   289,   289,   289,   290,
     290,   290,   291,   291,   292,   292,   292,   293,   293,   294,
     294,   294,   295,   295,   295,   296,   296,   297,   297,   297,
     298,   298,   298,   299,   299,   299,   300,   300,   301,   301,
     303,   302,   304,   305,   306,   306,   307,   308,   308,   308,
     310,   309,   311,   311,   312,   312,   312,   313,   312,   314,
     315,   316,   316,   316,   317,   318,   318,   318,   318,   319,
     319,   320,   320,   321,   321,   321,   321,   322,   323,   323,
     324,   324,   325,   325,   327,   326,   326,   326,   328,   328
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     0,     1,     1,     1,     2,     3,     1,     2,     0,
       2,     2,     2,     4,     0,     2,     1,     1,     3,     5,
       5,     3,     1,     1,     3,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     4,     4,     4,     5,     5,
       5,     1,     3,     3,     4,     4,     3,     2,     1,     4,
       1,     0,     2,     0,     2,     2,     2,     4,     0,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     3,
       2,     4,     0,     1,     2,     2,     2,     2,     2,     2,
       2,     0,     3,     2,     4,     1,     2,     1,     1,     1,
       0,     2,     0,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     0,     3,     2,     4,
       5,     2,     0,     2,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     1,     1,     4,     6,
       2,     1,     2,     3,     1,     1,     1,     0,     5,     2,
       1,     1,     1,     0,     2,     0,     2,     2,     4,     4,
       3,     4,     1,     1,     1,     3,     5,     1,     1,     1,
       3,     2,     2,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     4,     5,     5,     5,     4,     4,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     5,     5,     5,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     1,     4,     1,
       3,     2,     2,     3,     3,     2,     2,     3,     3,     1,
       3,     3,     3,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       4,     1,     4,     2,     1,     3,     2,     0,     2,     0,
       2,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     3,     2,     4,     2,     3,
       1,     1,     5,     5,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     1,
       2,     1,     1,     4,     3,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     3,     3,     2,     3,
       3,     1,     1,     3,     3,     3,     0,     2,     5,     2,
       1,     1,     1,     1,     1,     2,     0,     2,     1,     2,
       1,     1,     2,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     0,     1,     1,
       1,     1,     2,     1,     2,     2,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       2,     2,     0,     2,     0,     3,     3,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     2,     0,     2,
       0,     1,     8,     2,     2,     2,     1,     1,     1,     1,
       3,     2,     4,     0,     2,     1,     1,     2,     2,     1,
       1,     1,     1,     3,     1,     2,     2,     1,     3,     3,
       3,     1,     1,     3,     3,     2,     1,     1,     1,     2,
       1,     1,     2,     1,     1,     1,     0,     2,     0,     2,
       0,     3,     1,     2,     2,     1,     3,     1,     2,     1,
       0,     3,     1,     1,     1,     1,     2,     0,     5,     2,
       3,     0,     2,     2,     2,     3,     3,     3,     1,     1,
       3,     2,     3,     2,     2,     2,     2,     3,     1,     2,
       1,     1,     1,     1,     0,     5,     2,     2,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, Lily_parser *parser, SCM *retval)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, retval); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (Lily_parser *parser, SCM *retval)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, parser);
    }

  if (yychar <= END_OF_FILE)
    {
      yychar = END_OF_FILE;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* $@1: %empty  */
#line 393 "parser.yy"
                        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3356 "./out/parser.cc"
    break;

  case 4: /* start_symbol: "#{" $@1 embedded_lilypond  */
#line 395 "parser.yy"
                            {
		parser->lexer_->pop_state ();
                *retval = yyvsp[0];
 	}
#line 3365 "./out/parser.cc"
    break;

  case 5: /* lilypond: %empty  */
#line 401 "parser.yy"
                            { yyval = SCM_UNSPECIFIED; }
#line 3371 "./out/parser.cc"
    break;

  case 6: /* lilypond: lilypond toplevel_expression  */
#line 402 "parser.yy"
                                       {
	}
#line 3378 "./out/parser.cc"
    break;

  case 7: /* lilypond: lilypond assignment  */
#line 404 "parser.yy"
                              {
	}
#line 3385 "./out/parser.cc"
    break;

  case 8: /* lilypond: lilypond error  */
#line 406 "parser.yy"
                         {
		parser->error_level_ = 1;
	}
#line 3393 "./out/parser.cc"
    break;

  case 9: /* lilypond: lilypond "\\version-error"  */
#line 409 "parser.yy"
                                {
		parser->error_level_ = 1;
	}
#line 3401 "./out/parser.cc"
    break;

  case 10: /* toplevel_expression: header_block  */
#line 416 "parser.yy"
                     {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), yyvsp[0]);
	}
#line 3409 "./out/parser.cc"
    break;

  case 11: /* toplevel_expression: book_block  */
#line 419 "parser.yy"
                     {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3418 "./out/parser.cc"
    break;

  case 12: /* toplevel_expression: bookpart_block  */
#line 423 "parser.yy"
                         {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3427 "./out/parser.cc"
    break;

  case 13: /* toplevel_expression: BOOK_IDENTIFIER  */
#line 427 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier
			(unsmob<Book>(yyvsp[0])->paper_
			 ? "toplevel-book-handler"
			 : "toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3439 "./out/parser.cc"
    break;

  case 14: /* toplevel_expression: score_block  */
#line 434 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3448 "./out/parser.cc"
    break;

  case 15: /* toplevel_expression: composite_music  */
#line 438 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3457 "./out/parser.cc"
    break;

  case 16: /* toplevel_expression: full_markup  */
#line 442 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, scm_list_1 (yyvsp[0]));
	}
#line 3466 "./out/parser.cc"
    break;

  case 17: /* toplevel_expression: full_markup_list  */
#line 446 "parser.yy"
                           {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3475 "./out/parser.cc"
    break;

  case 18: /* toplevel_expression: SCM_TOKEN  */
#line 450 "parser.yy"
                    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3484 "./out/parser.cc"
    break;

  case 19: /* toplevel_expression: embedded_scm_active  */
#line 455 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_1 (proc, out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_1 (proc, yyvsp[0]);
		} else if (Output_def * od = unsmob<Output_def> (yyvsp[0])) {
			SCM id = SCM_EOL;

			if (to_boolean (od->c_variable ("is-paper")))
				id = ly_symbol2scm ("$defaultpaper");
			else if (to_boolean (od->c_variable ("is-midi")))
				id = ly_symbol2scm ("$defaultmidi");
			else if (to_boolean (od->c_variable ("is-layout")))
				id = ly_symbol2scm ("$defaultlayout");

			parser->lexer_->set_identifier (id, yyvsp[0]);
		} else if (ly_is_module (yyvsp[0]))
		{
			SCM module = get_header (parser);
			ly_module_copy (module, yyvsp[0]);
			parser->lexer_->set_identifier
				(ly_symbol2scm ("$defaultheader"), module);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3523 "./out/parser.cc"
    break;

  case 20: /* toplevel_expression: output_def  */
#line 489 "parser.yy"
                     {
		SCM id = SCM_EOL;
		Output_def * od = unsmob<Output_def> (yyvsp[0]);

		if (to_boolean (od->c_variable ("is-paper")))
			id = ly_symbol2scm ("$defaultpaper");
		else if (to_boolean (od->c_variable ("is-midi")))
			id = ly_symbol2scm ("$defaultmidi");
		else if (to_boolean (od->c_variable ("is-layout")))
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, yyvsp[0]);
	}
#line 3541 "./out/parser.cc"
    break;

  case 22: /* lookup: LOOKUP_IDENTIFIER '.' symbol_list_rev  */
#line 507 "parser.yy"
        {
		yyval = loc_on_copy (parser, (yyloc),
				  nested_property (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 3550 "./out/parser.cc"
    break;

  case 23: /* embedded_scm_bare: SCM_TOKEN  */
#line 515 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3558 "./out/parser.cc"
    break;

  case 29: /* embedded_scm_bare_arg: SCM_TOKEN  */
#line 530 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3566 "./out/parser.cc"
    break;

  case 47: /* scm_function_call: SCM_FUNCTION function_arglist  */
#line 570 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 3575 "./out/parser.cc"
    break;

  case 48: /* embedded_lilypond_number: '-' embedded_lilypond_number  */
#line 578 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 3583 "./out/parser.cc"
    break;

  case 50: /* embedded_lilypond_number: UNSIGNED NUMBER_IDENTIFIER  */
#line 583 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 3591 "./out/parser.cc"
    break;

  case 51: /* embedded_lilypond: %empty  */
#line 590 "parser.yy"
        {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		yyval = MAKE_SYNTAX (void_music, (yyloc));
	}
#line 3603 "./out/parser.cc"
    break;

  case 54: /* embedded_lilypond: post_event  */
#line 600 "parser.yy"
        {
		if (!unsmob<Music> (yyvsp[0]))
			yyval = MY_MAKE_MUSIC ("PostEvents", (yyloc))->unprotect ();
	}
#line 3612 "./out/parser.cc"
    break;

  case 55: /* embedded_lilypond: multiplied_duration post_events  */
#line 605 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0])) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
			n->set_property ("duration", yyvsp[-1]);
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 3628 "./out/parser.cc"
    break;

  case 56: /* embedded_lilypond: music_embedded music_embedded music_list  */
#line 616 "parser.yy"
                                                   {
		SCM tail = SCM_EOL;
		if (unsmob<Music> (yyvsp[-2]))
			tail = scm_cons (yyvsp[-2], tail);
		if (unsmob<Music> (yyvsp[-1]))
			tail = scm_cons (yyvsp[-1], tail);
		yyval = reverse_music_list (parser, (yyloc),
					 scm_append_x (scm_list_2 (yyvsp[0], tail)),
					 true, true);
		if (scm_is_pair (yyval)) // unpackaged list
			if (scm_is_null (scm_cdr (yyval)))
				yyval = scm_car (yyval); // single expression
			else
				yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyval);
		else if (scm_is_null (yyval))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		// else already packaged post-event
	}
#line 3651 "./out/parser.cc"
    break;

  case 57: /* embedded_lilypond: error  */
#line 634 "parser.yy"
                {
		parser->error_level_ = 1;
                yyval = SCM_UNSPECIFIED;
	}
#line 3660 "./out/parser.cc"
    break;

  case 58: /* embedded_lilypond: "\\version-error" embedded_lilypond  */
#line 638 "parser.yy"
                                    {
		parser->error_level_ = 1;
                yyval = yyvsp[0];
	}
#line 3669 "./out/parser.cc"
    break;

  case 59: /* lilypond_header_body: %empty  */
#line 646 "parser.yy"
                    { yyval = SCM_UNSPECIFIED; }
#line 3675 "./out/parser.cc"
    break;

  case 60: /* lilypond_header_body: lilypond_header_body assignment  */
#line 647 "parser.yy"
                                           {

	}
#line 3683 "./out/parser.cc"
    break;

  case 61: /* lilypond_header_body: lilypond_header_body SCM_TOKEN  */
#line 650 "parser.yy"
                                         {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3692 "./out/parser.cc"
    break;

  case 62: /* lilypond_header_body: lilypond_header_body embedded_scm_active  */
#line 654 "parser.yy"
                                                   {
		if (ly_is_module (yyvsp[0]))
			ly_module_copy (scm_current_module (), yyvsp[0]);
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3703 "./out/parser.cc"
    break;

  case 63: /* lilypond_header: "\\header" '{' lilypond_header_body '}'  */
#line 663 "parser.yy"
                                                {
		yyval = parser->lexer_->remove_scope ();
	}
#line 3711 "./out/parser.cc"
    break;

  case 64: /* $@2: %empty  */
#line 669 "parser.yy"
        {
		parser->lexer_->add_scope (get_header (parser));
	}
#line 3719 "./out/parser.cc"
    break;

  case 65: /* header_block: $@2 lilypond_header  */
#line 671 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 3727 "./out/parser.cc"
    break;

  case 66: /* assignment_id: STRING  */
#line 681 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3735 "./out/parser.cc"
    break;

  case 67: /* assignment_id: SYMBOL  */
#line 685 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3743 "./out/parser.cc"
    break;

  case 68: /* assignment: assignment_id '=' identifier_init  */
#line 691 "parser.yy"
                                           {
	        parser->lexer_->set_identifier (yyvsp[-2], yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3752 "./out/parser.cc"
    break;

  case 69: /* assignment: assignment_id '.' property_path '=' identifier_init  */
#line 695 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3762 "./out/parser.cc"
    break;

  case 70: /* assignment: assignment_id ',' property_path '=' identifier_init  */
#line 700 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3772 "./out/parser.cc"
    break;

  case 71: /* assignment: markup_mode_word '=' identifier_init  */
#line 706 "parser.yy"
        {
		if (scm_is_false (Lily::markup_function_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("Not a markup function"));
		} else {
			Lily::define_markup_command_internal
				(scm_string_to_symbol (yyvsp[-2]), yyvsp[0]);
		}
		yyval = SCM_UNSPECIFIED;
	}
#line 3787 "./out/parser.cc"
    break;

  case 74: /* identifier_init: symbol_list_part_bare '.' property_path  */
#line 723 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3795 "./out/parser.cc"
    break;

  case 75: /* identifier_init: symbol_list_part_bare ',' property_path  */
#line 727 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3803 "./out/parser.cc"
    break;

  case 76: /* identifier_init: post_event_nofinger post_events  */
#line 731 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (Music *m = unsmob<Music> (yyvsp[-1]))
		{
			if (m->is_mus_type ("post-event-wrapper"))
				yyval = scm_append
					(scm_list_2 (m->get_property ("elements"),
						     yyval));
			else
				yyval = scm_cons (yyvsp[-1], yyval);
		}
		if (scm_is_pair (yyval)
		    && scm_is_null (scm_cdr (yyval)))
			yyval = scm_car (yyval);
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			m->set_property ("elements", yyval);
			yyval = m->unprotect ();
		}
	}
#line 3829 "./out/parser.cc"
    break;

  case 91: /* identifier_init_nonumber: partial_function "\\etc"  */
#line 770 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_music_function, (yyloc),
				  scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 3838 "./out/parser.cc"
    break;

  case 92: /* partial_function_scriptable: MUSIC_FUNCTION function_arglist_partial  */
#line 780 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3846 "./out/parser.cc"
    break;

  case 93: /* partial_function_scriptable: EVENT_FUNCTION function_arglist_partial  */
#line 784 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3854 "./out/parser.cc"
    break;

  case 94: /* partial_function_scriptable: SCM_FUNCTION function_arglist_partial  */
#line 788 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3862 "./out/parser.cc"
    break;

  case 95: /* partial_function_scriptable: MUSIC_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 792 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3870 "./out/parser.cc"
    break;

  case 96: /* partial_function_scriptable: EVENT_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 796 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3878 "./out/parser.cc"
    break;

  case 97: /* partial_function_scriptable: SCM_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 800 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3886 "./out/parser.cc"
    break;

  case 98: /* partial_function_scriptable: MUSIC_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 804 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3894 "./out/parser.cc"
    break;

  case 99: /* partial_function_scriptable: EVENT_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 808 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3902 "./out/parser.cc"
    break;

  case 100: /* partial_function_scriptable: SCM_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 812 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3910 "./out/parser.cc"
    break;

  case 102: /* partial_function: "\\override" grob_prop_path '='  */
#line 820 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override_function,
					     scm_cdr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3924 "./out/parser.cc"
    break;

  case 103: /* partial_function: "\\set" context_prop_spec '='  */
#line 830 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set_function,
					     scm_cadr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3938 "./out/parser.cc"
    break;

  case 104: /* partial_function: "\\override" grob_prop_path '=' partial_function  */
#line 840 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override_function,
					     scm_cdr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3952 "./out/parser.cc"
    break;

  case 105: /* partial_function: "\\set" context_prop_spec '=' partial_function  */
#line 850 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set_function,
					     scm_cadr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3966 "./out/parser.cc"
    break;

  case 106: /* partial_function: script_dir markup_mode markup_partial_function  */
#line 861 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyvsp[-2] = SCM_INUM0;
		yyvsp[0] = MAKE_SYNTAX (partial_markup, (yylsp[0]), yyvsp[0]);
		parser->lexer_->pop_state ();
// This relies on partial_function always being followed by ETC
		yyval = scm_list_1 (scm_list_3 (MAKE_SYNTAX (partial_text_script, (yyloc), yyvsp[0]),
					     yyvsp[0], yyvsp[-2]));
	}
#line 3980 "./out/parser.cc"
    break;

  case 107: /* partial_function: script_dir partial_function_scriptable  */
#line 871 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyvsp[-1] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[-1]), yyvsp[0]);
	}
#line 3990 "./out/parser.cc"
    break;

  case 108: /* partial_function: script_dir  */
#line 877 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[0]))
			yyvsp[0] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[0]), SCM_EOL);
	}
#line 4000 "./out/parser.cc"
    break;

  case 109: /* context_def_spec_block: "\\context" '{' context_def_spec_body '}'  */
#line 886 "parser.yy"
        {
		yyval = yyvsp[-1];
		Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
		td->origin ()->set_spot ((yyloc));
	}
#line 4014 "./out/parser.cc"
    break;

  case 111: /* $@3: %empty  */
#line 900 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4022 "./out/parser.cc"
    break;

  case 112: /* context_mod_arg: $@3 composite_music  */
#line 904 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 4031 "./out/parser.cc"
    break;

  case 113: /* context_def_spec_body: %empty  */
#line 912 "parser.yy"
             {
		yyval = SCM_UNSPECIFIED;
	}
#line 4039 "./out/parser.cc"
    break;

  case 114: /* context_def_spec_body: context_def_spec_body context_mod  */
#line 915 "parser.yy"
                                            {
		if (!SCM_UNBNDP (yyvsp[0])) {
			Context_def *td = unsmob<Context_def> (yyval);
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			unsmob<Context_def> (yyval)->add_context_mod (yyvsp[0]);
		}
	}
#line 4054 "./out/parser.cc"
    break;

  case 115: /* context_def_spec_body: context_def_spec_body context_modification  */
#line 925 "parser.yy"
                                                     {
                Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
                SCM new_mods = unsmob<Context_mod> (yyvsp[0])->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
#line 4070 "./out/parser.cc"
    break;

  case 116: /* context_def_spec_body: context_def_spec_body context_mod_arg  */
#line 936 "parser.yy"
                                                {
		Context_def *td = unsmob<Context_def> (yyvsp[-1]);
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			;
		else if (!td && unsmob<Context_def> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			if (unsmob<Music> (yyvsp[0])) {
				SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
				yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
			}
			if (Context_mod *cm = unsmob<Context_mod> (yyvsp[0])) {
				for (SCM m = cm->get_mods (); scm_is_pair (m); m = scm_cdr (m)) {
					td->add_context_mod (scm_car (m));
				}
			} else
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
		}
	}
#line 4098 "./out/parser.cc"
    break;

  case 117: /* book_block: "\\book" '{' book_body '}'  */
#line 964 "parser.yy"
                                {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
#line 4109 "./out/parser.cc"
    break;

  case 118: /* book_body: %empty  */
#line 976 "parser.yy"
        {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = dynamic_cast<Output_def*> (unsmob<Output_def> (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ());
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyval);
	}
#line 4124 "./out/parser.cc"
    break;

  case 119: /* book_body: BOOK_IDENTIFIER  */
#line 986 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyvsp[0]);
	}
#line 4132 "./out/parser.cc"
    break;

  case 120: /* book_body: book_body paper_block  */
#line 989 "parser.yy"
                                {
		unsmob<Book> (yyvsp[-1])->paper_ = unsmob<Output_def> (yyvsp[0]);
		set_paper (parser, unsmob<Output_def> (yyvsp[0]));
	}
#line 4141 "./out/parser.cc"
    break;

  case 121: /* book_body: book_body bookpart_block  */
#line 993 "parser.yy"
                                   {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4150 "./out/parser.cc"
    break;

  case 122: /* book_body: book_body score_block  */
#line 997 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4159 "./out/parser.cc"
    break;

  case 123: /* book_body: book_body composite_music  */
#line 1001 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4168 "./out/parser.cc"
    break;

  case 124: /* book_body: book_body full_markup  */
#line 1005 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4177 "./out/parser.cc"
    break;

  case 125: /* book_body: book_body full_markup_list  */
#line 1009 "parser.yy"
                                     {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4186 "./out/parser.cc"
    break;

  case 126: /* book_body: book_body SCM_TOKEN  */
#line 1013 "parser.yy"
                              {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4195 "./out/parser.cc"
    break;

  case 127: /* book_body: book_body embedded_scm_active  */
#line 1018 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
				set_paper (parser, od);
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0]))
		{
			ly_module_copy (unsmob<Book> (yyvsp[-1])->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4227 "./out/parser.cc"
    break;

  case 128: /* $@4: %empty  */
#line 1046 "parser.yy"
        {
		parser->lexer_->add_scope (unsmob<Book> (yyvsp[0])->header_);
	}
#line 4235 "./out/parser.cc"
    break;

  case 130: /* book_body: book_body error  */
#line 1049 "parser.yy"
                          {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
#line 4246 "./out/parser.cc"
    break;

  case 131: /* bookpart_block: "\\bookpart" '{' bookpart_body '}'  */
#line 1058 "parser.yy"
                                       {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
#line 4256 "./out/parser.cc"
    break;

  case 132: /* bookpart_body: %empty  */
#line 1066 "parser.yy"
        {
		Book *book = new Book;
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyval);
	}
#line 4266 "./out/parser.cc"
    break;

  case 133: /* bookpart_body: BOOK_IDENTIFIER  */
#line 1071 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyvsp[0]);
	}
#line 4274 "./out/parser.cc"
    break;

  case 134: /* bookpart_body: bookpart_body paper_block  */
#line 1074 "parser.yy"
                                    {
		unsmob<Book> (yyval)->paper_ = unsmob<Output_def> (yyvsp[0]);
	}
#line 4282 "./out/parser.cc"
    break;

  case 135: /* bookpart_body: bookpart_body score_block  */
#line 1077 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4291 "./out/parser.cc"
    break;

  case 136: /* bookpart_body: bookpart_body composite_music  */
#line 1081 "parser.yy"
                                        {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4300 "./out/parser.cc"
    break;

  case 137: /* bookpart_body: bookpart_body full_markup  */
#line 1085 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4309 "./out/parser.cc"
    break;

  case 138: /* bookpart_body: bookpart_body full_markup_list  */
#line 1089 "parser.yy"
                                         {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4318 "./out/parser.cc"
    break;

  case 139: /* bookpart_body: bookpart_body SCM_TOKEN  */
#line 1093 "parser.yy"
                                  {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4327 "./out/parser.cc"
    break;

  case 140: /* bookpart_body: bookpart_body embedded_scm_active  */
#line 1098 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0])) {
			Book *book = unsmob<Book> (yyvsp[-1]);
			if (!ly_is_module (book->header_))
				book->header_ = ly_make_module (false);
			ly_module_copy (book->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4360 "./out/parser.cc"
    break;

  case 141: /* $@5: %empty  */
#line 1127 "parser.yy"
        {
                Book *book = unsmob<Book> (yyvsp[0]);
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
#line 4371 "./out/parser.cc"
    break;

  case 143: /* bookpart_body: bookpart_body error  */
#line 1133 "parser.yy"
                              {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
#line 4381 "./out/parser.cc"
    break;

  case 144: /* score_block: "\\score" '{' score_body '}'  */
#line 1141 "parser.yy"
                                        {
		unsmob<Score> (yyvsp[-1])->origin ()->set_spot ((yyloc));
		yyval = yyvsp[-1];
	}
#line 4390 "./out/parser.cc"
    break;

  case 145: /* score_body: score_items  */
#line 1148 "parser.yy"
                    {
		if (!unsmob<Score> (yyvsp[0])) {
			parser->parser_error ((yylsp[0]), _("Missing music in \\score"));
			yyval = (new Score)->unprotect ();
			if (scm_is_pair (yyvsp[0]) && ly_is_module (scm_car (yyvsp[0])))
			{
				unsmob<Score> (yyval)->set_header (scm_car (yyvsp[0]));
				yyvsp[0] = scm_cdr (yyvsp[0]);
			}
			for (SCM p = scm_reverse_x (yyvsp[0], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				unsmob<Score> (yyval)->
					add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
	}
#line 4412 "./out/parser.cc"
    break;

  case 146: /* score_body: score_body error  */
#line 1165 "parser.yy"
                           {
		unsmob<Score> (yyval)->error_found_ = true;
	}
#line 4420 "./out/parser.cc"
    break;

  case 150: /* score_items: %empty  */
#line 1178 "parser.yy"
        {
		yyval = SCM_EOL;
	}
#line 4428 "./out/parser.cc"
    break;

  case 151: /* score_items: score_items score_item  */
#line 1182 "parser.yy"
        {
		Output_def *od = unsmob<Output_def> (yyvsp[0]);
		if (od) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
			{
				parser->parser_error ((yylsp[0]), _("\\paper cannot be used in \\score, use \\layout instead"));
				od = 0;
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		} else if (!unsmob<Score> (yyval)) {
			if (unsmob<Music> (yyvsp[0])) {
				yyvsp[0] = Lily::scorify_music (yyvsp[0]);
			}
			if (unsmob<Score> (yyvsp[0]))
			{
				yyval = yyvsp[0];
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		}
		Score *score = unsmob<Score> (yyval);
		if (score && scm_is_pair (yyvsp[-1])) {
			if (ly_is_module (scm_car (yyvsp[-1])))
			{
				score->set_header (scm_car (yyvsp[-1]));
				yyvsp[-1] = scm_cdr (yyvsp[-1]);
			}
			for (SCM p = scm_reverse_x (yyvsp[-1], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				score->add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
		if (od) {
			if (score)
				score->add_output_def (od);
			else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				scm_set_cdr_x (yyval, scm_cons (yyvsp[0], scm_cdr (yyval)));
			else
				yyval = scm_cons (yyvsp[0], yyval);
		} else if (ly_is_module (yyvsp[0])) {
			SCM module = SCM_UNSPECIFIED;
			if (score) {
				module = score->get_header ();
				if (!ly_is_module (module))
				{
					module = ly_make_module (false);
					score->set_header (module);
				}
			} else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				module = scm_car (yyval);
			else {
				module = ly_make_module (false);
				yyval = scm_cons (module, yyval);
			}
			ly_module_copy (module, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("Spurious expression in \\score"));
	}
#line 4491 "./out/parser.cc"
    break;

  case 152: /* $@6: %empty  */
#line 1241 "parser.yy"
        {
		if (Score *score = unsmob<Score> (yyvsp[0])) {
			if (!ly_is_module (score->get_header ()))
				score->set_header (ly_make_module (false));
			parser->lexer_->add_scope (score->get_header ());
		} else {
			if (!scm_is_pair (yyvsp[0]) || !ly_is_module (scm_car (yyvsp[0])))
				yyvsp[0] = scm_cons (ly_make_module (false), yyvsp[0]);
			parser->lexer_->add_scope (scm_car (yyvsp[0]));
		}
	}
#line 4507 "./out/parser.cc"
    break;

  case 153: /* score_items: score_items $@6 lilypond_header  */
#line 1252 "parser.yy"
        {
		yyval = yyvsp[-2];
	}
#line 4515 "./out/parser.cc"
    break;

  case 154: /* paper_block: output_def  */
#line 1263 "parser.yy"
                   {
                Output_def *od = unsmob<Output_def> (yyvsp[0]);

		if (!to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
		{
			parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			yyval = get_paper (parser)->unprotect ();
		}
	}
#line 4529 "./out/parser.cc"
    break;

  case 155: /* output_def: output_def_body '}'  */
#line 1276 "parser.yy"
                            {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
#line 4541 "./out/parser.cc"
    break;

  case 156: /* output_def_head: "\\paper"  */
#line 1286 "parser.yy"
              {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                yyval = p->unprotect ();
	}
#line 4552 "./out/parser.cc"
    break;

  case 157: /* output_def_head: "\\midi"  */
#line 1292 "parser.yy"
                  {
		Output_def *p = get_midi (parser);
		yyval = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
#line 4562 "./out/parser.cc"
    break;

  case 158: /* output_def_head: "\\layout"  */
#line 1297 "parser.yy"
                        {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		yyval = p->unprotect ();
	}
#line 4573 "./out/parser.cc"
    break;

  case 159: /* output_def_head_with_mode_switch: output_def_head  */
#line 1306 "parser.yy"
                        {
		parser->lexer_->push_initial_state ();
		yyval = yyvsp[0];
	}
#line 4582 "./out/parser.cc"
    break;

  case 162: /* output_def_body: output_def_head_with_mode_switch '{'  */
#line 1323 "parser.yy"
                                             {
		unsmob<Output_def> (yyvsp[-1])->input_origin_.set_spot ((yyloc));
		// This is a stupid trick to mark the beginning of the
		// body for deciding whether to allow
		// embedded_scm_active to have an output definition
		yyval = scm_list_1 (yyvsp[-1]);
	}
#line 4594 "./out/parser.cc"
    break;

  case 163: /* output_def_body: output_def_body assignment  */
#line 1330 "parser.yy"
                                      {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
	}
#line 4603 "./out/parser.cc"
    break;

  case 164: /* output_def_body: output_def_body embedded_scm_active  */
#line 1335 "parser.yy"
        {
		// We don't switch into note mode for Scheme functions
		// here.  Does not seem warranted/required in output
		// definitions.
		if (scm_is_pair (yyvsp[-1]))
		{
			Output_def *o = unsmob<Output_def> (yyvsp[0]);
			if (o) {
				o->input_origin_.set_spot ((yyloc));
				yyvsp[-1] = o->self_scm ();
				parser->lexer_->remove_scope ();
				parser->lexer_->add_scope (o->scope_);
				yyvsp[0] = SCM_UNSPECIFIED;
			} else
				yyvsp[-1] = scm_car (yyvsp[-1]);
		}
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-1]), yyvsp[0]);
		// Seems unlikely, but let's be complete:
		else if (unsmob<Music> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier
				("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
		yyval = yyvsp[-1];
	}
#line 4636 "./out/parser.cc"
    break;

  case 165: /* output_def_body: output_def_body SCM_TOKEN  */
#line 1363 "parser.yy"
                                    {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4647 "./out/parser.cc"
    break;

  case 166: /* $@7: %empty  */
#line 1370 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyvsp[0] = scm_car (yyvsp[0]);
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4657 "./out/parser.cc"
    break;

  case 167: /* output_def_body: output_def_body $@7 music_or_context_def  */
#line 1375 "parser.yy"
        {
		parser->lexer_->pop_state ();
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-2]), yyvsp[0]);
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-2], yyvsp[0]);
		}
		yyval = yyvsp[-2];
	}
#line 4674 "./out/parser.cc"
    break;

  case 168: /* output_def_body: output_def_body error  */
#line 1387 "parser.yy"
                                {

	}
#line 4682 "./out/parser.cc"
    break;

  case 169: /* tempo_event: "\\tempo" steno_duration '=' tempo_range  */
#line 1393 "parser.yy"
                                                {
		yyval = MAKE_SYNTAX (tempo, (yyloc), SCM_EOL, yyvsp[-2], yyvsp[0]);
	}
#line 4690 "./out/parser.cc"
    break;

  case 170: /* tempo_event: "\\tempo" text steno_duration '=' tempo_range  */
#line 1396 "parser.yy"
                                                        {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4698 "./out/parser.cc"
    break;

  case 171: /* tempo_event: "\\tempo" text  */
#line 1399 "parser.yy"
                     {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[0]);
	}
#line 4706 "./out/parser.cc"
    break;

  case 172: /* music_list: %empty  */
#line 1408 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 4714 "./out/parser.cc"
    break;

  case 173: /* music_list: music_list music_embedded  */
#line 1411 "parser.yy"
                                    {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 4723 "./out/parser.cc"
    break;

  case 174: /* music_list: music_list error  */
#line 1415 "parser.yy"
                           {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		m->set_property ("error-found", SCM_BOOL_T);
		yyval = scm_cons (m->self_scm (), yyvsp[-1]);
		m->unprotect (); /* UGH */
	}
#line 4735 "./out/parser.cc"
    break;

  case 175: /* braced_music_list: '{' music_list '}'  */
#line 1426 "parser.yy"
        {
		yyval = reverse_music_list (parser, (yyloc), yyvsp[-1], true, false);
	}
#line 4743 "./out/parser.cc"
    break;

  case 179: /* pitch_as_music: pitch_or_music  */
#line 1438 "parser.yy"
        {
	        yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
                if (!unsmob<Music> (yyval))
		{
                        parser->parser_error ((yylsp[0]), _ ("music expected"));
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		}
	}
#line 4756 "./out/parser.cc"
    break;

  case 182: /* music_embedded: music_embedded_backup  */
#line 1452 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4764 "./out/parser.cc"
    break;

  case 183: /* music_embedded: music_embedded_backup "(backed-up?)" lyric_element_music  */
#line 1456 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4772 "./out/parser.cc"
    break;

  case 184: /* music_embedded: multiplied_duration post_events  */
#line 1460 "parser.yy"
        {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

		parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
		n->set_property ("duration", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0]))
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
		yyval = n->unprotect ();
	}
#line 4788 "./out/parser.cc"
    break;

  case 185: /* music_embedded_backup: embedded_scm  */
#line 1475 "parser.yy"
        {
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED)
		    || unsmob<Music> (yyvsp[0]))
			yyval = yyvsp[0];
		else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (LYRIC_ELEMENT, yyvsp[0], (yylsp[0]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			yyval = SCM_UNSPECIFIED;
		}
	}
#line 4805 "./out/parser.cc"
    break;

  case 188: /* repeated_music: "\\repeat" simple_string unsigned_number music  */
#line 1498 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 4813 "./out/parser.cc"
    break;

  case 189: /* repeated_music: "\\repeat" simple_string unsigned_number music "\\alternative" braced_music_list  */
#line 1502 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4821 "./out/parser.cc"
    break;

  case 190: /* sequential_music: "\\sequential" braced_music_list  */
#line 1508 "parser.yy"
                                     {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4829 "./out/parser.cc"
    break;

  case 191: /* sequential_music: braced_music_list  */
#line 1511 "parser.yy"
                            {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4837 "./out/parser.cc"
    break;

  case 192: /* simultaneous_music: "\\simultaneous" braced_music_list  */
#line 1517 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc), yyvsp[0]);
	}
#line 4845 "./out/parser.cc"
    break;

  case 193: /* simultaneous_music: "<<" music_list ">>"  */
#line 1520 "parser.yy"
                                                                {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc),
				  reverse_music_list (parser, (yyloc), yyvsp[-1],
						      true, false));
	}
#line 4855 "./out/parser.cc"
    break;

  case 197: /* $@8: %empty  */
#line 1535 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4863 "./out/parser.cc"
    break;

  case 198: /* context_modification: "\\with" $@8 '{' context_mod_list '}'  */
#line 1538 "parser.yy"
        {
                parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
        }
#line 4872 "./out/parser.cc"
    break;

  case 199: /* context_modification: "\\with" context_modification_arg  */
#line 1543 "parser.yy"
        {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			// let's permit \with #*unspecified* to go for
			// an empty context mod
			if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
			yyval = Context_mod ().smobbed_copy ();
		}
	}
#line 4892 "./out/parser.cc"
    break;

  case 202: /* optional_context_mods: context_modification_mods_list  */
#line 1571 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyval = scm_append_x (scm_reverse_x (yyvsp[0], SCM_EOL));
        }
#line 4901 "./out/parser.cc"
    break;

  case 203: /* context_modification_mods_list: %empty  */
#line 1584 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 4909 "./out/parser.cc"
    break;

  case 204: /* context_modification_mods_list: context_modification_mods_list context_modification  */
#line 1588 "parser.yy"
        {
		if (Context_mod *m = unsmob<Context_mod> (yyvsp[0]))
			yyval = scm_cons (m->get_mods (), yyvsp[-1]);
	}
#line 4918 "./out/parser.cc"
    break;

  case 205: /* context_mod_list: %empty  */
#line 1600 "parser.yy"
             {
            yyval = Context_mod ().smobbed_copy ();
        }
#line 4926 "./out/parser.cc"
    break;

  case 206: /* context_mod_list: context_mod_list context_mod  */
#line 1603 "parser.yy"
                                        {
		if (!SCM_UNBNDP (yyvsp[0]))
			unsmob<Context_mod> (yyvsp[-1])->add_context_mod (yyvsp[0]);
        }
#line 4935 "./out/parser.cc"
    break;

  case 207: /* context_mod_list: context_mod_list context_mod_arg  */
#line 1607 "parser.yy"
                                           {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			unsmob<Context_mod> (yyval)->add_context_mods
				(unsmob<Context_mod> (yyvsp[0])->get_mods ());
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _ ("not a context mod"));
        }
#line 4951 "./out/parser.cc"
    break;

  case 208: /* context_prefix: "\\context" symbol optional_id optional_context_mods  */
#line 1621 "parser.yy"
                                                         {
		yyval = START_MAKE_SYNTAX (context_specification, yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_BOOL_F);
	}
#line 4959 "./out/parser.cc"
    break;

  case 209: /* context_prefix: "\\new" symbol optional_id optional_context_mods  */
#line 1624 "parser.yy"
                                                              {
		yyval = START_MAKE_SYNTAX (context_specification, yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_BOOL_T);
	}
#line 4967 "./out/parser.cc"
    break;

  case 210: /* new_lyrics: "\\addlyrics" optional_context_mods lyric_mode_music  */
#line 1630 "parser.yy"
                                                         {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], SCM_EOL);
	}
#line 4975 "./out/parser.cc"
    break;

  case 211: /* new_lyrics: new_lyrics "\\addlyrics" optional_context_mods lyric_mode_music  */
#line 1633 "parser.yy"
                                                                      {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], yyvsp[-3]);
	}
#line 4983 "./out/parser.cc"
    break;

  case 215: /* basic_music: "\\lyricsto" simple_string lyric_mode_music  */
#line 1658 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], SCM_EOL, yyvsp[0]);
	}
#line 4991 "./out/parser.cc"
    break;

  case 216: /* basic_music: "\\lyricsto" symbol '=' simple_string lyric_mode_music  */
#line 1662 "parser.yy"
        {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], yyvsp[-3], yyvsp[0]);
	}
#line 4999 "./out/parser.cc"
    break;

  case 220: /* contexted_basic_music: context_prefix contextable_music new_lyrics  */
#line 1675 "parser.yy"
        {
		Input i;
		i.set_location ((yylsp[-2]), (yylsp[-1]));
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-2], i, yyvsp[-1]);
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyval, scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5010 "./out/parser.cc"
    break;

  case 221: /* contexted_basic_music: context_prefix contextable_music  */
#line 1682 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 5018 "./out/parser.cc"
    break;

  case 222: /* contexted_basic_music: context_prefix contexted_basic_music  */
#line 1686 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 5026 "./out/parser.cc"
    break;

  case 225: /* composite_music: basic_music new_lyrics  */
#line 1695 "parser.yy"
        {
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5034 "./out/parser.cc"
    break;

  case 229: /* grouped_music_list: simultaneous_music  */
#line 1707 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 5040 "./out/parser.cc"
    break;

  case 230: /* grouped_music_list: sequential_music  */
#line 1708 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 5046 "./out/parser.cc"
    break;

  case 232: /* symbol_list_arg: SYMBOL_LIST '.' symbol_list_rev  */
#line 1767 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 5054 "./out/parser.cc"
    break;

  case 233: /* symbol_list_arg: SYMBOL_LIST ',' symbol_list_rev  */
#line 1771 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 5062 "./out/parser.cc"
    break;

  case 235: /* symbol_list_rev: symbol_list_rev '.' symbol_list_part  */
#line 1779 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 5070 "./out/parser.cc"
    break;

  case 236: /* symbol_list_rev: symbol_list_rev ',' symbol_list_part  */
#line 1783 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 5078 "./out/parser.cc"
    break;

  case 238: /* symbol_list_part: embedded_scm_bare  */
#line 1793 "parser.yy"
        {
		yyval = make_reverse_key_list (yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		}
	}
#line 5090 "./out/parser.cc"
    break;

  case 239: /* symbol_list_element: STRING  */
#line 1805 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 5098 "./out/parser.cc"
    break;

  case 241: /* symbol_list_part_bare: SYMBOL  */
#line 1814 "parser.yy"
        {
		yyval = try_word_variants (Lily::key_list_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		} else
			yyval = scm_reverse (yyval);
	}
#line 5111 "./out/parser.cc"
    break;

  case 242: /* symbol_list_part_bare: symbol_list_element  */
#line 1823 "parser.yy"
        {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 5119 "./out/parser.cc"
    break;

  case 244: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup post_event_nofinger  */
#line 1831 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5127 "./out/parser.cc"
    break;

  case 245: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' UNSIGNED  */
#line 1835 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			yyval = scm_cons (n, yyvsp[-2]);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = check_scheme_arg (parser, (yylsp[-1]), t->unprotect (),
					       yyvsp[-2], yyvsp[-3], n);
		}
	}
#line 5143 "./out/parser.cc"
    break;

  case 246: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' REAL  */
#line 1847 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 5153 "./out/parser.cc"
    break;

  case 247: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' NUMBER_IDENTIFIER  */
#line 1853 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 5163 "./out/parser.cc"
    break;

  case 248: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup embedded_scm_arg  */
#line 1859 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 5177 "./out/parser.cc"
    break;

  case 249: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup bare_number_common  */
#line 1869 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5185 "./out/parser.cc"
    break;

  case 250: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" pitch_or_music  */
#line 1873 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5199 "./out/parser.cc"
    break;

  case 251: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" multiplied_duration  */
#line 1883 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5207 "./out/parser.cc"
    break;

  case 252: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" reparsed_rhythm  */
#line 1887 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5215 "./out/parser.cc"
    break;

  case 253: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" bare_number_common  */
#line 1891 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5223 "./out/parser.cc"
    break;

  case 254: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" SCM_ARG  */
#line 1895 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5231 "./out/parser.cc"
    break;

  case 255: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" lyric_element_music  */
#line 1899 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5239 "./out/parser.cc"
    break;

  case 256: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" symbol_list_arg  */
#line 1903 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5247 "./out/parser.cc"
    break;

  case 257: /* reparsed_rhythm: DURATION_ARG dots multipliers post_events  */
#line 1911 "parser.yy"
        {
		yyval = make_music_from_simple (parser, (yyloc),
					     make_duration (yyvsp[-3], scm_to_int (yyvsp[-2]), yyvsp[-1]));
		Music *m = unsmob<Music> (yyval);
		assert (m);
		if (scm_is_pair (yyvsp[0]))
			m->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5261 "./out/parser.cc"
    break;

  case 258: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup SCM_IDENTIFIER  */
#line 1924 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5282 "./out/parser.cc"
    break;

  case 259: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup pitch  */
#line 1941 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5297 "./out/parser.cc"
    break;

  case 260: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup steno_tonic_pitch  */
#line 1952 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5312 "./out/parser.cc"
    break;

  case 261: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup STRING  */
#line 1963 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5333 "./out/parser.cc"
    break;

  case 262: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup SYMBOL  */
#line 1980 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5354 "./out/parser.cc"
    break;

  case 263: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup full_markup  */
#line 1997 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5371 "./out/parser.cc"
    break;

  case 264: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup UNSIGNED  */
#line 2010 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5398 "./out/parser.cc"
    break;

  case 265: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup DURATION_IDENTIFIER  */
#line 2033 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5414 "./out/parser.cc"
    break;

  case 267: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup embedded_scm_arg  */
#line 2052 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
			if (scm_is_true (scm_call_1 (yyvsp[-2], yyval)))
				yyval = scm_cons (yyval, yyvsp[-1]);
			else
			{
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5433 "./out/parser.cc"
    break;

  case 268: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup post_event_nofinger  */
#line 2067 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (EVENT_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5447 "./out/parser.cc"
    break;

  case 269: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup pitch  */
#line 2077 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (PITCH_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5467 "./out/parser.cc"
    break;

  case 270: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup steno_tonic_pitch  */
#line 2093 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (TONICNAME_PITCH, yyvsp[0], (yylsp[0]));
		}
	}
#line 5487 "./out/parser.cc"
    break;

  case 271: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup full_markup  */
#line 2109 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5500 "./out/parser.cc"
    break;

  case 272: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup UNSIGNED  */
#line 2118 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else {
					yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
					MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				}
			} else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5531 "./out/parser.cc"
    break;

  case 273: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup REAL  */
#line 2145 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (REAL, yyvsp[0], (yylsp[0]));
		}
	}
#line 5546 "./out/parser.cc"
    break;

  case 274: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup NUMBER_IDENTIFIER  */
#line 2156 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (NUMBER_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5560 "./out/parser.cc"
    break;

  case 275: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' UNSIGNED  */
#line 2166 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = yyvsp[-2];
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], yyval)))
				yyval = scm_cons (yyval, yyvsp[-2]);
			else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				parser->lexer_->push_extra_token ((yylsp[-1]), '-');
			}
		}
	}
#line 5583 "./out/parser.cc"
    break;

  case 276: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' REAL  */
#line 2185 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
			yyval = yyvsp[-2];
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (REAL, n, (yylsp[0]));
		}
	}
#line 5598 "./out/parser.cc"
    break;

  case 277: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' NUMBER_IDENTIFIER  */
#line 2196 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = scm_cons (n, yyvsp[-2]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[0]));
		}
	}
#line 5612 "./out/parser.cc"
    break;

  case 278: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup DURATION_IDENTIFIER  */
#line 2206 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (DURATION_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5630 "./out/parser.cc"
    break;

  case 279: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup SCM_IDENTIFIER  */
#line 2220 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5649 "./out/parser.cc"
    break;

  case 280: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup STRING  */
#line 2235 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5668 "./out/parser.cc"
    break;

  case 281: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup SYMBOL  */
#line 2250 "parser.yy"
        {
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5687 "./out/parser.cc"
    break;

  case 282: /* function_arglist_backup: function_arglist_backup "(reparsed?)" pitch_or_music  */
#line 2265 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5701 "./out/parser.cc"
    break;

  case 283: /* function_arglist_backup: function_arglist_backup "(reparsed?)" bare_number_common  */
#line 2275 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5710 "./out/parser.cc"
    break;

  case 284: /* function_arglist_backup: function_arglist_backup "(reparsed?)" multiplied_duration  */
#line 2280 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5719 "./out/parser.cc"
    break;

  case 285: /* function_arglist_backup: function_arglist_backup "(reparsed?)" reparsed_rhythm  */
#line 2285 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5728 "./out/parser.cc"
    break;

  case 286: /* function_arglist_backup: function_arglist_backup "(reparsed?)" symbol_list_arg  */
#line 2290 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5736 "./out/parser.cc"
    break;

  case 288: /* function_arglist: "optional?" "scheme?" function_arglist_skip_nonbackup "\\default"  */
#line 2298 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5744 "./out/parser.cc"
    break;

  case 290: /* function_arglist_skip_nonbackup: "optional?" "scheme?" function_arglist_skip_nonbackup  */
#line 2306 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5752 "./out/parser.cc"
    break;

  case 291: /* function_arglist_partial: "scheme?" function_arglist_optional  */
#line 2325 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5760 "./out/parser.cc"
    break;

  case 292: /* function_arglist_partial: "scheme?" function_arglist_partial_optional  */
#line 2329 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5768 "./out/parser.cc"
    break;

  case 293: /* function_arglist_partial: "optional?" "scheme?" function_arglist_nonbackup  */
#line 2333 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5776 "./out/parser.cc"
    break;

  case 294: /* function_arglist_partial: "optional?" "scheme?" function_arglist_partial  */
#line 2337 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5784 "./out/parser.cc"
    break;

  case 295: /* function_arglist_partial_optional: "scheme?" function_arglist_optional  */
#line 2344 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5792 "./out/parser.cc"
    break;

  case 296: /* function_arglist_partial_optional: "scheme?" function_arglist_partial_optional  */
#line 2348 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5800 "./out/parser.cc"
    break;

  case 297: /* function_arglist_partial_optional: "optional?" "scheme?" function_arglist_backup  */
#line 2352 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5808 "./out/parser.cc"
    break;

  case 298: /* function_arglist_partial_optional: "optional?" "scheme?" function_arglist_partial_optional  */
#line 2356 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5816 "./out/parser.cc"
    break;

  case 299: /* function_arglist_common: EXPECT_NO_MORE_ARGS  */
#line 2362 "parser.yy"
                            {
		yyval = SCM_EOL;
	}
#line 5824 "./out/parser.cc"
    break;

  case 300: /* function_arglist_common: "scheme?" function_arglist_optional embedded_scm_arg  */
#line 2366 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 5838 "./out/parser.cc"
    break;

  case 301: /* function_arglist_common: "scheme?" function_arglist_optional bare_number_common  */
#line 2376 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5847 "./out/parser.cc"
    break;

  case 302: /* function_arglist_common: "scheme?" function_arglist_optional post_event_nofinger  */
#line 2381 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5856 "./out/parser.cc"
    break;

  case 303: /* function_arglist_common: "scheme?" function_arglist_optional '-' NUMBER_IDENTIFIER  */
#line 2386 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		yyval = check_scheme_arg (parser, (yylsp[0]), n, yyvsp[-2], yyvsp[-3]);
	}
#line 5865 "./out/parser.cc"
    break;

  case 304: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" SCM_ARG  */
#line 2391 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5874 "./out/parser.cc"
    break;

  case 305: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" lyric_element_music  */
#line 2396 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5883 "./out/parser.cc"
    break;

  case 306: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" pitch_or_music  */
#line 2401 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5897 "./out/parser.cc"
    break;

  case 307: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" bare_number_common  */
#line 2411 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5906 "./out/parser.cc"
    break;

  case 308: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" multiplied_duration  */
#line 2416 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5915 "./out/parser.cc"
    break;

  case 309: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" reparsed_rhythm  */
#line 2421 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5924 "./out/parser.cc"
    break;

  case 310: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" symbol_list_arg  */
#line 2426 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5932 "./out/parser.cc"
    break;

  case 311: /* function_arglist_common_reparse: "scheme?" function_arglist_optional SCM_IDENTIFIER  */
#line 2433 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5954 "./out/parser.cc"
    break;

  case 312: /* function_arglist_common_reparse: "scheme?" function_arglist_optional pitch  */
#line 2451 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5969 "./out/parser.cc"
    break;

  case 313: /* function_arglist_common_reparse: "scheme?" function_arglist_optional steno_tonic_pitch  */
#line 2462 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5984 "./out/parser.cc"
    break;

  case 314: /* function_arglist_common_reparse: "scheme?" function_arglist_optional STRING  */
#line 2473 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6006 "./out/parser.cc"
    break;

  case 315: /* function_arglist_common_reparse: "scheme?" function_arglist_optional SYMBOL  */
#line 2491 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6028 "./out/parser.cc"
    break;

  case 316: /* function_arglist_common_reparse: "scheme?" function_arglist_optional full_markup  */
#line 2509 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6046 "./out/parser.cc"
    break;

  case 317: /* function_arglist_common_reparse: "scheme?" function_arglist_optional UNSIGNED  */
#line 2523 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 6073 "./out/parser.cc"
    break;

  case 318: /* function_arglist_common_reparse: "scheme?" function_arglist_optional DURATION_IDENTIFIER  */
#line 2546 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 6089 "./out/parser.cc"
    break;

  case 319: /* function_arglist_common_reparse: "scheme?" function_arglist_optional '-' UNSIGNED  */
#line 2558 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], m)))
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, m);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, yyvsp[0]);
		}
	}
#line 6109 "./out/parser.cc"
    break;

  case 320: /* function_arglist_common_reparse: "scheme?" function_arglist_optional '-' REAL  */
#line 2574 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
	}
#line 6119 "./out/parser.cc"
    break;

  case 322: /* function_arglist_optional: "optional?" "scheme?" function_arglist_skip_backup "\\default"  */
#line 2584 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 6127 "./out/parser.cc"
    break;

  case 325: /* function_arglist_skip_backup: "optional?" "scheme?" function_arglist_skip_backup  */
#line 2593 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 6135 "./out/parser.cc"
    break;

  case 326: /* music_function_call: MUSIC_FUNCTION function_arglist  */
#line 2599 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6144 "./out/parser.cc"
    break;

  case 327: /* optional_id: %empty  */
#line 2607 "parser.yy"
             { yyval = SCM_EOL; }
#line 6150 "./out/parser.cc"
    break;

  case 328: /* optional_id: '=' simple_string  */
#line 2608 "parser.yy"
                            {
		yyval = yyvsp[0];
	}
#line 6158 "./out/parser.cc"
    break;

  case 329: /* $@9: %empty  */
#line 2620 "parser.yy"
        {
		parser->lexer_->push_lyric_state ();
	}
#line 6166 "./out/parser.cc"
    break;

  case 330: /* lyric_mode_music: $@9 grouped_music_list  */
#line 2623 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 6175 "./out/parser.cc"
    break;

  case 332: /* mode_changed_music: mode_changing_head grouped_music_list  */
#line 2631 "parser.yy"
                                              {
		if (scm_is_eq (yyvsp[-1], ly_symbol2scm ("chords")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyvsp[0]);
		}
		else
		{
		  yyval = yyvsp[0];
		}
		parser->lexer_->pop_state ();
	}
#line 6191 "./out/parser.cc"
    break;

  case 333: /* mode_changed_music: mode_changing_head_with_context optional_context_mods grouped_music_list  */
#line 2642 "parser.yy"
                                                                                   {
		yyval = MAKE_SYNTAX (context_specification, (yyloc), yyvsp[-2], SCM_EOL, yyvsp[-1], SCM_BOOL_T, yyvsp[0]);
		if (scm_is_eq (yyvsp[-2], ly_symbol2scm ("ChordNames")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyval);
		}
		parser->lexer_->pop_state ();
	}
#line 6204 "./out/parser.cc"
    break;

  case 334: /* mode_changing_head: "\\notemode"  */
#line 2653 "parser.yy"
                 {
		parser->lexer_->push_note_state (Lily::pitchnames);

		yyval = ly_symbol2scm ("notes");
	}
#line 6214 "./out/parser.cc"
    break;

  case 335: /* mode_changing_head: "\\drummode"  */
#line 2659 "parser.yy"
                {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("drums");
	}
#line 6224 "./out/parser.cc"
    break;

  case 336: /* mode_changing_head: "\\figuremode"  */
#line 2664 "parser.yy"
                     {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("figures");
	}
#line 6234 "./out/parser.cc"
    break;

  case 337: /* mode_changing_head: "\\chordmode"  */
#line 2669 "parser.yy"
                    {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("chords");

	}
#line 6246 "./out/parser.cc"
    break;

  case 338: /* mode_changing_head: "\\lyricmode"  */
#line 2677 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("lyrics");
	}
#line 6254 "./out/parser.cc"
    break;

  case 339: /* mode_changing_head_with_context: "\\drums"  */
#line 2683 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("DrumStaff");
	}
#line 6264 "./out/parser.cc"
    break;

  case 340: /* mode_changing_head_with_context: "\\figures"  */
#line 2688 "parser.yy"
                  {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("FiguredBass");
	}
#line 6274 "./out/parser.cc"
    break;

  case 341: /* mode_changing_head_with_context: "\\chords"  */
#line 2693 "parser.yy"
                 {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("ChordNames");
	}
#line 6285 "./out/parser.cc"
    break;

  case 342: /* mode_changing_head_with_context: "\\lyrics"  */
#line 2700 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("Lyrics");
	}
#line 6293 "./out/parser.cc"
    break;

  case 343: /* context_change: "\\change" symbol '=' simple_string  */
#line 2706 "parser.yy"
                                         {
		yyval = MAKE_SYNTAX (context_change, (yyloc), yyvsp[-2], yyvsp[0]);
	}
#line 6301 "./out/parser.cc"
    break;

  case 344: /* property_path: symbol_list_rev  */
#line 2713 "parser.yy"
                         {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 6309 "./out/parser.cc"
    break;

  case 345: /* property_operation: symbol '=' scalar  */
#line 2719 "parser.yy"
                          {
		yyval = scm_list_3 (ly_symbol2scm ("assign"), yyvsp[-2], yyvsp[0]);
	}
#line 6317 "./out/parser.cc"
    break;

  case 346: /* property_operation: "\\unset" symbol  */
#line 2722 "parser.yy"
                       {
		yyval = scm_list_2 (ly_symbol2scm ("unset"), yyvsp[0]);
	}
#line 6325 "./out/parser.cc"
    break;

  case 347: /* property_operation: "\\override" revert_arg '=' scalar  */
#line 2725 "parser.yy"
                                         {
		if (scm_ilength (yyvsp[-2]) < 2) {
			parser->parser_error ((yylsp[-2]), _("bad grob property path"));
			yyval = SCM_UNDEFINED;
		} else {
			yyval = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car (yyvsp[-2]),
						  yyvsp[0],
						  scm_cdr (yyvsp[-2])));
		}
	}
#line 6341 "./out/parser.cc"
    break;

  case 348: /* property_operation: "\\revert" revert_arg  */
#line 2736 "parser.yy"
                            {
		yyval = scm_cons (ly_symbol2scm ("pop"), yyvsp[0]);
	}
#line 6349 "./out/parser.cc"
    break;

  case 349: /* revert_arg: revert_arg_backup "(backed-up?)" symbol_list_arg  */
#line 2766 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 6357 "./out/parser.cc"
    break;

  case 350: /* revert_arg_backup: revert_arg_part  */
#line 2773 "parser.yy"
        {
		if (scm_is_null (yyvsp[0])
		    || scm_is_null (scm_cdr (yyvsp[0])))
			MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x (yyvsp[0], SCM_EOL), (yylsp[0]));
	}
#line 6369 "./out/parser.cc"
    break;

  case 352: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG '.' symbol_list_part  */
#line 2786 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6377 "./out/parser.cc"
    break;

  case 353: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG ',' symbol_list_part  */
#line 2790 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6385 "./out/parser.cc"
    break;

  case 354: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG symbol_list_part  */
#line 2794 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-1]));
	}
#line 6393 "./out/parser.cc"
    break;

  case 355: /* context_def_mod: "\\consists"  */
#line 2800 "parser.yy"
                 { yyval = ly_symbol2scm ("consists"); }
#line 6399 "./out/parser.cc"
    break;

  case 356: /* context_def_mod: "\\remove"  */
#line 2801 "parser.yy"
                 { yyval = ly_symbol2scm ("remove"); }
#line 6405 "./out/parser.cc"
    break;

  case 357: /* context_def_mod: "\\accepts"  */
#line 2803 "parser.yy"
                  { yyval = ly_symbol2scm ("accepts"); }
#line 6411 "./out/parser.cc"
    break;

  case 358: /* context_def_mod: "\\defaultchild"  */
#line 2804 "parser.yy"
                       { yyval = ly_symbol2scm ("default-child"); }
#line 6417 "./out/parser.cc"
    break;

  case 359: /* context_def_mod: "\\denies"  */
#line 2805 "parser.yy"
                 { yyval = ly_symbol2scm ("denies"); }
#line 6423 "./out/parser.cc"
    break;

  case 360: /* context_def_mod: "\\alias"  */
#line 2807 "parser.yy"
                { yyval = ly_symbol2scm ("alias"); }
#line 6429 "./out/parser.cc"
    break;

  case 361: /* context_def_mod: "\\type"  */
#line 2808 "parser.yy"
               { yyval = ly_symbol2scm ("translator-type"); }
#line 6435 "./out/parser.cc"
    break;

  case 362: /* context_def_mod: "\\description"  */
#line 2809 "parser.yy"
                      { yyval = ly_symbol2scm ("description"); }
#line 6441 "./out/parser.cc"
    break;

  case 363: /* context_def_mod: "\\name"  */
#line 2810 "parser.yy"
               { yyval = ly_symbol2scm ("context-name"); }
#line 6447 "./out/parser.cc"
    break;

  case 364: /* context_mod: property_operation  */
#line 2814 "parser.yy"
                           { yyval = yyvsp[0]; }
#line 6453 "./out/parser.cc"
    break;

  case 365: /* context_mod: context_def_mod STRING  */
#line 2815 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6461 "./out/parser.cc"
    break;

  case 366: /* context_mod: context_def_mod SYMBOL  */
#line 2818 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6469 "./out/parser.cc"
    break;

  case 367: /* context_mod: context_def_mod embedded_scm  */
#line 2822 "parser.yy"
        {
		if (!scm_is_string (yyvsp[0])
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("consists"))
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("remove")))
		{
			yyval = SCM_EOL;
			parser->parser_error ((yylsp[-1]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
		}
	}
#line 6487 "./out/parser.cc"
    break;

  case 368: /* grob_prop_spec: symbol_list_rev  */
#line 2840 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_pair (l)
		    && to_boolean
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6505 "./out/parser.cc"
    break;

  case 369: /* grob_prop_path: grob_prop_spec  */
#line 2858 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[0]) && scm_is_null (scm_cddr (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			yyval = SCM_UNDEFINED;
		}
	}
#line 6517 "./out/parser.cc"
    break;

  case 370: /* grob_prop_path: grob_prop_spec property_path  */
#line 2866 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-1])) {
			yyval = scm_append_x (scm_list_2 (yyvsp[-1], yyvsp[0]));
			if (scm_is_null (scm_cddr (yyval))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				yyval = SCM_UNDEFINED;
			}
		}

	}
#line 6532 "./out/parser.cc"
    break;

  case 371: /* context_prop_spec: symbol_list_rev  */
#line 2881 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[0]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6550 "./out/parser.cc"
    break;

  case 372: /* simple_revert_context: symbol_list_part  */
#line 2913 "parser.yy"
        {
		yyvsp[0] = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_null (yyvsp[0])
		    || to_boolean
		    (scm_object_property (scm_car (yyvsp[0]),
					  ly_symbol2scm ("is-grob?")))) {
			yyval = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER, yyvsp[0]);
		} else {
			yyval = scm_car (yyvsp[0]);
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER,
							  scm_cdr (yyvsp[0]));
		}
	}
#line 6569 "./out/parser.cc"
    break;

  case 373: /* music_property_def: "\\override" grob_prop_path '=' scalar  */
#line 2930 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_override, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cdr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6583 "./out/parser.cc"
    break;

  case 374: /* music_property_def: "\\revert" simple_revert_context revert_arg  */
#line 2939 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (property_revert, (yyloc), yyvsp[-1], yyvsp[0]);
	}
#line 6591 "./out/parser.cc"
    break;

  case 375: /* music_property_def: "\\set" context_prop_spec '=' scalar  */
#line 2942 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_set, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cadr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6605 "./out/parser.cc"
    break;

  case 376: /* music_property_def: "\\unset" context_prop_spec  */
#line 2951 "parser.yy"
                                  {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_unset, (yyloc),
					  scm_car (yyvsp[0]),
					  scm_cadr (yyvsp[0]));
	}
#line 6618 "./out/parser.cc"
    break;

  case 383: /* text: embedded_scm_bare  */
#line 2972 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("markup expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6631 "./out/parser.cc"
    break;

  case 386: /* simple_string: embedded_scm_bare  */
#line 2985 "parser.yy"
        {
		if (scm_is_string (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("simple string expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6644 "./out/parser.cc"
    break;

  case 387: /* symbol: STRING  */
#line 2996 "parser.yy"
               {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6652 "./out/parser.cc"
    break;

  case 388: /* symbol: SYMBOL  */
#line 3000 "parser.yy"
        {
		if (!is_regular_identifier (yyvsp[0], false))
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6662 "./out/parser.cc"
    break;

  case 389: /* symbol: embedded_scm_bare  */
#line 3006 "parser.yy"
        {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		yyval = try_string_variants (Guile_user::symbol_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			yyval = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
#line 6679 "./out/parser.cc"
    break;

  case 394: /* scalar: '-' bare_number  */
#line 3033 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 6687 "./out/parser.cc"
    break;

  case 396: /* scalar: symbol_list_part_bare '.' property_path  */
#line 3038 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6695 "./out/parser.cc"
    break;

  case 397: /* scalar: symbol_list_part_bare ',' property_path  */
#line 3042 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6703 "./out/parser.cc"
    break;

  case 398: /* event_chord: simple_element post_events  */
#line 3048 "parser.yy"
                                   {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair (yyvsp[0])) {
			unsmob<Music> (yyval)->set_property ("articulations",
							 scm_reverse_x (yyvsp[0], SCM_EOL));
		}
	}
#line 6715 "./out/parser.cc"
    break;

  case 399: /* event_chord: CHORD_REPETITION optional_notemode_duration post_events  */
#line 3055 "parser.yy"
                                                                  {
		yyval = MAKE_SYNTAX (repetition_chord, (yyloc),
				  yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6724 "./out/parser.cc"
    break;

  case 400: /* event_chord: MULTI_MEASURE_REST optional_notemode_duration post_events  */
#line 3059 "parser.yy"
                                                                    {
		yyval = MAKE_SYNTAX (multi_measure_rest, (yyloc), yyvsp[-1],
				  scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6733 "./out/parser.cc"
    break;

  case 403: /* note_chord_element: chord_body optional_notemode_duration post_events  */
#line 3070 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[-2]);
		SCM dur = unsmob<Duration> (yyvsp[-1])->smobbed_copy ();
		SCM es = m->get_property ("elements");
		SCM postevs = scm_reverse_x (yyvsp[0], SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
		  unsmob<Music> (scm_car (s))->set_property ("duration", dur);
		es = ly_append2 (es, postevs);

		m->set_property ("elements", es);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = m->self_scm ();
	}
#line 6752 "./out/parser.cc"
    break;

  case 404: /* chord_body: "<" chord_body_elements ">"  */
#line 3088 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc),
				  reverse_music_list (parser, (yyloc),
						      yyvsp[-1], false, false));
	}
#line 6762 "./out/parser.cc"
    break;

  case 405: /* chord_body: FIGURE_OPEN figure_list FIGURE_CLOSE  */
#line 3094 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc), scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 6770 "./out/parser.cc"
    break;

  case 406: /* chord_body_elements: %empty  */
#line 3100 "parser.yy"
                                { yyval = SCM_EOL; }
#line 6776 "./out/parser.cc"
    break;

  case 407: /* chord_body_elements: chord_body_elements chord_body_element  */
#line 3101 "parser.yy"
                                                 {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6785 "./out/parser.cc"
    break;

  case 408: /* chord_body_element: pitch_or_tonic_pitch exclamations questions octave_check post_events  */
#line 3109 "parser.yy"
        {
		bool q = to_boolean (yyvsp[-2]);
		bool ex = to_boolean (yyvsp[-3]);
		SCM check = yyvsp[-1];
		SCM post = yyvsp[0];

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("pitch", yyvsp[-4]);
		if (q)
			n->set_property ("cautionary", SCM_BOOL_T);
                if (ex || q)
			n->set_property ("force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			n->set_property ("articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			n->set_property ("absolute-octave", scm_from_int (q-1));
		}

		yyval = n->unprotect ();
	}
#line 6815 "./out/parser.cc"
    break;

  case 409: /* chord_body_element: DRUM_PITCH post_events  */
#line 3134 "parser.yy"
                                           {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("drum-type", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0])) {
			SCM arts = scm_reverse_x (yyvsp[0], SCM_EOL);
			n->set_property ("articulations", arts);
		}
		yyval = n->unprotect ();
	}
#line 6830 "./out/parser.cc"
    break;

  case 410: /* chord_body_element: music_function_chord_body  */
#line 3145 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);

		if (m && !m->is_mus_type ("post-event")) {
			while (m && m->is_mus_type ("music-wrapper-music")) {
				yyval = m->get_property ("element");
				m = unsmob<Music> (yyval);
			}

			if (!(m && m->is_mus_type ("rhythmic-event"))) {
				parser->parser_error ((yyloc), _ ("not a rhythmic event"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6850 "./out/parser.cc"
    break;

  case 415: /* event_function_event: EVENT_FUNCTION function_arglist  */
#line 3170 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6859 "./out/parser.cc"
    break;

  case 416: /* post_events: %empty  */
#line 3177 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 6867 "./out/parser.cc"
    break;

  case 417: /* post_events: post_events post_event  */
#line 3180 "parser.yy"
                                 {
		yyval = yyvsp[-1];
		if (Music *m = unsmob<Music> (yyvsp[0]))
		{
			if (m->is_mus_type ("post-event-wrapper"))
			{
				for (SCM p = m->get_property ("elements");
				     scm_is_pair (p);
				     p = scm_cdr (p))
				{
					yyval = scm_cons (scm_car (p), yyval);
				}
			} else {
				m->set_spot (parser->lexer_->override_input ((yylsp[0])));
				yyval = scm_cons (yyvsp[0], yyval);
			}
		}
	}
#line 6890 "./out/parser.cc"
    break;

  case 418: /* post_event_nofinger: direction_less_event  */
#line 3201 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 6898 "./out/parser.cc"
    break;

  case 419: /* post_event_nofinger: script_dir music_function_call  */
#line 3204 "parser.yy"
                                         {
		Music *m = unsmob<Music> (yyvsp[0]);
		if (!m->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[0]), _ ("post-event expected"));
			yyval = SCM_UNSPECIFIED;
		} else {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
				m->set_property ("direction", yyvsp[-1]);
			yyval = yyvsp[0];
		}
	}
#line 6915 "./out/parser.cc"
    break;

  case 420: /* post_event_nofinger: "--"  */
#line 3216 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
#line 6925 "./out/parser.cc"
    break;

  case 421: /* post_event_nofinger: "__"  */
#line 3221 "parser.yy"
                   {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
#line 6935 "./out/parser.cc"
    break;

  case 422: /* post_event_nofinger: script_dir direction_reqd_event  */
#line 3226 "parser.yy"
                                          {
		if (Music *m = unsmob<Music> (yyvsp[0])) {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
			{
				m->set_property ("direction", yyvsp[-1]);
			}
		}
		yyval = yyvsp[0];
	}
#line 6950 "./out/parser.cc"
    break;

  case 423: /* post_event_nofinger: script_dir direction_less_event  */
#line 3236 "parser.yy"
                                          {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		if (!SCM_UNBNDP (yyvsp[-1]))
			m->set_property ("direction", yyvsp[-1]);
		yyval = yyvsp[0];
	}
#line 6962 "./out/parser.cc"
    break;

  case 424: /* post_event_nofinger: '^' fingering  */
#line 3244 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (UP));
		yyval = yyvsp[0];
	}
#line 6973 "./out/parser.cc"
    break;

  case 425: /* post_event_nofinger: '_' fingering  */
#line 3251 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (DOWN));
		yyval = yyvsp[0];
	}
#line 6984 "./out/parser.cc"
    break;

  case 427: /* post_event: '-' fingering  */
#line 3261 "parser.yy"
                        {
		unsmob<Music> (yyvsp[0])->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = yyvsp[0];
	}
#line 6993 "./out/parser.cc"
    break;

  case 428: /* string_number_event: E_UNSIGNED  */
#line 3268 "parser.yy"
                   {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		s->set_property ("string-number", yyvsp[0]);
		yyval = s->unprotect ();
	}
#line 7003 "./out/parser.cc"
    break;

  case 430: /* direction_less_event: EVENT_IDENTIFIER  */
#line 3277 "parser.yy"
                                {
		yyval = yyvsp[0];
	}
#line 7011 "./out/parser.cc"
    break;

  case 431: /* direction_less_event: tremolo_type  */
#line 3280 "parser.yy"
                        {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               a->set_property ("tremolo-type", yyvsp[0]);
               yyval = a->unprotect ();
        }
#line 7021 "./out/parser.cc"
    break;

  case 433: /* direction_reqd_event: gen_text_def  */
#line 3289 "parser.yy"
                     {
		yyval = yyvsp[0];
	}
#line 7029 "./out/parser.cc"
    break;

  case 434: /* direction_reqd_event: script_abbreviation  */
#line 3292 "parser.yy"
                              {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string (yyvsp[0]));
		if (scm_is_string (s)) {
			Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
			a->set_property ("articulation-type", s);
			yyval = a->unprotect ();
		} else {
			Music *original = unsmob<Music> (s);
			if (original && original->is_mus_type ("post-event")) {
				Music *a = original->clone ();
				// origin will be set by post_event_nofinger
				yyval = a->unprotect ();
			} else {
				parser->parser_error ((yylsp[0]), _ ("expecting string or post-event as script definition"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 7052 "./out/parser.cc"
    break;

  case 435: /* octave_check: %empty  */
#line 3313 "parser.yy"
             { yyval = SCM_EOL; }
#line 7058 "./out/parser.cc"
    break;

  case 436: /* octave_check: '=' quotes  */
#line 3314 "parser.yy"
                     { yyval = yyvsp[0]; }
#line 7064 "./out/parser.cc"
    break;

  case 437: /* quotes: %empty  */
#line 3319 "parser.yy"
        {
                yyval = SCM_INUM0;
	}
#line 7072 "./out/parser.cc"
    break;

  case 440: /* erroneous_quotes: quotes  */
#line 3328 "parser.yy"
               {
		if (scm_is_eq (SCM_INUM0, yyvsp[0]))
			yyval = SCM_UNDEFINED;
	}
#line 7081 "./out/parser.cc"
    break;

  case 441: /* sup_quotes: '\''  */
#line 3335 "parser.yy"
             {
		yyval = scm_from_int (1);
	}
#line 7089 "./out/parser.cc"
    break;

  case 442: /* sup_quotes: sup_quotes '\''  */
#line 3338 "parser.yy"
                          {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7097 "./out/parser.cc"
    break;

  case 443: /* sub_quotes: ','  */
#line 3344 "parser.yy"
            {
		yyval = scm_from_int (-1);
	}
#line 7105 "./out/parser.cc"
    break;

  case 444: /* sub_quotes: sub_quotes ','  */
#line 3347 "parser.yy"
                         {
		yyval = scm_oneminus (yyvsp[-1]);
	}
#line 7113 "./out/parser.cc"
    break;

  case 445: /* steno_pitch: NOTENAME_PITCH quotes  */
#line 3353 "parser.yy"
                              {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7126 "./out/parser.cc"
    break;

  case 446: /* steno_tonic_pitch: TONICNAME_PITCH quotes  */
#line 3368 "parser.yy"
                               {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7139 "./out/parser.cc"
    break;

  case 448: /* pitch: PITCH_IDENTIFIER quotes  */
#line 3380 "parser.yy"
                                  {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7152 "./out/parser.cc"
    break;

  case 451: /* gen_text_def: full_markup  */
#line 3396 "parser.yy"
                    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7162 "./out/parser.cc"
    break;

  case 452: /* gen_text_def: STRING  */
#line 3401 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 7173 "./out/parser.cc"
    break;

  case 453: /* gen_text_def: SYMBOL  */
#line 3407 "parser.yy"
                 {
		// Flag a warning? could be unintentional
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 7185 "./out/parser.cc"
    break;

  case 454: /* gen_text_def: embedded_scm  */
#line 3415 "parser.yy"
        {
		// Could be using this for every gen_text_def but for speed
		yyval = MAKE_SYNTAX (create_script, (yylsp[0]), yyvsp[0]);
	}
#line 7194 "./out/parser.cc"
    break;

  case 455: /* fingering: UNSIGNED  */
#line 3422 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		t->set_property ("digit", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7204 "./out/parser.cc"
    break;

  case 456: /* script_abbreviation: '^'  */
#line 3430 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Hat");
	}
#line 7212 "./out/parser.cc"
    break;

  case 457: /* script_abbreviation: '+'  */
#line 3433 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Plus");
	}
#line 7220 "./out/parser.cc"
    break;

  case 458: /* script_abbreviation: '-'  */
#line 3436 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dash");
	}
#line 7228 "./out/parser.cc"
    break;

  case 459: /* script_abbreviation: '!'  */
#line 3439 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Bang");
	}
#line 7236 "./out/parser.cc"
    break;

  case 460: /* script_abbreviation: ">"  */
#line 3442 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Larger");
	}
#line 7244 "./out/parser.cc"
    break;

  case 461: /* script_abbreviation: '.'  */
#line 3445 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dot");
	}
#line 7252 "./out/parser.cc"
    break;

  case 462: /* script_abbreviation: '_'  */
#line 3448 "parser.yy"
              {
		yyval = scm_from_ascii_string ("Underscore");
	}
#line 7260 "./out/parser.cc"
    break;

  case 463: /* script_dir: '_'  */
#line 3454 "parser.yy"
                { yyval = scm_from_int (DOWN); }
#line 7266 "./out/parser.cc"
    break;

  case 464: /* script_dir: '^'  */
#line 3455 "parser.yy"
                { yyval = scm_from_int (UP); }
#line 7272 "./out/parser.cc"
    break;

  case 465: /* script_dir: '-'  */
#line 3456 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7278 "./out/parser.cc"
    break;

  case 466: /* maybe_notemode_duration: %empty  */
#line 3460 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7286 "./out/parser.cc"
    break;

  case 467: /* maybe_notemode_duration: multiplied_duration  */
#line 3463 "parser.yy"
                                {
		yyval = yyvsp[0];
		parser->default_duration_ = *unsmob<Duration> (yyval);
	}
#line 7295 "./out/parser.cc"
    break;

  case 468: /* optional_notemode_duration: maybe_notemode_duration  */
#line 3472 "parser.yy"
        {
		if (SCM_UNBNDP (yyval))
			yyval = parser->default_duration_.smobbed_copy ();
	}
#line 7304 "./out/parser.cc"
    break;

  case 469: /* steno_duration: UNSIGNED dots  */
#line 3479 "parser.yy"
                                {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[-1]), _ ("not a duration"));
			yyval = Duration ().smobbed_copy ();
		}
	}
#line 7317 "./out/parser.cc"
    break;

  case 470: /* steno_duration: DURATION_IDENTIFIER dots  */
#line 3487 "parser.yy"
                                        {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
	}
#line 7325 "./out/parser.cc"
    break;

  case 471: /* multiplied_duration: steno_duration multipliers  */
#line 3493 "parser.yy"
                                   {
		yyval = make_duration (yyvsp[-1], 0, yyvsp[0]);
	}
#line 7333 "./out/parser.cc"
    break;

  case 472: /* dots: %empty  */
#line 3499 "parser.yy"
                        {
		yyval = SCM_INUM0;
	}
#line 7341 "./out/parser.cc"
    break;

  case 473: /* dots: dots '.'  */
#line 3502 "parser.yy"
                   {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7349 "./out/parser.cc"
    break;

  case 474: /* multipliers: %empty  */
#line 3509 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7357 "./out/parser.cc"
    break;

  case 475: /* multipliers: multipliers '*' UNSIGNED  */
#line 3513 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], yyvsp[0]);
		else
			yyval = yyvsp[0];
	}
#line 7368 "./out/parser.cc"
    break;

  case 476: /* multipliers: multipliers '*' FRACTION  */
#line 3520 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], scm_divide (scm_car (yyvsp[0]),
							  scm_cdr (yyvsp[0])));
		else
			yyval = scm_divide (scm_car (yyvsp[0]), scm_cdr (yyvsp[0]));
	}
#line 7380 "./out/parser.cc"
    break;

  case 477: /* tremolo_type: ':'  */
#line 3530 "parser.yy"
                {
		yyval = scm_from_int (parser->default_tremolo_type_);
	}
#line 7388 "./out/parser.cc"
    break;

  case 478: /* tremolo_type: ':' UNSIGNED  */
#line 3533 "parser.yy"
                       {
		if (SCM_UNBNDP (make_duration (yyvsp[0]))) {
			parser->parser_error ((yylsp[0]), _ ("not a duration"));
			yyval = scm_from_int (parser->default_tremolo_type_);
		} else {
			yyval = yyvsp[0];
			parser->default_tremolo_type_ = scm_to_int (yyvsp[0]);
		}
	}
#line 7402 "./out/parser.cc"
    break;

  case 483: /* bass_number: embedded_scm_bare  */
#line 3550 "parser.yy"
        {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer (yyvsp[0])
		    ? scm_is_true (scm_negative_p (yyvsp[0]))
		    : !Text_interface::is_markup (yyvsp[0]))
		{
			parser->parser_error ((yylsp[0]), _ ("bass number expected"));
			yyval = SCM_INUM0;
		}
	}
#line 7418 "./out/parser.cc"
    break;

  case 484: /* figured_bass_alteration: '-'  */
#line 3564 "parser.yy"
                { yyval = ly_rational2scm (FLAT_ALTERATION); }
#line 7424 "./out/parser.cc"
    break;

  case 485: /* figured_bass_alteration: '+'  */
#line 3565 "parser.yy"
                { yyval = ly_rational2scm (SHARP_ALTERATION); }
#line 7430 "./out/parser.cc"
    break;

  case 486: /* figured_bass_alteration: '!'  */
#line 3566 "parser.yy"
                { yyval = scm_from_int (0); }
#line 7436 "./out/parser.cc"
    break;

  case 487: /* bass_figure: "_"  */
#line 3570 "parser.yy"
                     {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->unprotect ();
	}
#line 7445 "./out/parser.cc"
    break;

  case 488: /* bass_figure: bass_number  */
#line 3574 "parser.yy"
                       {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->self_scm ();

		if (scm_is_number (yyvsp[0]))
			bfr->set_property ("figure", yyvsp[0]);
		else if (Text_interface::is_markup (yyvsp[0]))
			bfr->set_property ("text", yyvsp[0]);

		bfr->unprotect ();
	}
#line 7461 "./out/parser.cc"
    break;

  case 489: /* bass_figure: bass_figure ']'  */
#line 3585 "parser.yy"
                          {
		yyval = yyvsp[-1];
		unsmob<Music> (yyvsp[-1])->set_property ("bracket-stop", SCM_BOOL_T);
	}
#line 7470 "./out/parser.cc"
    break;

  case 490: /* bass_figure: bass_figure figured_bass_alteration  */
#line 3589 "parser.yy"
                                              {
		Music *m = unsmob<Music> (yyvsp[-1]);
		if (scm_to_double (yyvsp[0])) {
			SCM salter = m->get_property ("alteration");
			SCM alter = scm_is_number (salter) ? salter : scm_from_int (0);
			m->set_property ("alteration",
					 scm_sum (alter, yyvsp[0]));
		} else {
			m->set_property ("alteration", scm_from_int (0));
		}
	}
#line 7486 "./out/parser.cc"
    break;

  case 491: /* bass_figure: bass_figure figured_bass_modification  */
#line 3600 "parser.yy"
                                                 {
		Music *m = unsmob<Music> (yyvsp[-1]);
		m->set_property (yyvsp[0], SCM_BOOL_T);
	}
#line 7495 "./out/parser.cc"
    break;

  case 492: /* figured_bass_modification: "\\+"  */
#line 3608 "parser.yy"
                        {
		yyval = ly_symbol2scm ("augmented");
	}
#line 7503 "./out/parser.cc"
    break;

  case 493: /* figured_bass_modification: "\\!"  */
#line 3611 "parser.yy"
                        {
		yyval = ly_symbol2scm ("no-continuation");
	}
#line 7511 "./out/parser.cc"
    break;

  case 494: /* figured_bass_modification: '/'  */
#line 3614 "parser.yy"
                        {
		yyval = ly_symbol2scm ("diminished");
	}
#line 7519 "./out/parser.cc"
    break;

  case 495: /* figured_bass_modification: "\\\\"  */
#line 3617 "parser.yy"
                      {
		yyval = ly_symbol2scm ("augmented-slash");
	}
#line 7527 "./out/parser.cc"
    break;

  case 496: /* br_bass_figure: bass_figure  */
#line 3623 "parser.yy"
                    {
		yyval = yyvsp[0];
	}
#line 7535 "./out/parser.cc"
    break;

  case 497: /* br_bass_figure: '[' bass_figure  */
#line 3626 "parser.yy"
                          {
		yyval = yyvsp[0];
		unsmob<Music> (yyval)->set_property ("bracket-start", SCM_BOOL_T);
	}
#line 7544 "./out/parser.cc"
    break;

  case 498: /* figure_list: %empty  */
#line 3633 "parser.yy"
                        {
		yyval = SCM_EOL;
	}
#line 7552 "./out/parser.cc"
    break;

  case 499: /* figure_list: figure_list br_bass_figure  */
#line 3636 "parser.yy"
                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7560 "./out/parser.cc"
    break;

  case 500: /* optional_rest: %empty  */
#line 3642 "parser.yy"
               { yyval = SCM_BOOL_F; }
#line 7566 "./out/parser.cc"
    break;

  case 501: /* optional_rest: "\\rest"  */
#line 3643 "parser.yy"
               { yyval = SCM_BOOL_T; }
#line 7572 "./out/parser.cc"
    break;

  case 502: /* pitch_or_music: pitch exclamations questions octave_check maybe_notemode_duration erroneous_quotes optional_rest post_events  */
#line 3651 "parser.yy"
                                                                                                                     {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[-7]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP (yyvsp[-2]))
		{
			// It's possible to get here without a
			// duration, like when there is no
			// octave_check but a question mark.  But we
			// point out the most frequent error of an
			// interspersed duration specifically
			if (!SCM_UNBNDP (yyvsp[-3]))
				parser->parser_error ((yylsp[-2]), _ ("octave marks must precede duration"));
			else
				parser->parser_error ((yylsp[-2]), _ ("badly placed octave marks"));
			// Try sorting the quotes to where they likely belong
			if (scm_is_number (yyvsp[-4])) {
				yyvsp[-4] = scm_sum (yyvsp[-4], yyvsp[-2]);
			} else {
				yyvsp[-7] = unsmob<Pitch> (yyvsp[-7])->transposed
					(Pitch (scm_to_int (yyvsp[-2]), 0)).smobbed_copy ();
			}
		}

		if (!SCM_UNBNDP (yyvsp[-6])
                    || !SCM_UNBNDP (yyvsp[-5])
                    || scm_is_number (yyvsp[-4])
                    || !SCM_UNBNDP (yyvsp[-3])
		    || scm_is_true (yyvsp[-1])
		    || scm_is_pair (yyvsp[0]))
		{
			Music *n = 0;
			if (scm_is_true (yyvsp[-1]))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			n->set_property ("pitch", yyvsp[-7]);
			if (SCM_UNBNDP (yyvsp[-3]))
				n->set_property ("duration",
						 parser->default_duration_.smobbed_copy ());
			else
				n->set_property ("duration", yyvsp[-3]);

			if (scm_is_number (yyvsp[-4]))
			{
				int q = scm_to_int (yyvsp[-4]);
				n->set_property ("absolute-octave", scm_from_int (q-1));
			}

			if (to_boolean (yyvsp[-5]))
				n->set_property ("cautionary", SCM_BOOL_T);
			if (to_boolean (yyvsp[-6]) || to_boolean (yyvsp[-5]))
				n->set_property ("force-accidental", SCM_BOOL_T);
			if (scm_is_pair (yyvsp[0]))
				n->set_property ("articulations",
						 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 7636 "./out/parser.cc"
    break;

  case 503: /* pitch_or_music: new_chord post_events  */
#line 3710 "parser.yy"
                                {
		if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[-1]), _ ("have to be in Chord mode for chords"));
		if (scm_is_pair (yyvsp[0])) {
			if (unsmob<Pitch> (yyvsp[-1]))
				yyvsp[-1] = make_chord_elements ((yylsp[-1]),
							  yyvsp[-1],
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));

			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), elts);
		} else if (!unsmob<Pitch> (yyvsp[-1]))
			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), yyvsp[-1]);
		// A mere pitch drops through.
	}
#line 7658 "./out/parser.cc"
    break;

  case 504: /* simple_element: DRUM_PITCH optional_notemode_duration  */
#line 3730 "parser.yy"
                                              {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("duration", yyvsp[0]);
		n->set_property ("drum-type", yyvsp[-1]);

		yyval = n->unprotect ();
	}
#line 7670 "./out/parser.cc"
    break;

  case 505: /* simple_element: RESTNAME optional_notemode_duration  */
#line 3737 "parser.yy"
                                                        {
		Music *ev = 0;
 		if (ly_scm2string (yyvsp[-1]) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		ev->set_property ("duration", yyvsp[0]);
 		yyval = ev->unprotect ();
	}
#line 7688 "./out/parser.cc"
    break;

  case 506: /* lyric_element: full_markup  */
#line 3753 "parser.yy"
                    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("markup outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7698 "./out/parser.cc"
    break;

  case 507: /* lyric_element: SYMBOL  */
#line 3758 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _f ("not a note name: %s", ly_scm2string (yyvsp[0])));
		yyval = yyvsp[0];
	}
#line 7708 "./out/parser.cc"
    break;

  case 508: /* lyric_element: STRING  */
#line 3763 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("string outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7718 "./out/parser.cc"
    break;

  case 510: /* lyric_element_music: lyric_element optional_notemode_duration post_events  */
#line 3772 "parser.yy"
                                                             {
		yyval = MAKE_SYNTAX (lyric_event, (yyloc), yyvsp[-2], yyvsp[-1]);
		if (scm_is_pair (yyvsp[0]))
			unsmob<Music> (yyval)->set_property
				("articulations", scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 7729 "./out/parser.cc"
    break;

  case 511: /* new_chord: steno_tonic_pitch maybe_notemode_duration  */
#line 3782 "parser.yy"
                                                    {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = yyvsp[-1];
		else
			yyval = make_chord_elements ((yyloc), yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 7740 "./out/parser.cc"
    break;

  case 512: /* new_chord: steno_tonic_pitch optional_notemode_duration chord_separator chord_items  */
#line 3788 "parser.yy"
                                                                                   {
		SCM its = scm_reverse_x (yyvsp[0], SCM_EOL);
		yyval = make_chord_elements ((yyloc), yyvsp[-3], yyvsp[-2], scm_cons (yyvsp[-1], its));
	}
#line 7749 "./out/parser.cc"
    break;

  case 513: /* chord_items: %empty  */
#line 3795 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 7757 "./out/parser.cc"
    break;

  case 514: /* chord_items: chord_items chord_item  */
#line 3798 "parser.yy"
                                 {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7765 "./out/parser.cc"
    break;

  case 515: /* chord_separator: ":"  */
#line 3804 "parser.yy"
                    {
		yyval = ly_symbol2scm ("chord-colon");
	}
#line 7773 "./out/parser.cc"
    break;

  case 516: /* chord_separator: "^"  */
#line 3807 "parser.yy"
                      {
		yyval = ly_symbol2scm ("chord-caret");
	}
#line 7781 "./out/parser.cc"
    break;

  case 517: /* chord_separator: "/" steno_tonic_pitch  */
#line 3810 "parser.yy"
                                        {
 		yyval = scm_list_2 (ly_symbol2scm ("chord-slash"), yyvsp[0]);
	}
#line 7789 "./out/parser.cc"
    break;

  case 518: /* chord_separator: "/+" steno_tonic_pitch  */
#line 3813 "parser.yy"
                                       {
		yyval = scm_list_2 (ly_symbol2scm ("chord-bass"), yyvsp[0]);
	}
#line 7797 "./out/parser.cc"
    break;

  case 519: /* chord_item: chord_separator  */
#line 3819 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7805 "./out/parser.cc"
    break;

  case 520: /* chord_item: step_numbers  */
#line 3822 "parser.yy"
                       {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 7813 "./out/parser.cc"
    break;

  case 521: /* chord_item: CHORD_MODIFIER  */
#line 3825 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 7821 "./out/parser.cc"
    break;

  case 522: /* step_numbers: step_number  */
#line 3831 "parser.yy"
                    { yyval = scm_cons (yyvsp[0], SCM_EOL); }
#line 7827 "./out/parser.cc"
    break;

  case 523: /* step_numbers: step_numbers '.' step_number  */
#line 3832 "parser.yy"
                                       {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7835 "./out/parser.cc"
    break;

  case 524: /* step_number: UNSIGNED  */
#line 3838 "parser.yy"
                 {
		yyval = make_chord_step (yyvsp[0], 0);
        }
#line 7843 "./out/parser.cc"
    break;

  case 525: /* step_number: UNSIGNED '+'  */
#line 3841 "parser.yy"
                       {
		yyval = make_chord_step (yyvsp[-1], SHARP_ALTERATION);
	}
#line 7851 "./out/parser.cc"
    break;

  case 526: /* step_number: UNSIGNED "-"  */
#line 3844 "parser.yy"
                               {
		yyval = make_chord_step (yyvsp[-1], FLAT_ALTERATION);
	}
#line 7859 "./out/parser.cc"
    break;

  case 527: /* tempo_range: unsigned_number  */
#line 3850 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7867 "./out/parser.cc"
    break;

  case 528: /* tempo_range: unsigned_number '-' unsigned_number  */
#line 3853 "parser.yy"
                                              {
		yyval = scm_cons (yyvsp[-2], yyvsp[0]);
	}
#line 7875 "./out/parser.cc"
    break;

  case 529: /* number_expression: number_expression '+' number_term  */
#line 3865 "parser.yy"
                                          {
		yyval = scm_sum (yyvsp[-2], yyvsp[0]);
	}
#line 7883 "./out/parser.cc"
    break;

  case 530: /* number_expression: number_expression '-' number_term  */
#line 3868 "parser.yy"
                                            {
		yyval = scm_difference (yyvsp[-2], yyvsp[0]);
	}
#line 7891 "./out/parser.cc"
    break;

  case 532: /* number_term: number_factor  */
#line 3875 "parser.yy"
                      {
		yyval = yyvsp[0];
	}
#line 7899 "./out/parser.cc"
    break;

  case 533: /* number_term: number_factor '*' number_factor  */
#line 3878 "parser.yy"
                                          {
		yyval = scm_product (yyvsp[-2], yyvsp[0]);
	}
#line 7907 "./out/parser.cc"
    break;

  case 534: /* number_term: number_factor '/' number_factor  */
#line 3881 "parser.yy"
                                          {
		yyval = scm_divide (yyvsp[-2], yyvsp[0]);
	}
#line 7915 "./out/parser.cc"
    break;

  case 535: /* number_factor: '-' number_factor  */
#line 3887 "parser.yy"
                           { /* %prec UNARY_MINUS */
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 7923 "./out/parser.cc"
    break;

  case 539: /* bare_number_common: REAL NUMBER_IDENTIFIER  */
#line 3897 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7931 "./out/parser.cc"
    break;

  case 542: /* bare_number: UNSIGNED NUMBER_IDENTIFIER  */
#line 3905 "parser.yy"
                                        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7939 "./out/parser.cc"
    break;

  case 544: /* unsigned_number: NUMBER_IDENTIFIER  */
#line 3913 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7952 "./out/parser.cc"
    break;

  case 545: /* unsigned_number: embedded_scm  */
#line 3922 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7965 "./out/parser.cc"
    break;

  case 546: /* exclamations: %empty  */
#line 3933 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7971 "./out/parser.cc"
    break;

  case 547: /* exclamations: exclamations '!'  */
#line 3935 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7982 "./out/parser.cc"
    break;

  case 548: /* questions: %empty  */
#line 3950 "parser.yy"
        { yyval = SCM_UNDEFINED; }
#line 7988 "./out/parser.cc"
    break;

  case 549: /* questions: questions '?'  */
#line 3952 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7999 "./out/parser.cc"
    break;

  case 550: /* $@10: %empty  */
#line 3962 "parser.yy"
                { parser->lexer_->push_markup_state (); }
#line 8005 "./out/parser.cc"
    break;

  case 551: /* full_markup_list: "\\markuplist" $@10 markup_list  */
#line 3963 "parser.yy"
                    {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8014 "./out/parser.cc"
    break;

  case 552: /* markup_mode: "\\markup"  */
#line 3971 "parser.yy"
        {
		parser->lexer_->push_markup_state ();
	}
#line 8022 "./out/parser.cc"
    break;

  case 553: /* markup_mode_word: markup_mode markup_word  */
#line 3987 "parser.yy"
        {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8031 "./out/parser.cc"
    break;

  case 554: /* full_markup: markup_mode markup_top  */
#line 3995 "parser.yy"
                               {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8040 "./out/parser.cc"
    break;

  case 555: /* full_markup: markup_mode_word  */
#line 4000 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8048 "./out/parser.cc"
    break;

  case 556: /* partial_markup: markup_mode markup_partial_function "\\etc"  */
#line 4007 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_markup, (yylsp[-1]), yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8057 "./out/parser.cc"
    break;

  case 557: /* markup_top: markup_list  */
#line 4014 "parser.yy"
                    {
		yyval = scm_list_2 (Lily::line_markup,  yyvsp[0]);
	}
#line 8065 "./out/parser.cc"
    break;

  case 558: /* markup_top: markup_head_1_list simple_markup  */
#line 4018 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8074 "./out/parser.cc"
    break;

  case 559: /* markup_top: simple_markup_noword  */
#line 4022 "parser.yy"
                               {
		yyval = yyvsp[0];
	}
#line 8082 "./out/parser.cc"
    break;

  case 560: /* $@11: %empty  */
#line 4029 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (MARKUP_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else if (Text_interface::is_markup_list (yyvsp[0]))
			MYBACKUP (MARKUPLIST_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else {
			parser->parser_error ((yylsp[0]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[0]));
		}
	}
#line 8097 "./out/parser.cc"
    break;

  case 562: /* markup_list: markup_composed_list  */
#line 4043 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 8105 "./out/parser.cc"
    break;

  case 564: /* markup_uncomposed_list: markup_braced_list  */
#line 4050 "parser.yy"
                           {
		yyval = yyvsp[0];
	}
#line 8113 "./out/parser.cc"
    break;

  case 565: /* markup_uncomposed_list: markup_command_list  */
#line 4053 "parser.yy"
                              {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8121 "./out/parser.cc"
    break;

  case 566: /* markup_uncomposed_list: markup_scm MARKUPLIST_IDENTIFIER  */
#line 4057 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8129 "./out/parser.cc"
    break;

  case 567: /* $@12: %empty  */
#line 4060 "parser.yy"
                     {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8137 "./out/parser.cc"
    break;

  case 568: /* markup_uncomposed_list: "\\score-lines" $@12 '{' score_body '}'  */
#line 4062 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_1 (scm_list_2 (Lily::score_lines_markup_list, yyvsp[-1]));
		parser->lexer_->pop_state ();
	}
#line 8153 "./out/parser.cc"
    break;

  case 569: /* markup_composed_list: markup_head_1_list markup_uncomposed_list  */
#line 4076 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (composed_markup_list,
				  (yylsp[0]), yyvsp[-1], yyvsp[0]);
	}
#line 8162 "./out/parser.cc"
    break;

  case 570: /* markup_braced_list: '{' markup_braced_list_body '}'  */
#line 4083 "parser.yy"
                                        {
		yyval = scm_reverse_x (yyvsp[-1], SCM_EOL);
	}
#line 8170 "./out/parser.cc"
    break;

  case 571: /* markup_braced_list_body: %empty  */
#line 4089 "parser.yy"
                        {  yyval = SCM_EOL; }
#line 8176 "./out/parser.cc"
    break;

  case 572: /* markup_braced_list_body: markup_braced_list_body markup  */
#line 4090 "parser.yy"
                                         {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8184 "./out/parser.cc"
    break;

  case 573: /* markup_braced_list_body: markup_braced_list_body markup_list  */
#line 4093 "parser.yy"
                                              {
		yyval = scm_reverse_x (yyvsp[0], yyvsp[-1]);
	}
#line 8192 "./out/parser.cc"
    break;

  case 574: /* markup_command_list: MARKUP_LIST_FUNCTION markup_command_list_arguments  */
#line 4099 "parser.yy"
                                                           {
	  yyval = scm_cons (yyvsp[-1], scm_reverse_x(yyvsp[0], SCM_EOL));
	}
#line 8200 "./out/parser.cc"
    break;

  case 575: /* markup_command_basic_arguments: "markup-list?" markup_command_list_arguments markup_list  */
#line 4105 "parser.yy"
                                                                     {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8208 "./out/parser.cc"
    break;

  case 576: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments embedded_scm  */
#line 4108 "parser.yy"
                                                                {
	  yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8216 "./out/parser.cc"
    break;

  case 577: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments STRING  */
#line 4111 "parser.yy"
                                                          {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8224 "./out/parser.cc"
    break;

  case 578: /* markup_command_basic_arguments: EXPECT_NO_MORE_ARGS  */
#line 4114 "parser.yy"
                              {
	  yyval = SCM_EOL;
	}
#line 8232 "./out/parser.cc"
    break;

  case 579: /* markup_command_list_arguments: markup_command_basic_arguments  */
#line 4120 "parser.yy"
                                       { yyval = yyvsp[0]; }
#line 8238 "./out/parser.cc"
    break;

  case 580: /* markup_command_list_arguments: "markup?" markup_command_list_arguments markup  */
#line 4121 "parser.yy"
                                                             {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8246 "./out/parser.cc"
    break;

  case 581: /* markup_partial_function: MARKUP_FUNCTION markup_arglist_partial  */
#line 4128 "parser.yy"
        {
		yyval = scm_list_1 (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 8254 "./out/parser.cc"
    break;

  case 582: /* markup_partial_function: markup_head_1_list MARKUP_FUNCTION markup_arglist_partial  */
#line 4132 "parser.yy"
        {
		yyval = scm_cons (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)),
			       yyvsp[-2]);
	}
#line 8263 "./out/parser.cc"
    break;

  case 583: /* markup_arglist_partial: "markup?" markup_arglist_partial  */
#line 4140 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8271 "./out/parser.cc"
    break;

  case 584: /* markup_arglist_partial: "scheme?" markup_arglist_partial  */
#line 4144 "parser.yy"
        {
		yyval= yyvsp[0];
	}
#line 8279 "./out/parser.cc"
    break;

  case 585: /* markup_arglist_partial: "markup?" markup_command_list_arguments  */
#line 4148 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8287 "./out/parser.cc"
    break;

  case 586: /* markup_arglist_partial: "scheme?" markup_command_list_arguments  */
#line 4152 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8295 "./out/parser.cc"
    break;

  case 587: /* markup_head_1_item: MARKUP_FUNCTION "markup?" markup_command_list_arguments  */
#line 4158 "parser.yy"
                                                                    {
	  yyval = scm_cons (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8303 "./out/parser.cc"
    break;

  case 588: /* markup_head_1_list: markup_head_1_item  */
#line 4164 "parser.yy"
                                {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8311 "./out/parser.cc"
    break;

  case 589: /* markup_head_1_list: markup_head_1_list markup_head_1_item  */
#line 4167 "parser.yy"
                                                {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8319 "./out/parser.cc"
    break;

  case 592: /* simple_markup: markup_word  */
#line 4179 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8327 "./out/parser.cc"
    break;

  case 594: /* $@13: %empty  */
#line 4186 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8335 "./out/parser.cc"
    break;

  case 595: /* simple_markup_noword: "\\score" $@13 '{' score_body '}'  */
#line 4188 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_2 (Lily::score_markup, yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8351 "./out/parser.cc"
    break;

  case 596: /* simple_markup_noword: MARKUP_FUNCTION markup_command_basic_arguments  */
#line 4199 "parser.yy"
                                                         {
		yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8359 "./out/parser.cc"
    break;

  case 597: /* simple_markup_noword: markup_scm MARKUP_IDENTIFIER  */
#line 4203 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8367 "./out/parser.cc"
    break;

  case 598: /* markup: markup_head_1_list simple_markup  */
#line 4210 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8376 "./out/parser.cc"
    break;

  case 599: /* markup: simple_markup  */
#line 4214 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 8384 "./out/parser.cc"
    break;


#line 8388 "./out/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= END_OF_FILE)
        {
          /* Return failure if at end of input.  */
          if (yychar == END_OF_FILE)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, retval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 4219 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
	return scm_c_with_fluid (Lily::f_parser,
				 self_scm (),
				 do_yyparse_trampoline,
				 static_cast <void *>(this));
}

SCM
Lily_parser::do_yyparse_trampoline (void *parser)
{
	SCM retval = SCM_UNDEFINED;
	yyparse (static_cast <Lily_parser *>(parser), &retval);
	return retval;
}



/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob<Book> (sid)) {
		Book *book =  unsmob<Book> (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
	} else if (unsmob<Context_def> (sid))
	{
		*destination = unsmob<Context_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
        } else if (unsmob<Context_mod> (sid)) {
                *destination = unsmob<Context_mod> (sid)->smobbed_copy ();
                return SCM_IDENTIFIER;
	} else if (Music *mus = unsmob<Music> (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob<Pitch> (sid)) {
		*destination = unsmob<Pitch> (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob<Duration> (sid)) {
		*destination = unsmob<Duration> (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob<Output_def> (sid)) {
		*destination = unsmob<Output_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (unsmob<Score> (sid)) {
		*destination = unsmob<Score> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (scm_is_pair (sid)
		   && scm_is_pair (scm_car (sid))
		   && scm_is_true (Lily::key_p (scm_caar (sid)))) {
		*destination = sid;
		return LOOKUP_IDENTIFIER;
	}
	return -1;
}

SCM
get_next_unique_context_id ()
{
	return scm_from_ascii_string ("$uniqueContextId");
}


SCM
get_next_unique_lyrics_context_id ()
{
	static int new_context_count;
	char s[128];
	snprintf (s, sizeof (s)-1, "uniqueContext%d", new_context_count++);
	return scm_from_ascii_string (s);
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX (argument_error, loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg)
{
	if (Music *m = unsmob<Music> (arg))
	{
		m = m->clone ();
		m->set_spot (parser->lexer_->override_input (loc));
		return m->unprotect ();
	}
	if (Book *b = unsmob<Book> (arg))
	{
		b = b->clone ();
		b->origin ()->set_spot (parser->lexer_->override_input (loc));
		return b->unprotect ();
	}
	if (Context_def *cd = unsmob<Context_def> (arg))
	{
		cd = cd->clone ();
		cd->origin ()->set_spot (parser->lexer_->override_input (loc));
		return cd->unprotect ();
	}
	if (Output_def *od = unsmob<Output_def> (arg))
	{
		od = od->clone ();
		od->input_origin_ = parser->lexer_->override_input (loc);
		return od->unprotect ();
	}
	if (Score *s = unsmob<Score> (arg))
	{
		s = s->clone ();
		s->origin ()->set_spot (parser->lexer_->override_input (loc));
		return s->unprotect ();
	}
	if (Context_mod *cm = unsmob<Context_mod> (arg))
	{
		return cm->smobbed_copy ();
	}
	return arg;
}

SCM
make_reverse_key_list (SCM keys)
{
	if (scm_is_true (Lily::key_p (keys)))
		return scm_list_1 (keys);
	if (scm_is_string (keys))
		return scm_list_1 (scm_string_to_symbol (keys));
	if (!ly_is_list (keys))
		return SCM_UNDEFINED;
	SCM res = SCM_EOL;
	for (; scm_is_pair (keys); keys = scm_cdr (keys))
	{
		SCM elt = scm_car (keys);
		if (scm_is_true (Lily::key_p (elt)))
			res = scm_cons (elt, res);
		else if (scm_is_string (elt))
			res = scm_cons (scm_string_to_symbol (elt), res);
		else return SCM_UNDEFINED;
	}
	return res;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a key may be interpreted as a list of keys if it helps
	if (scm_is_true (Lily::key_p (str))) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	if (!scm_is_string (str))
		return SCM_UNDEFINED;

	// Let's attempt the symbol list interpretation first.

	str = scm_string_to_symbol (str);

	SCM lst = scm_list_1 (str);

	if (scm_is_true (scm_call_1 (pred, lst)))
		return lst;

	// Try the single symbol interpretation

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	return SCM_UNDEFINED;
}

SCM
try_word_variants (SCM pred, SCM str)
{
	// str is always a string when we come here

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_split (scm_car (p),
						    SCM_MAKE_CHAR (',')));
	str = scm_append_x (str);
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_to_symbol (scm_car (p)));

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple &&
						       (c == '.' || c == ','))))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob<Music> (simple))
		return simple;

	if (scm_is_symbol (simple))
	{
		SCM out = SCM_UNDEFINED;
		switch (parser->lexer_->scan_word (out, simple))
		{
		case DRUM_PITCH:
		{
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("drum-type", out);
			return n->unprotect ();
		}
		case NOTENAME_PITCH:
		case TONICNAME_PITCH:
			// Take the parsed pitch
			simple = out;
			break;
		// Don't scan CHORD_MODIFIER etc.
		}
	}

	if (parser->lexer_->is_note_state ()) {
		if (unsmob<Pitch> (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("pitch", simple);
			return n->unprotect ();
		}
		SCM d = simple;
		if (scm_is_integer (simple))
			d = make_duration (simple);
		if (unsmob<Duration> (d)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", d);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX (lyric_event, loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob<Pitch> (simple))
			return MAKE_SYNTAX
				(event_chord,
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots, SCM factor)
{
	Duration k;

	if (Duration *dur = unsmob<Duration> (d)) {
		if (!dots && SCM_UNBNDP (factor))
			return d;
		k = *dur;
		if (dots)
			k = Duration (k.duration_log (), k.dot_count () + dots)
				.compressed (k.factor ());
	} else {
		int t = scm_to_int (d);
		if (t > 0 && (t & (t-1)) == 0)
			k = Duration (intlog2 (t), dots);
		else
			return SCM_UNDEFINED;
	}

	if (!SCM_UNBNDP (factor))
		k = k.compressed (ly_scm2rational (factor));

	return k.smobbed_copy ();
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
	Pitch m (0, scm_to_int (step_scm) - 1, alter);

	// Notename/octave are normalized
	if (m.get_notename () == 6)
		m = m.transposed (Pitch (0, 0, FLAT_ALTERATION));

	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM res = Lily::construct_chord_elements (pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob<Music> (scm_car (s))->set_spot (loc);
	}
	return res;
}

// Return true if there are post events unaccounted for
bool
add_post_events (Music *m, SCM events)
{
	if (!scm_is_pair (events))
		return false;	// successfully added -- nothing

	while (m) {
		if (m->is_mus_type ("rhythmic-event")) {
			m->set_property
				("articulations",
				 scm_append_x (scm_list_2
					       (m->get_property ("articulations"),
						events)));
			return false;
		}
		if (m->is_mus_type ("event-chord")) {
			m->set_property
				("elements",
				 scm_append_x (scm_list_2
					       (m->get_property ("elements"),
						events)));
			return false;
		}
		if (m->is_mus_type ("sequential-music")) {
			SCM lp = scm_last_pair (m->get_property ("elements"));
			if (scm_is_pair (lp)) {
				m = unsmob<Music> (scm_car (lp));
				continue;
			}
			return true;
		}
		if (m->is_mus_type ("music-wrapper-music")
		    || m->is_mus_type ("time-scaled-music")) {
			m = unsmob<Music> (m->get_property ("element"));
			continue;
		}
		break;
	}
	return true;
}

// Returns either a list or a post-event
//
// If PRESERVE is true, unattachable post-events are not thrown away
// but rather added attached to empty chords.  If COMPRESS is true, a
// sequence consisting only of post-events may be returned as a single
// post-event.
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress)
{
	SCM res = SCM_EOL;	// Resulting reversed list
	SCM bad = SCM_EOL;	// Bad post events
	SCM post = SCM_EOL;	// current unattached events
	for (; scm_is_pair (lst); lst = scm_cdr (lst)) {
		SCM elt = scm_car (lst);
		Music *m = unsmob<Music> (elt);
		assert (m);
		if (m->is_mus_type ("post-event")) {
			post = scm_cons (elt, post);
			continue;
		}
		if (add_post_events (m, post)) {
			bad = scm_cons (scm_car (post), bad);
			if (preserve) {
				Music *p = unsmob<Music> (scm_car (post));
				res = scm_cons (MAKE_SYNTAX (event_chord,
							     *p->origin (),
							     post),
						res);
			}
		}
		post = SCM_EOL;
		res = scm_cons (elt, res);
	}
	if (scm_is_pair (post)) {
		if (scm_is_null (res) && compress) { // pure postevent list
			if (scm_is_null (scm_cdr (post)))
				return scm_car (post);
			Music *m = MY_MAKE_MUSIC ("PostEvents", loc);
			m->set_property ("elements", post);
			return m->unprotect ();
		}
		bad = ly_append2 (post, bad);
		if (preserve) {
			Music *p = unsmob<Music> (scm_car (post));
			res = scm_cons (MAKE_SYNTAX (event_chord,
						     *p->origin (),
						     post),
					res);
		}
	}
	for (; scm_is_pair (bad); bad = scm_cdr (bad))
	{
		Music *what = unsmob<Music> (scm_car (bad));
		if (preserve)
			what->origin ()->warning (_f ("Unattached %s",
						      what->name ()));
		else
			what->origin ()->warning (_f ("Dropping unattachable %s",
						      what->name ()));
	}
	return res;
}


int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	int tok = lex->pop_extra_token ();
	if (tok >= 0)
		return tok;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
